<?php
/**
 * stanislav.elbl, 09.05.2016
 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;

return [
    'caption' => 'nastaveni_monitorovani',
    'category' => 'nastaveni_sekce_dochazka',
    'name'  => 'monitorovani',
    'index' => 230,
    'storage' => 'nastaveni',
    'strings' => 'preferences_dochazka.ini',

    'items' =>
        [
            [
                'name'  => 'monitorovanibezprihlaseni',    'type'  => Preference::CHECKBOX,    'title' => 'povolit_monitorovani_bez_prihlaseni',
                'defaultValue' => 0,
                'infoText' => 'povolit_monitorovani_bez_prihlaseni_info'
            ],
            [
                'name'  => 'monitorovani_jennejvyssirozdeleni',    'type'  => Preference::CHECKBOX,    'title' => 'monitorovani_jen_nejvyssi_rozdeleni',
                'defaultValue' => 0
            ],
            [
                'name'  => 'monitorovani_skryt_ext',    'type'  => Preference::CHECKBOX,    'title' => 'nezobrazovat_externi_osoby',
                'defaultValue' => 0
            ],
            [
                'name'  => 'pouzitrychlemonitorovani',    'type'  => Preference::CHECKBOX,    'title' => 'pouzit_rychle_monitorovani',
                'defaultValue' => 0
            ],
            [
                'name'  => 'monitorovani_dnu',    'type'  => Preference::TEXT,        'title' => 'pocet_dnu_monitorovani_zpetne',
                'defaultValue' => ''
            ],
            [
                'name'  => 'triditmonitorovani',    'type'  => Preference::TEXT,        'title' => 'tridit_monitorovani_podle',
                'defaultValue' => ''
            ],
//            [
//                'name'  => 'typrozdelenieditace',         'type'  => Preference::SQL_COMBOBOX,    'title' => 'dochazka_typ_rozdeleni',
//                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni ORDER BY Kod'
//            ],
            [
                'name'  => 'RonPortal_monitorovani_nastaveni_xml',    'type'  => Preference::MEMO,        'title' => 'monitorovani_xml',
                'defaultValue' => '', 'storage' => 'sys_bvar_global',
                'infoText' => 'monitorovani_xml_info'
            ],
//            [
//                'name'  => 'sloupcemonitorovani',    'type'  => Preference::MEMO,        'title' => 'sloupce_monitorovani',
//                'defaultValue' => '', 'storage' => 'nastaveni',
//                'infoText' => 'sloupce_monitorovani_info'
//            ]

        ]
];
