<?php
/**
 * stanislav.elbl, 03.02.2021
 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;

if (isset($_POST['preferencesName'])  &&  $_POST['preferencesName'] == 'absence') {
    if (isset($_POST['pregenerovatklic'])) {

    }
}

//$absenceInitPreferences = [
return [
    'caption' => 'nastaveni_planovani_absenci',
    'category' => 'nastaveni_sekce_planovani',
    'name'  => 'absence1',
    'index' => 250,
    'storage' => 'nastaveni',
    'strings' => 'preferences_absence.ini',

    'items' =>
        [
            [
                'name'  => 'zakazatabsencepoukonceni', 'type'  => Preference::CHECKBOX,    'title' => 'absence_zakazat_planovat_po_ukonceni_pp',
                'defaultValue' => 0
            ],

            [
                'name'  => 'pocetdnuzpetneplanovani', 'type'  => Preference::TEXT,    'title' => 'absence_pocet_dnu_pro_zpetne_planovani',
                'defaultValue' => '',
                'infoText' => 'absence_pocet_dnu_pro_zpetne_planovani_info'
            ],

            // planovani absence pri schvalene dochazce
            [
                'name'  => 'povolitabsenceprischvalenidoch', 'type'  => Preference::COMBOBOX,    'title' => 'absence_povolit_planovat_pri_schvalene_dochazce',
                'options'   => ['0' => 'absence_pri_schvalene_zakazat', '1' => 'absence_pri_schvalene_1', '2' => 'absence_pri_schvalene_2', '3' => 'absence_pri_schvalene_3'],
                'defaultValue' => '0',
                'infoText' => 'absence_povolit_planovat_pri_schvalene_dochazce_info'
            ],
            // rozdeleni
            [
                'name'  => 'typrozdeleniabsence',   'type'  => Preference::SQL_COMBOBOX,    'title' => 'Typ_rozdeleni_absence',
                'defaultValue' => '',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 ORDER BY Kod',
                'infoText' => 'Typ_rozdeleni_absence_info'
            ],
            // zaokrouhlovanicasu
            [
                'name'  => 'zaokrouhleniabsence',   'type'  => Preference::TEXT,    'title' => 'absence_zaokrouhleni',
                'defaultValue' => '',
                'infoText' => 'absence_zaokrouhleni_info'
            ],


            // zobrazeni poznamek ke dni - nastaveni typu, ktere se zobrazi (oddeleno strednikem, * znamena vse)
            [
                'name'  => 'casovaslozkaabsence',  'type'  => Preference::TEXT,    'title' => 'absence_zobrazit_casove_slozky',
                'defaultValue' => ''
            ],

            // zobrazeni poznamek ke dni - nastaveni typu, ktere se zobrazi (oddeleno strednikem, * znamena vse)
            [
                'name'  => 'nadpisslozkaabsence',  'type'  => Preference::TEXT,    'title' => 'absence_nadpisy_casove_slozky',
                'defaultValue' => '',
                'infoText' => 'absence_zobrazit_casove_slozky_info'
            ],

            // zobrazeni poznamek ke dni - nastaveni typu, ktere se zobrazi (oddeleno strednikem, * znamena vse)
            [
                'name'  => 'absence_typpoznamky',  'type'  => Preference::TEXT,    'title' => 'absence_zobrazit_poznamky_ke_dni',
                'defaultValue' => '',
                'infoText' => 'absence_zobrazit_poznamky_ke_dni_info'
            ],

        ]
];

//// pozor! nepouzivat promennou $result!
//$absencePref = new Preferences();
//$absencePref ->init($absenceInitPreferences);
//return $absencePref;
