<?php
/**
 * Created by PhpStorm.
 * User: pavel.rudol
 * Date: 4.5.2016
 * Time: 15:56
 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;

return [
    'caption' => 'nastaveni_vyroba',
    'category' => 'nastaveni_sekce_vyroba',
    'name'  => 'vyroba',
    'index' => 600,
    'storage' => 'nastaveni',
    'strings' => 'vyroba.ini',

    'items' =>
        [
            // vychozí cinnost
            [
                'name'  => 'vyroba_vychozi_cinnost', 'type'  => Preference::SQL_COMBOBOX,    'title' => 'Vyroba_vychozi_cinnost',
                'sql'   => 'SELECT Kod, Popis FROM VyrobniCinnost WHERE Aktivni = 1 ORDER BY popis',  'infoText' => 'Vyroba_vychozi_cinnost_info',
                'defaultValue' => ''
            ],
            // vychozí zakazka
            [
                'name'  => 'vyroba_vychozi_zakazka', 'type'  => Preference::SQL_COMBOBOX,    'title' => 'Vyroba_vychozi_zakazka',
                'sql'   => 'SELECT cisloZakazky, Popis FROM VyrobniZakazka ORDER BY popis',
                'defaultValue' => ''
            ],
            // vychozí vyrobek
            [
                'name'  => 'vyroba_vychozi_vyrobek', 'type'  => Preference::SQL_COMBOBOX,    'title' => 'Vyroba_vychozi_vyrobek',
                'sql'   => 'SELECT Kod, Popis FROM Zbozi WHERE Neaktivni = 0 ORDER BY popis',
                'defaultValue' => ''
            ],

        ]
];