<?php
/**
 * stanislav.elbl, 27.10.2015
 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;
use RonPortal\Dokumenty\DokumentyUtils;

return [
    'caption' => 'nastaveni_zabezpeceni',
    'name'  => 'zabezpeceni',
    'index' => 110,
    'storage' => 'nastaveniSpolecne',
    'strings' => 'users.ini',

    'items' =>
        [
            // pocet minut pro automaticke odhlaseni
            [
                'name'  => 'logouttimer',   'type'  => Preference::TEXT,    'title' => 'Pocet_minut_logout',
                'infoText' => 'Pocet_minut_logout_info',
                'defaultValue' => ''
            ],

            // sekce (menuid) zabezpecene heslem
            [
                'name'  => 'protected_menuid',   'type'  => Preference::TEXT,    'title' => 'Sekce_zabezpecene_heslem',
                'infoText' => 'Sekce_zabezpecene_heslem_info',
                'defaultValue' => ''
            ],
            [
                'name'  => 'protected_timeout',  'type'  => Preference::TEXT,    'title' => 'Sekce_zabezpecene_heslem_platnost',
                'infoText' => 'Sekce_zabezpecene_heslem_platnost_info',
                'defaultValue' => ''
            ],

            // upload souboru ----------------------------
            [
                'type'  => Preference::CATEGORY,    'title' => 'Nastaveni_upload_souboru'

            ],
            [
                'name'  => 'upload_mime_types',   'type'  => Preference::TEXT,    'title' => 'Upload_povolene_mime_typy',
                'infoText' => 'Upload_povolene_mime_typy_info',
                'defaultValue' => DokumentyUtils::UPLOAD_MIME_TYPES
            ],
            [
                'name'  => 'upload_extensions',   'type'  => Preference::TEXT,    'title' => 'Upload_povolene_pripony',
                'infoText' => 'Upload_povolene_pripony_info',
                'defaultValue' => DokumentyUtils::UPLOAD_EXTENSIONS
            ],
        ],


];