<?php

namespace Ron\Exception;

use Ron\RonException;

class FileNotFoundException extends RonException
{
    public function __construct($message = null, $fieldName = null, $errorDescription = null, $code = 0, $previous = null)
    {
        parent::__construct($message ?? 'File not found!', $fieldName, $errorDescription, $code, $previous);
        $this ->responseCode = 404;
    }
}
