<?php
/**
 * stanislav.elbl, 08.09.2015
 */

namespace RonPortal\Dochazka;

use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;
use Ron\TextManager;

$action = Model::getInstance() ->getData('action');
$pp = Model::getInstance() ->getData('PP');
$prava = Model::getInstance() ->getData('prava');

?>

<h1><?= TextManager::_( ($action == 'odblokovani') ? 'Odblokovani_karty' : 'Blokovani_karty' ) ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<form method="post" action="?menuid=<?= $action ?>">
    <input type="hidden" name="akceblokovani" value="potvrzeniblokovani">
    <input type="hidden" name="karta" value="<?= StringUtils::htmlTextConvert($_POST['karta']) ?>">
    <input type="hidden" name="osoba" value="<?= (int)$_POST['osoba'] ?>">

    <div class="form form-100 middle-form">
        <div class="form-content">
            <div class="form-row">
                <div class="form-col form-col1 caption"><?= TextManager::_('Osoba') ?></div>
                <div class="form-col form-col2"><strong><?= $pp->jmenoPrijmeni ?></strong></div>
            </div>

            <div class="form-row">
                <div class="form-col form-col1 caption"><?= TextManager::_('Karta_cislo') ?></div>
                <div class="form-col form-col2"><strong><?= StringUtils::htmlTextConvert($_POST["karta"]) ?></strong></div>
            </div>

        <?php if ($prava->priznak) { // uzivatel musi zadat heslo ?>
            <div class="form-row">
                <div class="form-col form-col1 caption"><?= TextManager::_('Heslo') ?></div>
                <div class="form-col form-col2">
                    <input class="form-input" type="password" name="heslo">
                </div>
            </div>
        <?php } ?>
        </div>

        <div class="buttons">
            <input type="submit" class="submitbutton" value="<?= TextManager::_('Provest') ?>">
        </div>
    </div>
</form>
