<?php

namespace RonPortal\Hodnoceni;

use Ron\MessageManager;
use RonPortal\Testy\Dotaznik;
use RonPortal\Testy\DotaznikViewObject;


class PrevzitHodnoceniViewObject extends HodnoceniViewObject
{
    /**
     * PrevzetiHodnoceniViewObject constructor.
     * @param Dotaznik $hodnoceni
     */
    public function __construct($hodnoceni)
    {
        parent::__construct($hodnoceni, false, false);
    }


    /**
     * @throws \Exception
     */
    public function render()
    {
        if ( $this ->dotaznik->fXMLSablona) {
            if ( !$this ->dotaznik->zobrazDotaznikXML(false, false, 'prevzit') ) {
                MessageManager::getInstance() ->showMessages();
                // v XML sablone je mozne zabranit prevzeti (napr. uzivatelska kontrola prav)
                return;
            }
        }

        $this ->dotaznik ->zobrazHlavicku();
        require('ronportal/hodnoceni/view_prevzit_hodnoceni.php');
    }

}
