<?php
/**
 * Roman.Szablatura 13.2.2017
 */

namespace RonPortal\Jidelna;

use Ron\MVC\Model;

$model = Model::getInstance();
$pocetSloupcu = $model->getData('pocetSloupcu');
$kodterminalu = $model->getData('kodterminalu');
$jedinyVyskytTypuPolozkyNaRadku = $model->getData('jedinyVyskytTypuPolozkyNaRadku');
$kodjidelny = $model->getData('kodjidelny');
$interval = $model->getData('interval');
$cena = $model->getData('cena');
$sirkaPrvku = 99 / $pocetSloupcu;
$stylPrvku = 'width: ' . $sirkaPrvku . '%';

?>
<!DOCTYPE html>
<html>
    <head>
<!--        <link rel="stylesheet" href="jidelna/vitrina.css" type="text/css">-->
        <?php
            require('ron/apphead.php');
            require('view/apphead.php');
        ?>

        <style>
            .polozkaVitriny {
                <?= $stylPrvku ?>
            }
        </style>
    </head>

    <body class="bodyvitrina">
        <input id="jedinyVyskytTypuPolozkyNaRadku" value="<?= $jedinyVyskytTypuPolozkyNaRadku?>" type="hidden">
        <input id="kodterminalu" value="<?= $kodterminalu?>" type="hidden">
        <input id="kodjidelny" value="<?= $kodjidelny?>" type="hidden">
        <input id="cena" value="<?= $cena?>" type="hidden">
        <input id="interval" value="<?= $interval?>" type="hidden">
    </body>
</html>