<?php
/**
 * roman.Szablatura 24.11.2016  20:02
 */

namespace RonPortal\Napady;

use Ron\Controls\ComboBox;
use Ron\Controls\FormField;
use Ron\DB\DBException;
use Ron\DB\DBRecordField;
use Ron\DB\DBUtils;
use Ron\DB\Database;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Controls\RCOsobyFormField;
use RonPortal\Controls\RonPortalForm;
use RonPortal\Controls\UserLoginFormField;
use RonPortal\NeniPravoException;
use RonPortal\Prava;
use RonPortal\PravaNaOsoby;
use RonPortal\User;

///**
// * Class VlozeniAutora
// * @package Ron\RonPortal\Napady
// */
//class AutorNapaduFormField extends FormField
//{
//    /** @var  PravaNaOsoby $prava_admin */
//    var $prava_admin;
//
//    var $autor;
//
//    /**
//     * VlozeniAutora constructor.
//     * @param $prava_admin
//     */
//    function __construct($prava_admin)
//    {
//        parent::__construct();
//        $this->prava_admin = $prava_admin;
//        $this->maxLength = 15;
//    }
//
//    /**
//     * @param Database $database
//     * @param mixed $value
//     * @param bool $canEdit
//     * @param bool $insert
//     * @param array $rowData
//     * @throws DBException
//     */
//    function showFieldContent($database, $value, $canEdit, $insert, $rowData)
//    {
//        $this->autor = $rowData[4];
//
//        // Prevod RC na ID PP
//        $params = $database->createParameters();
//        $osobaID = DBUtils::getSqlValue($database,
//            'SELECT MAX(ID) FROM PracovniPomer WHERE PracovniPomer.RC = ' .  $params->addParameter(User::getRC()),
//            $params);
//
//        $params = $database->createParameters();
//        $sql =
//            'SELECT MAX(PracovniPomer.Id),' .
//            " COALESCE(Osoba.Prijmeni,'') {fn_concat()} ' ' {fn_concat()} COALESCE(Osoba.Jmeno,'') {fn_concat()} COALESCE(', ' {fn_concat()} Osoba.Titul,'')" .
//            ' FROM PracovniPomer, Osoba' .
//            ' WHERE Osoba.RC = PracovniPomer.RC' .
//            ' AND PracovniPomer.DatumNastupu <= ' . $params->addParameter($database ->dateToParam(time())) .
//            ' AND (PracovniPomer.DatumUkonceni IS NULL  OR  PracovniPomer.DatumUkonceni >= ' . $params->addParameter($database ->dateToParam(time())) . ')' .
//            ' AND PracovniPomer.Zamestnanec > 0' .
//            ' GROUP BY Osoba.Prijmeni, Osoba.Jmeno, Osoba.Titul' .
//            ' ORDER BY Osoba.Prijmeni, Osoba.Jmeno';
//
//        if ($this->editable  &&  $this->prava_admin->jsouNejakePrava()) {
//            $combo = new ComboBox($this ->fieldName);
//            $combo->emptyRow = '';
//            $combo->className = 'form-input ronselect';
//            $combo->htmlParams = ['data-columns' => 'text'];
//            $combo->loadData($database, $sql, $osobaID, $params);
//            $combo->render();
//        } else  if ($this->editable) {
//            echo StringUtils::htmlTextConvert(User::getUserName());
//            echo '<input type="hidden" name="Autor" value="' . $osobaID . '">';
//        } else {
//            echo StringUtils::htmlTextConvert($rowData[17]);
//            echo '<input type="hidden" name="Autor" value="' . $osobaID . '">';
//        }
//    }
//
//    /**
//     * @param Database $database
//     * @param string $tableName
//     * @param int $insert
//     * @param bool $utf8
//     * @return DBRecordField
//     */
//    function createDBRecordField($database, $tableName, $insert, $utf8 = false)
//    {
//        $field = new DBRecordField($this->sqlFieldName, '', !$this->editable, $this->maxLength);
//        if ($this->editable) {
//            // Prevod ID PP na RC
//            $params = $database->createParameters();
//            $osobaRC = DBUtils::getSqlValue($database, "SELECT RC FROM PracovniPomer WHERE ID = " . $params->addParameter($_POST['Autor']), $params);
//            $field->setValue($osobaRC);
//        } else {
//            $field->setValue($this->autor);
//        }
//        return $field;
//    }
//}

///**
// * Class VlozeniPilota
// * @package Ron\RonPortal\Napady
// *
// * Jine chovani nez autor
// */
//class PilotFormField extends FormField
//{
//    /** @var  PravaNaOsoby $prava_admin */
//    var $prava_admin;
//
//    var $pilot;
//
//    function __construct($fieldname, $edit, $prava_admin)
//    {
//        parent::__construct();
//        $this->prava_admin = $prava_admin;
//        $this->fieldName = $fieldname;
//        $this->sqlFieldName = $fieldname;
//        $this->editable = $edit;
//        $this->maxLength = 15;
//        $this->caption = TextManager::_('pilot');
//    }
//
//    /**
//     * @param Database $database
//     * @param mixed $value
//     * @param bool $canEdit
//     * @param bool $insert
//     * @param array $rowData
//     * @throws DBException
//     */
//    function showFieldContent($database, $value, $canEdit, $insert, $rowData)
//    {
//        $this->pilot = $rowData[8];
//
//        // Prevod RC na ID PP
//        if (isset($this ->pilot)) {
//            $params1 = $database->createParameters();
//            $osobaID = DBUtils::getSqlValue($database,
//                "SELECT MAX(ID) FROM PracovniPomer WHERE PracovniPomer.RC  = " . $params1->addParameter($this->pilot),
//                $params1);
//        } else {
//            $osobaID = null;
//        }
//
//        $params = $database->createParameters();
//        $sql =
//            'SELECT (SELECT MAX(ID) FROM PracovniPomer WHERE PracovniPomer.RC = Osoba.RC' .
//            ' AND PracovniPomer.DatumNastupu <= ' . $params->addParameter($database ->dateToParam(date(time()))) .
//            ' AND (PracovniPomer.DatumUkonceni >= ' . $params->addParameter($database ->dateToParam(date(time()))) . ' OR PracovniPomer.DatumUkonceni IS NULL)), ' .
//            "   COALESCE(Osoba.Prijmeni,'') {fn_concat()} ' ' {fn_concat()} COALESCE(Osoba.Jmeno,'') {fn_concat()} COALESCE(', ' {fn_concat()} Osoba.Titul,'') " .
//            ' FROM Osoba' .
//            ' WHERE EXISTS(SELECT P.RC FROM PracovniPomer P WHERE (P.RC = Osoba.RC) AND (P.DatumNastupu <= ' . $params->addParameter($database ->dateToParam(date(time()))) . ' ) ' .
//            ' AND ((P.DatumUkonceni IS NULL) OR (P.DatumUkonceni >= ' . $params->addParameter($database ->dateToParam(date(time()))) . ')) AND (P.Zamestnanec > 0))' .
//            ' ORDER BY Osoba.Prijmeni, Osoba.Jmeno';
//
//        if ($this->editable && $this->prava_admin->jsouNejakePrava()) {
//            $combo = new ComboBox('Pilot');
//            $combo->emptyRow = '';
//            $combo->className = 'form-input ronselect';
//            $combo->htmlParams = ['data-columns' => 'text'];
//            $combo->loadData($database, $sql, $osobaID, $params);
//            $combo->render();
//        } else {
//            echo StringUtils::htmlTextConvert($rowData[18]);
//            echo '<input type="hidden" name="Pilot" value="' . $osobaID . '">';
//        }
//    }
//
//    /**
//     * @param Database $database
//     * @param $tableName
//     * @param $insert
//     * @return DBRecordField
//     * @throws DBException
//     */
//    function createDBRecordField($database, $tableName, $insert, $utf8 = false)
//    {
//        $field = new DBRecordField($this->sqlFieldName, '', $this->readOnly, $this->maxLength);
//        if (!$this->readOnly) {
//            //Prevod ID PP na RC
//            if (isset($_POST['Pilot']) && $_POST['Pilot'] != '') {
//                $params = $database->createParameters();
//                $osobaRC = DBUtils::getSqlValue($database, 'SELECT RC FROM PracovniPomer WHERE ID = ' . $params->addParameter($_POST['Pilot']), $params);
//                $field->setValue($osobaRC);
//            }
//        }
//
//        return $field;
//    }
//}


/**
 * Class VolbaPriority
 * @package Ron\RonPortal\Napady
 */
class VolbaPriority extends FormField
{
//    /**
//     * @param Database $database
//     * @param mixed $value
//     * @param bool $canEdit
//     * @param bool $insert
//     * @param array $rowData
//     * @throws DBException
//     */
//    function showFieldContent($database, $value, $canEdit, $insert, $rowData)
//    {
//        if ($canEdit) {
//            $sql =
//                'SELECT DISTINCT Napad.Priorita, Napad.Priorita' .
//                ' FROM Napad' .
//                ' WHERE Napad.Priorita IS NOT NULL' .
//                ' ORDER BY Napad.Priorita';
//
//            $combo = new ComboBox($this ->fieldName);
//            $combo->emptyRow = TextManager::_('priorita_neni_urcena');
//            $combo->alwaysShowSelected = true;
//            $combo->loadData($database, $sql, $rowData[9]);
//            $combo->render();
//
//            echo '<span class="js toggleClass" data-remove-class="d-none" data-selector=".row-nova-priorita">' . TextManager::_('priorita_nova') . '</span>';
//        } else {
//            echo StringUtils::htmlTextConvert($value);
//        }
//    }


    function createDBRecordField($database, $tableName, $insert, $utf8 = false)
    {
        $field = parent::createDBRecordField($database, $tableName, $insert, $utf8);

        if (isset($_POST['priorita_nova']) && trim($_POST['priorita_nova']) != '') {
            $field->setValue($_POST['priorita_nova']);
        }

        return $field;
    }
}


/**
 * Class VytvoreniNovehoNapaduFrom
 * @package RonPortal\Napady
 */
class NapadForm extends RonPortalForm
{
    /** @var  PravaNaOsoby $prava */
    var $prava;

    /** @var  PravaNaOsoby $prava_admin */
    var $prava_admin;

    /** @var int    Id editovaneho/vlozeneho zaznamu - nastavi se po vlozeni nebo editaci */
    public $id;


    /**
     * NapadForm constructor.
     * @param Database $database
     * @throws NeniPravoException
     * @throws \Exception
     */
    function __construct($database)
    {
        parent::__construct($database);

        $this->title = TextManager::_($this->isInsert() ? 'zapis_noveho_napadu' : 'editace_napadu');
        $this->htmlAction = '?menuid=napady';

        $this->code = 'formnapad';

        $this->prava = Prava::vratPrava('napady');
        $this->prava_admin = Prava::vratPrava('napady_admin');

        $this->setXmlEventsName('NAPAD');

        if ($this ->isInsert()) {
            $autorMuzeEditovat = true;
            $napad = null;
        } else {
            $napad = Napad::nactiNapad($this ->database, $this ->getRecordPrimaryKeyValue());
            if (!$napad ->jePravoNaNapad()) {
                throw new NeniPravoException();
            }
//            //Pokud pilot zadal vyjadreni neumoznit autorovi (mimo admina) editaci napadu - dokud bude nejake vyjadreni pilota
//            //pokud pilot nema pravo na autora, pak mize editovat pouze svou oblast napadu tedy prioritu, vyjadreni atd.
//            if ( !($napad->vyjadreniPilota == '' || $this->prava_admin->jsouNejakePrava() || $this->prava->lzeZobrazitRC($napad->autorRC)) ){
//                $autorMuzeEditovat = false;
//            }

            $autorMuzeEditovat =
                $this->prava_admin->lzeZobrazitRC($napad ->autorRC)  || // admin muze editovat vzdy
                (!$napad->vyjadreniPilota &&  $this->prava->lzeZobrazitRC($napad->autorRC));    // editor muze editovat, jen kdyz neni vyjadreni pilota
        }

        $this->stornoAction = ($this ->isInsert())
            ? '?menuid=napady'
            : '?menuid=napady&action=zaznam&record=' . $_GET['record'];

//        $this->sqlSelectPart =
//            'ID, Datum, Stav, Oblast, Autor, Nazev, {fn_CASTWIDEMEMO(Napad.PodrobnyPopis)}, Rozpocet,' .            //0 - 7
//            ' Pilot, Priorita, {fn_CASTWIDEMEMO(Napad.VyjadreniPilota)}, OdmenaCastka, OdmenaVyplacenaVObdobi,' .   //8 - 12
//            ' Insert_UserName, Insert_Timestamp, Update_UserName, Update_Timestamp' . // 13 - 16
//            " (SELECT COALESCE(Osoba.Prijmeni,'') {fn_concat()} ' ' {fn_concat()} COALESCE(Osoba.Jmeno,'') {fn_concat()} COALESCE(', ' {fn_concat()} Osoba.Titul,'')" .
//            "  FROM Osoba WHERE Osoba.RC = Autor), " .      // 17
//            " (SELECT COALESCE(Pilot.Prijmeni,'') {fn_concat()} ' ' {fn_concat()} COALESCE(Pilot.Jmeno,'') {fn_concat()} COALESCE(', ' {fn_concat()} Pilot.Titul,'')" .
//            "  FROM Osoba Pilot WHERE Pilot.RC = Pilot)" ;  // 18

        $this->sqlTableName = 'Napad';


        $this->addField(FormField::FIELD_TYPE_ID)
            ->setFieldName('Id') ->setPrimary(true)
            ->setCode('field-id');

        if ($this->prava_admin->jsouNejakePrava()) {
            // Stav napadu - implicitne jako 0 - novy, jinak Admin nebo Pilot mohou stavy menit
            $this->addField(FormField::FIELD_TYPE_SELECT)
                ->setFieldName('Stav') ->setDefaultValue(0) ->setCaption('stav_napadu') ->setRequired(1)
                ->setCode('field-stav-admin')
                ->setSelectSql('SELECT Kod, Popis FROM StavNapadu ORDER BY Kod')
                ->setSelectDataTypeTest(false);
        } else {
            // Skryte pole: duvod novy napad - hodnota napevno nastavena na novy napad
            $this->addField(FormField::FIELD_TYPE_CONSTANT)
                ->setFieldName('Stav') ->setDefaultValue(0) ->setDataType('int') ->setReadOnly(true)
                ->setCode('field-stav');
        }

        // Autor
//        // Moznost upravovat autora pouze pri vytvoreni s pravy napady_admin, jinak je autorem automaticky prihlasena osoba
//        $this->addField(new AutorNapaduFormField($this->prava_admin))
//            ->setFieldName('Autor')
//            ->setReadOnly(true)  //->setReadOnly($this->formAction == 'new' || $this->formAction == 'insert' ? 0 : 1)
//            ->setRequired(true)
//            ->setCaption('autor')
//            ->setCode('field-autor');

        $this ->addField(new RCOsobyFormField('napady', time()))
            ->setFieldName('Autor') ->setReadOnly(true) ->setRequired(true)
            ->setCaption('autor')
            ->setCode('field-autor');


        // Datum
        $this->addField(FormField::FIELD_TYPE_ACTUAL_DATE)
            ->setFieldName('Datum') ->setReadOnly(true)
            ->setCode('field-datum');

        // Sekce detaily
        $this->addField(FormField::FIELD_TYPE_SECTION_HEADER)
            ->setCaption('detaily') ->setRowClass('form-section margin-top-2 margin-bottom-2')
            ->setCode('sekce-detaily');

        // Nazev
        $this->addField()
            ->setFieldName('Nazev') ->setRequired(true)
            ->setCode('field-nazev')
            ->setCaption('nazev_napadu') ->setReadOnly(!$autorMuzeEditovat);

        // Oblast napadu
        $this->addField(FormField::FIELD_TYPE_SELECT)
            ->setFieldName('Oblast') ->setCaption('oblast_napadu')
            ->setCode('field-oblast')
            ->setSelectSql('SELECT OblastNapadu.Kod, OblastNapadu.Popis FROM OblastNapadu ORDER BY OblastNapadu.Popis')
            ->setShowEmptyValue(true)
            ->setReadOnly(!$autorMuzeEditovat);

        // Podrobny popis
        $this->addField(FormField::FIELD_TYPE_MEMO)
            ->setFieldName('PodrobnyPopis') ->setCaption('podrobny_popis')
            ->setCode('field-podrobnypopis')
            ->setReadOnly(!$autorMuzeEditovat);

        // Rozpocet
        $this->addField(FormField::FIELD_TYPE_FLOAT)
            ->setFieldName('Rozpocet') ->setCaption('rozpocet')
            ->setCode('field-rozpocet')
            ->setReadOnly(!$autorMuzeEditovat);

        //Pokud se nejedna o admina nebo neni pilot urcen pak nezobrazovat


        // Urceny pilot
        //$this->addField(new PilotFormField('Pilot', $this->prava_admin->jsouNejakePrava(), $this->prava_admin));
        $this ->addField(new RCOsobyFormField(new PravaNaOsoby(3, null, null, null), time()))
            ->setFieldName('Pilot') ->setCaption('pilot') ->setRequired(false)
            ->setCode('field-pilot')
            ->setVisible(!$this ->isInsert()  ||  $this->prava_admin->jsouNejakePrava())
            ->setReadOnly(!$this ->prava_admin ->jsouNejakePrava());

        //Vyjadreni pilota
        $jsemPilotNeboAdmin = $this ->isInsert()
            ? $this->prava_admin->jsouNejakePrava()
            : ($this ->prava_admin ->lzeZobrazitRC($napad ->autorRC) || User::hasRC($napad ->pilotRC));

        //Priorita - z combo pripadne nova
        $this->addField(new VolbaPriority(FormField::FIELD_TYPE_SELECT))
            ->setFieldName('Priorita') ->setMaxLength(80) ->setCaption('priorita')
            ->setCode('field-priorita')
            ->setReadOnly(!$jsemPilotNeboAdmin)
            ->setSelectSql('SELECT DISTINCT Priorita, Priorita FROM Napad' .
                ' WHERE Napad.Priorita IS NOT NULL AND (%FILTER%)' .
                ' ORDER BY %ORDER%', '1 = 1', 'Napad.Priorita'
            );

        if ($this->prava_admin->jsouNejakePrava()) {
            $this->addField(FormField::FIELD_TYPE_TEXT)
                ->setText('<span class="js toggleClass" data-toggle-class="d-none" data-selector="#row-nova-priorita">' . TextManager::_('priorita_nova') . '</span>')
                ->setCode('field-novapriorita-link')
                ->setVisible($jsemPilotNeboAdmin);

            $this->addField()
                ->setFieldName('*priorita_nova')->setMaxLength(80)//->setCaption(ronText('priorita_nova'))
                ->setRowId('row-nova-priorita') ->setRowClass('form-row row-nova-priorita d-none')
                ->setVisible($jsemPilotNeboAdmin)
                ->setCode('field-novapriorita');
        }

        $this->addField(FormField::FIELD_TYPE_MEMO)
            ->setFieldName('VyjadreniPilota') ->setCaption('vyjadreni_pilota')
            ->setVisible(!$this ->isInsert()  ||  $this->prava_admin->jsouNejakePrava())
            ->setReadOnly(!$jsemPilotNeboAdmin)
            ->setCode('field-vyjadrenipilota');

        // Odmena
        $this->addField(FormField::FIELD_TYPE_FLOAT)
            ->setFieldName('OdmenaCastka') ->setCaption('odmena') ->setFormat('number2')
            ->setVisible(!$this ->isInsert()  ||  $this->prava_admin->jsouNejakePrava())
            ->setReadOnly(!$jsemPilotNeboAdmin)
            ->setCode('field-odmena');

        // Termin vyplaceni odmeny
        $this->addField(FormField::FIELD_TYPE_DATE)
            ->setFieldName('OdmenaVyplacenaVObdobi') ->setCaption('obdobi_vyplaceni_odmeny')
            ->setVisible(!$this ->isInsert()  ||  $this->prava_admin->jsouNejakePrava())
            ->setReadOnly(!$jsemPilotNeboAdmin)
            ->setCode('field-odmenavyplacenavobdobi');

        // Datum a uzivatel - editace napadu
        $this->addField(new UserLoginFormField(false, 'Update_UserName'))
            ->setCode('field-update_username')
            ->setUpdateLog(true);
        $this->addField(FormField::FIELD_TYPE_ACTUAL_TIME)
            ->setFieldName('Update_Timestamp')
            ->setCode('field-update_timestamp')
            ->setUpdateLog(true);

        // Datum a uzivatel - vlozeni napadu
        $this->addField(new UserLoginFormField(true, 'Insert_UserName'))
            ->setCode('field-insert_username') ->setReadOnly(true);
        $this->addField(FormField::FIELD_TYPE_ACTUAL_TIME)
            ->setFieldName('Insert_Timestamp') ->setReadOnly(true)
            ->setCode('field-insert_timestamp');
    }

    function afterInsertRecord($rec)
    {
        $this->id = $rec['ID'];
        return parent::afterInsertRecord($rec);
    }

    function afterUpdateRecord($rec)
    {
        $this->id = $rec['ID'];
        return parent::afterUpdateRecord($rec);
    }
}
