<?php
/**
 * stanislav.elbl, 26.05.2017
 */

namespace RonPortal\XML\Classes;

use Ron\StringUtils;
use RonPortal\XML\XMLFormElementCommand;


class XMLElementDelete extends XMLFormElementCommand
{
    function doCommand()
    {
        if ($this ->xmlForm ->readOnly) {
            return;
        }

        $okInfoMsg = StringUtils::fromUTF8($this ->getAttributeValue('okinfomsg'));
        $this ->xmlForm ->delete($okInfoMsg);
        $this ->xmlForm ->exit = true;
    }
}
