<?php
/**
 * stanislav.elbl, 27.02.2016
 */

namespace RonPortal\Zamestnanci;

use Ron\DateUtils;
use Ron\DB\Database;
use RonPortal\Personalistika\ZdravotniStavOsoby;
use RonPortal\Prava;
use RonPortal\RonPortalUtils;
use Ron\StringUtils;
use RonPortal\RozdeleniOsob;


/**
 * Class OsobniUdajeDovednost
 * @package Ron\Personalistika
 */
class OsobniUdajeDovednost
{
    public $kod;
    public $popis;
    public $popisUrovne;
    public $bodovaHodnota;
}



///**
// * Class PracovniMistoOsoby
// */
//class PracovniMistoOsoby
//{
//    public $popis;
//    public $platnostOd;
//
//    /**
//     * @param Database $database
//     * @param string $rc
//     * @return PracovniMistoOsoby[]
//     */
//    public static function nactiPracovniMista($database, $rc)
//    {
//        $params = $database ->createParameters();
//
//        $sql =
//            'SELECT Rozdeleni.Popis, RozdeleniOsob.PlatnostOd ' .
//            ' FROM RozdeleniOsob, Rozdeleni ' .
//            ' WHERE Rozdeleni.KodTypuRozdeleni = RozdeleniOsob.KodTypuRozdeleni ' .
//            ' AND Rozdeleni.Kod = RozdeleniOsob.Rozdeleni ' .
//            ' AND Rozdeleni.KodTypuRozdeleni = -1 ' .
//            ' AND RC = ' . $params ->addParameter($rc) .
//            ' AND RozdeleniOsob.PlatnostOd <= ' . $params ->addParameter($database ->dateToParam(time())) .
//            ' AND (RozdeleniOsob.PlatnostDo >= ' . $params ->addParameter($database ->dateToParam(time())) . ' OR RozdeleniOsob.PlatnostDo IS NULL)' .
//            ' ORDER BY RozdeleniOsob.PlatnostOd DESC ';
//
//        $result = [];
//
//        $cursor = $database ->getSqlResult($sql, $params);
//        while ($row = $cursor ->fetch()) {
//            $pracovniMisto = new PracovniMistoOsoby();
//            $pracovniMisto ->popis = $row[0];
//            $pracovniMisto ->platnostOd = $database ->stringToTimestamp($row[1]);
//            $result[] = $pracovniMisto;
//        }
//        $cursor ->close();
//
//        return $result;
//    }
//}


/**
 * Class OsobniUdaje
 * @package RonPortal\Personalistika
 */
class OsobniUdaje
{
    public $rc;
    public $titul;
    public $jmeno;
    public $prijmeni;
    public $titulZa;

    public $idFotografie;

    //public $rodneJmeno;
    public $datumNarozeni;
    public $pohlavi;
    public $narodnost;
    public $rcZahranicni;

    public $uzivatelska1;
    public $uzivatelska2;
    public $uzivatelska3;
    public $uzivatelska4;
    public $uzivatelska5;
    public $uzivatelska6;
    public $uzivatelska7;
    public $uzivatelska8;
    public $uzivatelska9;
    public $uzivatelska10;
    public $uzivatelska11;
    public $uzivatelska12;
    public $uzivatelska13;
    public $uzivatelska14;
    public $uzivatelska15;
    public $uzivatelska16;
    public $uzivatelska17;
    public $uzivatelska18;
    public $uzivatelska19;
    public $uzivatelska20;

    public $mistoNarozeni;
    public $okresNarozeni;
    public $statniPrislusnost;

    public $intrawebLogin;
    public $skupinaIW;
    public $telefon;
    public $mobil;
    public $email;
    public $poznamka;

    // pracovni pomer
    public $idPP;
    public $osobniCislo;
    public $datumNastupu;
    public $datumUkonceni;
    public $zamestnanec;
    public $poradoveCisloPP;
    public $cisloPracovniSmlouvy;
    public $typPracovnihoPomeru;
    public $zkusebniDoba;
    public $zkusebniDobaDo;
    public $zkusebniDobaDoVypoctena;
    public $postaveniVZamestnani;
    public $duvodUkonceni;
    public $duvodVzniku;

    public $uzivatelskaPP1;
    public $uzivatelskaPP2;
    public $uzivatelskaPP3;
    public $uzivatelskaPP4;
    public $uzivatelskaPP5;
    public $uzivatelskaPP6;
    public $uzivatelskaPP7;
    public $uzivatelskaPP8;
    public $uzivatelskaPP9;
    public $uzivatelskaPP10;
    public $uzivatelskaPP11;
    public $uzivatelskaPP12;
    public $uzivatelskaPP13;
    public $uzivatelskaPP14;
    public $uzivatelskaPP15;
    public $uzivatelskaPP16;
    public $uzivatelskaPP17;
    public $uzivatelskaPP18;
    public $uzivatelskaPP19;
    public $uzivatelskaPP20;

    public $emailProVyplatniListek;

    public $poznamkaPP;

    /** @var AdresaOsoby[] */
    public $adresy = [];
    /** @var bool */
    public $pravoZobrazitTrvale = true;
    /** @var bool */
    public $pravoZobrazitPrechodne = true;

    /** @var RodinnyStav */
    public $rodinnyStav = null;
    /** @var ZdravotniStavOsoby */
    public $zdravotniStav = null;
    /** @var ZdravotniPojisteniOsoby */
    public $zdravotniPojistovna = null;
    /** @var VzdelaniOsoby[] */
    public $vzdelani = [];
    /** @var OsobniUdajeDovednost[] */
    public $dovednosti = [];
    /** @var RozdeleniOsob[] */
    public $pracovniMista = [];

    /** @var BankovniUcetOsoby[] $uctyOsoby  */
    public $uctyOsoby = null;

    /** @var Prukaz[][] $prukazyOsoby */
    public $prukazyOsoby = [];

    /** @var  PenzijniPripojisteniOsoby $penzijniPripojisteniOsoby */
    public $penzijniPripojisteniOsoby = [];

    /** @var ZivotniPojisteniOsoby[] $zivotniPojisteniOsoby */
    public $zivotniPojisteniOsoby = [];

    /** @var RodinnyPrislusnik $rodinniPrislusnici */
    public $rodinniPrislusnici = [];

    /** @var array $velikostPomucekOsoby */
    public $velikostPomucekOsoby = [];
    /** @var array $seznamVydanychPomucekOsoby */
    public $seznamVydanychPomucekOsoby = [];
    /** @var array $seznamNesplnenychNarokuPomucek */
    public $seznamNesplnenychNarokuPomucek = [];

    /** @var EvidencniStav[] $evidencniStavy */
    public $evidencniStavy = [];

    /**
     * @param Database $database
     * @param int $idPP
     * @throws \Exception
     */
    function nactiZakladniUdaje($database, $idPP)
    {
        $jsouMzdy = RonPortalUtils::jeNainstalovanaAplikace($database, 'MZDY');
        $jePersonalistika = RonPortalUtils::jeNainstalovanaAplikace($database, 'PERSON');

        $params = $database ->createParameters();

        $sql =
            'SELECT Osoba.RC, Osoba.Titul, Osoba.Jmeno, Osoba.Prijmeni, Osoba.TitulZa, Osoba.IdFotografie,' . // 0..5
            ' NULL AS RodneJmeno, NULL AS DatumNarozeni, NULL AS Pohlavi, NULL AS Narodnost, NULL AS RC_Zahranicni,' .  //6..10 - 11/2017 - odstraneny osobni udaje
            ' Osoba.Uzivatelska1,  Osoba.Uzivatelska2, Osoba.Uzivatelska3, Osoba.Uzivatelska4, Osoba.Uzivatelska5,' .  // 11..
            ' Osoba.Uzivatelska6,  Osoba.Uzivatelska7, Osoba.Uzivatelska8, Osoba.Uzivatelska9, Osoba.Uzivatelska10,' .
            ' Osoba.Uzivatelska11,  Osoba.Uzivatelska12, Osoba.Uzivatelska13, Osoba.Uzivatelska14, Osoba.Uzivatelska15,' .
            ' Osoba.Uzivatelska16,  Osoba.Uzivatelska17, Osoba.Uzivatelska18, Osoba.Uzivatelska19, Osoba.Uzivatelska20,' . // ..30
            ' NULL AS MistoNarozeni, NULL AS OkresNarozeni, NULL AS StatniPrislusnost,' .    // 31..33  -  11/2017 - odstraneny osobni udaje
            ' Osoba.IntrawebLogin, Osoba.SkupinaIW, Osoba.Telefon, Osoba.eMail,' .    // 34..37
            $database ->castWideMemo('Osoba.Poznamka') . ',' . // 38
            // pracovni pomer
            ' PracovniPomer.OsobniCislo, PracovniPomer.DatumNastupu, PracovniPomer.DatumUkonceni, PracovniPomer.Zamestnanec,' . // 39..42
            ' PracovniPomer.PoradoveCisloPP, PracovniPomer.CisloPracovniSmlouvy, PracovniPomer.TypPracovnihoPomeru,' .     // 43..45
            ' PracovniPomer.ZkusebniDoba, PracovniPomer.ZkusebniDobaDo,' . // 46..47
            ' PracovniPomer.Uzivatelska1,  PracovniPomer.Uzivatelska2, PracovniPomer.Uzivatelska3, PracovniPomer.Uzivatelska4, PracovniPomer.Uzivatelska5,' .  // 48..
            ' PracovniPomer.Uzivatelska6,  PracovniPomer.Uzivatelska7, PracovniPomer.Uzivatelska8, PracovniPomer.Uzivatelska9, PracovniPomer.Uzivatelska10,' .
            ' PracovniPomer.Uzivatelska11,  PracovniPomer.Uzivatelska12, PracovniPomer.Uzivatelska13, PracovniPomer.Uzivatelska14, PracovniPomer.Uzivatelska15,' .
            ' PracovniPomer.Uzivatelska16,  PracovniPomer.Uzivatelska17, PracovniPomer.Uzivatelska18, PracovniPomer.Uzivatelska19, PracovniPomer.Uzivatelska20,' . // ..67
            $database ->castWideMemo('PracovniPomer.Poznamka') . ', Osoba.Mobil, Osoba.EmailProVyplatniListek,' . // 68..70
            ( ($jsouMzdy  ||  $jePersonalistika) ? ' PostaveniVZamestnani.Popis' : ' PracovniPomer.PostaveniVZamestnani')  . ', ' . // 71
            ' PracovniPomer.ZkusebniDobaDoVypoctena, DuvodUkonceniPP.Popis, DuvodVznikuPP.Popis ' . // 72..74
            // ...
            ' FROM Osoba' .
            ' INNER JOIN PracovniPomer ON Osoba.RC = PracovniPomer.RC' .
            ' LEFT OUTER JOIN DuvodUkonceniPP ON DuvodUkonceniPP.Kod = PracovniPomer.DuvodUkonceniPP ' .
            ' LEFT OUTER JOIN DuvodVznikuPP ON DuvodVznikuPP.Kod = PracovniPomer.DuvodVznikuPP ' .
            ( ($jsouMzdy  ||  $jePersonalistika)
                ? ' LEFT OUTER JOIN PostaveniVZamestnani ON PostaveniVZamestnani.Kod = PracovniPomer.PostaveniVZamestnani'
                : ''
            ) .
            ' WHERE PracovniPomer.Id = ' . $params ->addParameter((int)$idPP);

        $cursor = $database ->select($sql, $params);

        if (!$row = $cursor ->fetch()) {
            throw new \Exception(StringUtils::fromUTF8('Pozadovana osoba nebyla nalezena!'));
        }

        $cursor ->close();

        $this ->idPP = $idPP;
        $this ->rc = $row[0];
        $this ->titul = $row[1];
        $this ->jmeno = $row[2];
        $this ->prijmeni = $row[3];
        $this ->titulZa = $row[4];
        $this ->idFotografie = $row[5];

        //$this ->rodneJmeno = $row[6];
        $this ->datumNarozeni = $database ->stringToTimestamp($row[7]);
        $this ->pohlavi = $row[8];
        $this ->narodnost = $row[9];
        $this ->rcZahranicni = $row[10];

        for ($i = 1;  $i <= 20;  $i++) {
            $this ->{'uzivatelska'.$i} = $row[10 + $i];
        }

        $this ->mistoNarozeni = $row[31];
        $this ->okresNarozeni = $row[32];
        $this ->statniPrislusnost = $row[33];
        $this ->intrawebLogin = $row[34];
        $this ->skupinaIW = $row[35];
        $this ->telefon = $row[36];
        $this ->email = $row[37];
        $this ->poznamka = $row[38];

        // Pracovni pomer
        $this ->osobniCislo = $row[39];
        $this ->datumNastupu = $database ->stringToTimestamp($row[40]);
        $this ->datumUkonceni = $database ->stringToTimestamp($row[41]);
        $this ->zamestnanec = $row[42];
        $this ->poradoveCisloPP = $row[43];
        $this ->cisloPracovniSmlouvy = $row[44];
        $this ->typPracovnihoPomeru = $row[45];
        $this ->zkusebniDoba = $row[46];
        $this ->zkusebniDobaDo = $database ->stringToTimestamp($row[47]);
        $this ->zkusebniDobaDoVypoctena = $database ->stringToTimestamp($row[72]);
        $this ->emailProVyplatniListek = $row[70];

        for ($i = 1;  $i <= 20;  $i++) {
            $this ->{'uzivatelskaPP'.$i} = $row[47 + $i];
        }

        $this ->poznamkaPP = $row[68];
        $this ->mobil = $row[69];
        $this ->postaveniVZamestnani = $row[71];
        $this->duvodUkonceni = $row[73];
        $this->duvodVzniku = $row[74];
    }

    function vratTextPole($jmenoPole)
    {
        $jmenoPole = trim(strtolower($jmenoPole));

        switch ($jmenoPole) {
            case 'osoba.jmeno' : return StringUtils::htmlTextConvert($this ->jmeno);
            case 'osoba.prijmeni' : return StringUtils::htmlTextConvert($this ->prijmeni);
            case 'osoba.titul' : return StringUtils::htmlTextConvert($this ->titul);
            case 'osoba.rc' : return StringUtils::htmlTextConvert($this ->rc);
            case 'osoba.rodnejmeno' : return ''; // return StringUtils::htmlTextConvert($this ->rodneJmeno);
            case 'osoba.datumnarozeni' : return StringUtils::format('date', $this ->datumNarozeni);
            case 'osoba.poznamka' : return StringUtils::longTextToHtml($this ->poznamka, true);
            case 'osoba.pohlavi' : return $this ->pohlavi;
            case 'osoba.narodnost' : return $this ->narodnost;
            case 'osoba.mistonarozeni' : return StringUtils::htmlTextConvert($this ->mistoNarozeni);
            case 'osoba.okresnarozeni' : return StringUtils::htmlTextConvert($this ->okresNarozeni);
            case 'osoba.email' : return StringUtils::htmlTextConvert($this ->email);
            case 'osoba.intraweblogin' : return StringUtils::htmlTextConvert($this ->intrawebLogin);
            case 'osoba.skupinaiw' : return StringUtils::htmlTextConvert($this ->skupinaIW);
            case 'osoba.telefon' : return StringUtils::htmlTextConvert($this ->telefon);
            case 'osoba.mobil' : return StringUtils::htmlTextConvert($this ->mobil);
            case 'osoba.statniprislusnost' : return StringUtils::htmlTextConvert($this ->statniPrislusnost);
            case 'osoba.rczahranicni' : return StringUtils::htmlTextConvert($this ->rcZahranicni);
            case 'pracovnipomer.osobnicislo' : return StringUtils::htmlTextConvert($this ->osobniCislo);
            case 'pracovnipomer.datumnastupu' : return StringUtils::format('date', $this ->datumNastupu);
            case 'pracovnipomer.datumukonceni' : return StringUtils::format('date', $this ->datumUkonceni);
            case 'pracovnipomer.id' : return $this ->idPP;
            case 'pracovnipomer.poradovecislopp' : return $this ->poradoveCisloPP;
            case 'pracovnipomer.cislopracovnismlouvy' : return StringUtils::htmlTextConvert($this ->cisloPracovniSmlouvy);
            case 'pracovnipomer.typpracovnihopomeru' : return StringUtils::htmlTextConvert($this ->typPracovnihoPomeru);
            case 'pracovnipomer.zkusebnidoba' : return $this ->zkusebniDoba;
            case 'pracovnipomer.zkusebnidobado' : return StringUtils::format('date', $this ->zkusebniDobaDo);
            case 'pracovnipomer.zkusebnidobadovypoctena' : return StringUtils::format('date', $this ->zkusebniDobaDoVypoctena);
            case 'pracovnipomer.zamestnanec' : return $this ->zamestnanec;
            case 'pracovnipomer.poznamka' : return StringUtils::longTextToHtml($this ->poznamkaPP, true);
            case 'pracovnipomer.postavenivzamestnani' : return isset($this ->postaveniVZamestnani) ? $this ->postaveniVZamestnani : '';
            case 'pracovnipomer.duvodvznikupp' : return $this->duvodVzniku;
            case 'pracovnipomer.duvodukoncenipp' : return $this->duvodUkonceni;
        }

        if ($jmenoPole > 'osoba.uzivatelska'  &&  $jmenoPole < 'osoba.uzivatelska99') {
            $property = substr($jmenoPole, 6);
            return StringUtils::htmlTextConvert($this ->{$property});
        }

        if ($jmenoPole > 'pracovnipomer.uzivatelska'  &&  $jmenoPole < 'pracovnipomer.uzivatelska99') {
            $property = 'uzivatelskaPP' . substr($jmenoPole, 25);
            return StringUtils::htmlTextConvert($this ->{$property});
        }

        return '';
    }


    function overPravo($kodUzivatelskehoPrava)
    {
        if (Prava::existujePravo($kodUzivatelskehoPrava)) {
            return Prava::vratPrava($kodUzivatelskehoPrava) ->lzeZobrazitRC($this ->rc);
        }

        return true;
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiAdresy($database)
    {
        $this ->pravoZobrazitTrvale = $this ->overPravo('prohl_osobni_trvale');
        $this ->pravoZobrazitPrechodne = $this ->overPravo('prohl_osobni_prechodne');

        $this->adresy = ($this ->pravoZobrazitTrvale || $this ->pravoZobrazitPrechodne)
            ? AdresaOsoby::nactiAdresuOsoby($database, $this->rc, time())
            : [];
    }


    /**
     * @param $database
     * @throws \Exception
     */
    function nactiRodinnyStav($database)
    {
        if ($this->overPravo('prohl_osobni_rodinnystav')) {
            $this->rodinnyStav = RodinnyStav::nactiStav($database, $this->rc, null, true); // aktualni
        } else {
            // nema pravo na rodinny stav
            $this->rodinnyStav = false;
        }
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiRodinnePrislusniky($database){
        $this->rodinniPrislusnici = $this ->overPravo('prohl_osobni_prislusnik')
            ? RodinnyPrislusnik::nactiRodinuZamestnance($database, $this->rc)
            : false;
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiZdravotniStav($database)
    {
        if ($this ->overPravo('prohl_osobni_pojistovna')) {
            $this->zdravotniStav = ZdravotniStavOsoby::nactiStav($database, $this->rc, time());
        } else {
            $this->zdravotniStav = false;
        }
    }

    /**
     * @param $database
     * @throws \Ron\DB\DBException
     */
    function nactiZdravotniPojistovnu($database)
    {
        $this ->zdravotniPojistovna = $this ->overPravo('prohl_osobni_pojistovna')
            ? ZdravotniPojisteniOsoby::nactiZdravotniPojistovnuOsoby($database, $this ->rc, time())
            : false;
    }

    /**
     * @param $database
     * @throws \Exception
     */
    function nactiVzdelani($database)
    {
        $this ->vzdelani = $this ->overPravo('prohl_osobni_vzdelani')
            ? VzdelaniOsoby::nactiVzdelani($database, $this ->rc, 'VzdelaniOsoby')
            : false;
    }


    /**
     * @param Database $database
     * @param bool $jenNejvyssi priznak, jestli se ma nacist jen nejvyssi uroven kazde dovednosti
     * @throws \Ron\DB\DBException
     */
    function nactiDovednosti($database, $jenNejvyssi = true)
    {
        if (!$this ->overPravo('prohl_osobni_dovednosti')) {
            $this ->dovednosti = false;
            return;
        }

        $params = $database ->createParameters();

        $sql =
            'SELECT DovednostOsoby.KodDovednosti, UrovenDovednosti.BodovaHodnota, Dovednost.Popis, UrovenDovednosti.Popis ' .
            ' FROM DovednostOsoby, Dovednost, UrovenDovednosti ' .
            ' WHERE DovednostOsoby.RC = ' . $params ->addParameter($this ->rc) .
            ' AND Dovednost.Kod = DovednostOsoby.KodDovednosti ' .
            ' AND UrovenDovednosti.KodDovednosti = DovednostOsoby.KodDovednosti ' .
            ' AND UrovenDovednosti.KodUrovne = DovednostOsoby.KodUrovne ' .
            ' ORDER BY DovednostOsoby.KodDovednosti, UrovenDovednosti.BodovaHodnota DESC ';

        $cursor = $database ->getSqlResult($sql, $params);

        $this ->dovednosti = [];

        $posledniKod = '';
        while ($row = $cursor ->fetch()) {
            if (!$jenNejvyssi  ||  ($posledniKod != $row[0])) {
                $posledniKod = $row[0];

                $dovednost = new OsobniUdajeDovednost();
                $dovednost ->kod = $row[0];
                $dovednost ->bodovaHodnota = $row[1];
                $dovednost ->popis = $row[2];
                $dovednost ->popisUrovne = $row[3];

                $this ->dovednosti[] = $dovednost;
            }
        }

        $cursor ->close();
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiPracovniMista($database)
    {
        $this->pracovniMista = $this ->overPravo('prohl_osobni_pracmista')
            //? PracovniMistoOsoby::nactiPracovniMista($database,  $this->rc)
            ? RozdeleniOsob::nactiRozdeleniOsoby($database, ['rc' => $this ->rc], -1, time())
            : false;
    }

    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiUcetOsoby($database){
        $this->uctyOsoby = $this ->overPravo('prohl_osobni_ucetosoby')
            ? BankovniUcetOsoby::nactiUcetOsoby($database,  $this->rc)
            : false;
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiPrukazyOsoby($database){
        $this->prukazyOsoby = $this ->overPravo('prohl_osobni_prukaz')
            ? Prukaz::nactiPrukazyOsoby($database, $this->rc)
            : false;
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiPenzijniPripojisteniOsoby($database){
        $this->penzijniPripojisteniOsoby = $this ->overPravo('prohl_osobni_penzijni')
            ? PenzijniPripojisteniOsoby::nactiPenzijniPripojisteniOsoby($database, $this->rc)
            : false;
    }

    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiZivotniPojisteniOsoby($database){
        $this->zivotniPojisteniOsoby = $this ->overPravo('prohl_osobni_zivotni')
            ? ZivotniPojisteniOsoby::nactiZivotniPojisteniOsoby($database, $this->rc)
            : false;
    }

    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function nactiVelikostPracovnichPomucek($database)
    {
        if ($this ->overPravo('prohl_osobni_velikosti')) {
            $this->velikostPomucekOsoby = [];

            $params = $database->createParameters();

            $sql =
                'SELECT TypVelikosti.Popis, VelikostPPomucky.Velikost' .
                ' FROM TypVelikosti' .
                ' JOIN VelikostPPomucky ON (TypVelikosti.Kod = VelikostPPomucky.TypVelikosti)' .
                ' LEFT JOIN VelikostPPOsoby ON (VelikostPPomucky.TypVelikosti = VelikostPPOsoby.TypVelikosti AND VelikostPPomucky.Velikost = VelikostPPOsoby.Velikost)' .
                ' WHERE RCOsoby = ' . $params->addParameter($this->rc);

            $cursor = $database->getSqlResult($sql, $params);
            while ($row = $cursor->fetch()) {
                $this->velikostPomucekOsoby[] = $row;
            }
            $cursor ->close();
        } else {
            $this ->velikostPomucekOsoby = false;
        }
    }

    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function seznamVydanychPracovnichPomucek($database)
    {
        if ($this ->overPravo('prohl_osobni_pomucky')) {
            $this->seznamVydanychPomucekOsoby = [];

            $params = $database->createParameters();

            $sql =
                'SELECT PracovniPomucka.Popis, PrirazenaPracPomucka.DatumVydani, PrirazenaPracPomucka.DatumExpirace, TypPomucky.Popis ' .
                'FROM PrirazenaPracPomucka JOIN PracovniPomucka ON (PrirazenaPracPomucka.PracovniPomucka=PracovniPomucka.Kod) ' .
                ' JOIN TypPomucky ON TypPomucky.Kod = PracovniPomucka.TypPomucky ' .
                'WHERE NOT(PrirazenaPracPomucka.datumVydani IS NULL) AND (PrirazenaPracPomucka.datumVraceni IS NULL) ' .
                'AND RC = ' . $params->addParameter($this->rc) . ' ' .
                'ORDER BY TypPomucky.Popis, PrirazenaPracPomucka.DatumExpirace';

            $cursor = $database->getSqlResult($sql, $params);

            while ($row = $cursor->fetch()) {
                $poExpiraci = "";

                if ($row[2] != "") {

                    $zbyvaDni = DateUtils::daysBetween(time(), $database->stringToTimestamp($row[2]));

                    if ($zbyvaDni > 0) {
                        $poExpiraci = "";
                        //Do expirace
                    } else {
                        //Po expiraci
                        $poExpiraci = " expirovano ";

                    }
                }

                $this->seznamVydanychPomucekOsoby[] = [
                    0 => $row[0],
                    1 => $database->stringToTimestamp($row[1]),
                    2 => $database->stringToTimestamp($row[2]),
                    3 => $poExpiraci,
                    4 => $row[3]
                ];
            }

            $cursor ->close();
        } else {
            $this ->seznamVydanychPomucekOsoby = false;
        }
    }


    /**
     * @param Database $database
     * @throws \Ron\DB\DBException
     */
    function seznamNesplnenychNarokuNaPracovniPomucky($database)
    {
        if ($this ->overPravo('prohl_osobni_pomucky')) {
            $params = $database->createParameters();

            $sql =
                'SELECT PracovniPomucka.popis, PrirazenaPracPomucka.DatumNaroku ' .
                'FROM (PrirazenaPracPomucka  ' .
                'LEFT JOIN PracovniPomucka ON (PracovniPomucka.kod = PrirazenaPracPomucka.pracovniPomucka) ' .
                'LEFT OUTER JOIN TypPomucky ON (TypPomucky.Kod=PracovniPomucka.TypPomucky)) ' .
                'WHERE (PrirazenaPracPomucka.RC = ' . $params->addParameter($this->rc) . ') ' .
                'AND (PrirazenaPracPomucka.datumVydani IS NULL) AND (PrirazenaPracPomucka.datumVraceni IS NULL) ' .
                'ORDER BY PrirazenaPracPomucka.DatumNaroku';

            $this->seznamNesplnenychNarokuPomucek = [];

            $cursor = $database->getSqlResult($sql, $params);
            while ($row = $cursor->fetch()) {
                $this->seznamNesplnenychNarokuPomucek[] = [
                    $row[0],
                    $database->stringToTimestamp($row[1])
                ];
            }
            $cursor ->close();
        } else {
            $this->seznamNesplnenychNarokuPomucek = false;
        }
    }

    function nactiEvidencniStavy($database)
    {
        $this->evidencniStavy = $this ->overPravo('prohl_osobni_evidencni')
            ? EvidencniStav::nactiEvidencniStavy($database, $this->rc)
            : false;
    }
}
