


var jidelna = { };
jidelna.Alergen = function() {
    this.kod = 0;
    this.popis = '';
};

jidelna.PolozkaJidelnicku = function() {
    this.idpolozky = 0;
    this.den = '';
    this.popis = '';
    this.hodnoceni = 0;
    this.hodnocenipoznamka = '';
    this.alergeny = [];
    this.idfotografie = 0;
};
jidelna.zapisHodnoceniJidla = function(data, zapsatPoznamku, callback) {
    var odesliPozadavekHodnoceni = function(action) {
        var submitData = {
            idpolozky: data.idpolozky,
            hodnoceni: data.hodnoceni
        };

        if (zapsatPoznamku) submitData.hodnocenipoznamka = data.hodnocenipoznamka;

        $.ajax(
            {
                url : "?menuid=jidelnajs&action=" + action,
                type: "POST",
                data : submitData
            }).done( function(responseData) {
                if ( responseData.result === "OK" ) {
                    callback.call();
                } else {
                    ron.showError(responseData);
                }
            }).fail( function(jqXHR) {
                ron.showAjaxError(jqXHR, "Pri hodnoceni jidla doslo k chybe!");
            });
    };
    var zapisHodnoceniJidla = function() {
        odesliPozadavekHodnoceni("hodnotit");

        return true;
    }; 
    
    zapisHodnoceniJidla();
};
jidelna.zobrazHodnoceniJidla = function(id, callback) {  
    function provedHodnoceniJidla() {
        var hodnoceni = 0;
        var $vybranohodnoceni = $('.vybranohodnoceni');
        if ($vybranohodnoceni.length !== 0) {
            hodnoceni = $vybranohodnoceni.data('hodnoceni-polozky');
        }
        var poznamka = $('#polozkajidelnicku_poznamka').val();        
        
        jidelna.zapisHodnoceniJidla({
                idpolozky : id,
                hodnoceni: hodnoceni,
                hodnocenipoznamka: poznamka
            },
            true, // zapsat poznamku = true
            function () {
                $('.vybranohodnoceni').removeClass('vybranohodnoceni');
                $("#polozkajidelnicku_dialog").dialog('close');
                if (hodnoceni !== 0) {
                    var hodnoceno = $('#jidelnicek_hodnoceni_'+hodnoceni+'_'+id);
                    $(hodnoceno).prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on_16');
                    $(hodnoceno).nextAll('span').removeClass('hodnocenijidla_hvezda_on_16');
                    $(hodnoceno).parent('td').data('aktualni-hodnoceni', hodnoceni);
                }
                else {
                    $('tr[data-jidelnicek-id="' + id + '"]').children('td.jidelnicek_hodnoceni')
                        .data('aktualni-hodnoceni',hodnoceni)
                        .children('span').removeClass('hodnocenijidla_hvezda_on_16 hodnocenijidla_hvezda_off_16');
                }
            }
        );
    }

    $('#polozkajidelnicku_foto').hide();

    $("#polozkajidelnicku_dialog")        
        .dialog( {
            modal : true,
            resizable: false,
            width: "auto",
            height: "auto"
        });
    $('#polozkajidelnicku_row_alergeny').hide();
    $('#polozkajidelnicku_seznamalergenu').html('');  

    var $polozkaJidelnickuHodnoceni = $('#polozkajidelnicku_hodnoceni');
    $polozkaJidelnickuHodnoceni.find('span').removeClass('vybranohodnoceni hodnocenijidla_hvezda_on');
    $("#btnStornoHodnoceni")
        .off("click")
        .on("click", function() {
            $('.vybranohodnoceni').removeClass('vybranohodnoceni');
            $("#polozkajidelnicku_dialog").dialog("close");    
        });

    $("#btnHodnoceniOK")
        .off("click")
        .on("click", provedHodnoceniJidla);
    $polozkaJidelnickuHodnoceni
        .off('mouseover mousemove mouseout click')
        .on('mouseover mousemove', 'span[data-hodnoceni-polozky]', function() {                        
            $(this).prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on');

            var $vybraneneHodnoceni = $('.vybranohodnoceni');
            if ($vybraneneHodnoceni.length !== 0) {
                $vybraneneHodnoceni.prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on');
            }
        })
        .on('mouseout', 'span[data-hodnoceni-polozky]', function() {                        
            $(this).siblings('span').addBack().removeClass('hodnocenijidla_hvezda_on');

            var $vybraneneHodnoceni = $('.vybranohodnoceni');
            if ($vybraneneHodnoceni.length !== 0) {
                $vybraneneHodnoceni.prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on');
            }
        })
        .on('click', 'span[data-hodnoceni-polozky]', function() {                                                
            $(this).prevAll('span').removeClass('vybranohodnoceni');
            $(this).nextAll('span').removeClass('vybranohodnoceni hodnocenijidla_hvezda_on');
            if ($(this).hasClass('vybranohodnoceni')) {                
                $(this).prevAll('span').addBack().removeClass('hodnocenijidla_hvezda_on');
                $(this).removeClass('vybranohodnoceni');
            }
            else {
                $(this).addClass('vybranohodnoceni')            
                .prevAll('span').addBack()
                .addClass("hodnocenijidla_hvezda_on");            
            }
            
            ron.debugLog('Vybrano hodnoceni: '+$('.vybranohodnoceni').data('hodnoceni-polozky'));
        });
    var zobrazData = function(data) {
        if (!data  ||  !data.idpolozky) return;
        
        $('#polozkajidelnicku_dialog').dialog('option','title',data.popis);
        
        ron.debugLog('Dialog pro den:' + data.den);
        
        var dnes = new Date();
        if (ron.utils.stringToDate(data.den) > dnes) {
            $('#polozkajidelnicku_row_hodnoceni').hide();
            $('#polozkajidelnicku_row_poznamka').hide();
            $("#btnHodnoceniOK").hide();
        }
        else {
            $('#polozkajidelnicku_hodnoceni_'+data.hodnoceni).addClass('vybranohodnoceni').prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on');

            $('#polozkajidelnicku_poznamka').val(data.hodnocenipoznamka);
            if ($('.jidelnicek_hodnoceni_polozky :visible').length > 0) {
                $('#polozkajidelnicku_row_hodnoceni').show();
                $('#polozkajidelnicku_row_poznamka').show();
            }
        }
        if ((data.alergeny.length > 0) && ($('.alergeny :visible').length > 0)) {
            $.each(data.alergeny, function (k, v) {
                $('#polozkajidelnicku_seznamalergenu').append('<li>'+v.kod + ' - ' + v.popis +'</li>');
            }); 
            $('#polozkajidelnicku_row_alergeny').show();
        }
        else {
            $('#polozkajidelnicku_row_alergeny').hide();
        }

        if (data.idfotografie > 0) {
            var img = $('#polozkajidelnicku_foto_img');
            $(img).prop('src',$(img).data('link') + '&idpolozky=' + data.idpolozky);
            $('#polozkajidelnicku_foto').show();
        }
        else {
            $('#polozkajidelnicku_foto').hide();
        }
    };


    var url = "?menuid=jidelnajs&action=loaddata&id=" + id;

    $.ajax(url)
        .done( function(data) {
            ron.debugLog("Nactena data polozky jidelnicku: ", data);

            if (data.result === "error") {
                ron.showError(data);
            } else {
                zobrazData(data);                

                if (typeof callback === "function") {
                    callback(data);
                }
            }

        }).fail( function(jqXHR) {
            ron.showAjaxError(jqXHR, "Pri nacitani polozky jidelnicku doslo k chybe!");
        });

};
$(function() {
    var nastavZobrazPolozku = function (event) {
        var id = $(this).data("jidelnicek-id");
        var existujeFoto = $(this).data('jidelnicek-mafotografii');
        var jsouAlergeny = $(this).data('jidelnicek-maalergeny');

        if ((povolitHodnoceni && (ron.utils.stringToDate($(this).data('jidelnicek-den')) < hodnotitPred)) || jsouAlergeny || existujeFoto) {
            if ((id) && (event.target.tagName === 'SPAN') && (event.target.id !== '')) {
                var hodnoceni = $(event.target).data('hodnoceni-polozky');
                var puvodniHodnoceni = $(event.target).parent('td').data('aktualni-hodnoceni');
                if (hodnoceni === puvodniHodnoceni) {
                    hodnoceni = 0;
                }
                jidelna.zapisHodnoceniJidla({
                        idpolozky: id,
                        hodnoceni: hodnoceni
                    },
                    false, // zapsat poznamku = false
                    function () {
                        if (hodnoceni !== 0) {
                            var hodnoceno = $('#jidelnicek_hodnoceni_' + hodnoceni + '_' + id);
                            $(hodnoceno).prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on_16');
                            $(hodnoceno).nextAll('span').removeClass('hodnocenijidla_hvezda_on_16');
                            $(hodnoceno).parent('td').data('aktualni-hodnoceni', hodnoceni);
                        }
                        else {
                            $('tr[data-jidelnicek-id="' + id + '"]').children('td.jidelnicek_hodnoceni')
                                .data('aktualni-hodnoceni', hodnoceni)
                                .children('span').removeClass('hodnocenijidla_hvezda_on_16 hodnocenijidla_hvezda_off_16');
                        }
                    });
            }
            else if ((id) && (event.target.tagName !== 'INPUT')) {
                if (povolitHodnoceni || existujeFoto === true || jsouAlergeny === true) {
                    jidelna.zobrazHodnoceniJidla(id);
                }
            }
        }
    };

    var
        $jidelnicek = $('.jidelnicek'),
        hodnotitPred = new Date(),
        povolitHodnoceni = $jidelnicek.data('jidelnicek-povolit-hodnoceni');

    if (!$jidelnicek.length) {
        return;
    }

    $jidelnicek
        .on('click', 'tr[data-jidelnicek-id]', nastavZobrazPolozku)
        .on('mouseover', 'tr[data-jidelnicek-id]', function () {
            if ((povolitHodnoceni && (ron.utils.stringToDate($(this).data('jidelnicek-den')) < hodnotitPred)) || (($(this).data('jidelnicek-maalergeny') === true) /*&& ($('.alergeny :visible').length > 0)*/) || ($(this).data('jidelnicek-mafotografii') == true)) {
                $(this).addClass("browserhighlightrow");
                $(this).css('cursor', 'pointer');
            }
            if (ron.utils.stringToDate($(this).data('jidelnicek-den')) < hodnotitPred) {
                $(this).children(".jidelnicek_hodnoceni").find('span').addClass('hodnocenijidla_hvezda_off_16');
            }
        })
        .on('mouseout', 'tr[data-jidelnicek-id]', function () {
            $(this)
                .removeClass("browserhighlightrow");
            if (($(this).children('td.jidelnicek_hodnoceni').data('aktualni-hodnoceni') === undefined) ||
                (($(this).children('td.jidelnicek_hodnoceni').data('aktualni-hodnoceni') === 0))) {
                $(this).children(".jidelnicek_hodnoceni").find('span').removeClass('hodnocenijidla_hvezda_off_16');
            }
        })
        .on('mouseover mousemove', 'span[data-hodnoceni-polozky]', function () {
            $(this).prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on_16');

            var aktualniHodnoceni = $(this).parent('td').data('aktualni-hodnoceni');
            var id = $(this).parents('tr[data-jidelnicek-id]').data('jidelnicek-id');

            if (aktualniHodnoceni !== 0) {
                $('#jidelnicek_hodnoceni_' + aktualniHodnoceni + '_' + id).prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on_16');
            }
        })
        .on('mouseout', 'span[data-hodnoceni-polozky]', function () {
            $(this).siblings('span').addBack().removeClass('hodnocenijidla_hvezda_on_16');

            var aktualniHodnoceni = $(this).parent('td').data('aktualni-hodnoceni');
            var id = $(this).parents('tr[data-jidelnicek-id]').data('jidelnicek-id');

            if (aktualniHodnoceni !== 0) {
                $('#jidelnicek_hodnoceni_' + aktualniHodnoceni + '_' + id).prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on_16');
            }
        })
    ;
    var
        hodnocenePolozky = $('.jidelnicek td[data-aktualni-hodnoceni]'),
        aktualniHodnoceni = 0;

    $.each(hodnocenePolozky, function (index, item) {
        aktualniHodnoceni = $(item).data('aktualni-hodnoceni');
        $(item)
            .children('span').addClass('hodnocenijidla_hvezda_off_16');
        $(item)
            .children('span[data-hodnoceni-polozky="' + aktualniHodnoceni + '"]').prevAll('span').addBack().addClass('hodnocenijidla_hvezda_on_16');
    });

    if ($jidelnicek.data('zobrazit-dialog') == true) {
        ron.errorsDialog(".errormessages");
    }
});



jidelna.objednejPolozku = function () {
    $(this).parent().submit();
    return false;
};

$(function(){
    $('.jidelnicek').on('click', 'div.jidelnicek_objednat', jidelna.objednejPolozku);
});
(function($) {

    let
        nactenaJidelna = null,
        canceled = false,
        $element = null,
        zDetailu = false;
    function zobrazPrevodObjednavky() {
        let
            jidelna = $element ? $element.data("ron-jidelna") : null;
        if ($element) {
            $("#osoba_objednavky").text($element.data("ron-jmeno"));
            $("#id_polozky_jidelnicku").text($element.data("ron-id-polozky-jidelnicku"));
            $("#popis_objednavky").text($element.data("ron-popis-objednavky"));
            $("#datum_objednavky").text($element.data("ron-datum-objednavky"));
            $("#pocet_objednavek").text("1");
            $("#jidelna_prevod_objednavky").removeClass("hromadne");
        } else {
            $("#pocet_objednavek").text($(".vybrat-radek:checked").length);
            $("#jidelna_prevod_objednavky").addClass("hromadne");
        }

        if (!nactenaJidelna  ||  nactenaJidelna !== jidelna) {
            $("#prevodObjednavkySelectOsoba").ronselect("instance").loadData("?menuid=jidelnaobjednavky&action=seznamosob&jidelna=" + (jidelna ? jidelna : ''), false);
            nactenaJidelna = jidelna;
        }

        $("#jidelna_prevod_objednavky").dialog({
            modal: true,
            width: "auto",
            height: "auto"
        });
    }
    function prevodObjednavky() {
        $element = $(this);
        zDetailu = false;
        zobrazPrevodObjednavky();
        return false;
    }
    function prevodObjednavkyDetail() {
        $element = $(this);
        zDetailu = true;
        zobrazPrevodObjednavky();
    }
    function prevedObjednavku($tr, $element, $callback) {
        let
            novaOsobaIDPP = $('#prevodObjednavkySelectOsoba').val();

        $("#loadingSpinnerPrevodObjednavky").addClass("loading");

        $.ajax({
                url: "?menuid=jidelnaobjednavky&action=prevodobjednavkynaosobu",
                type: "POST",
                data: {
                    cisloObjednavky: $element.data("ron-cislo-objednavky"),
                    novaOsobaIDPP: novaOsobaIDPP,
                    csrfkey: $element.data("csrfkey")
                }
            })
            .done(function (data) {
                $("#loadingSpinnerPrevodObjednavky").removeClass("loading");

                if (data.result === "OK") {
                    if (zDetailu) {
                        window.location = "?menuid=jidelnaobjednavky";
                    } else {
                        $tr.addClass("text-decoration-line-through");
                        $element
                            .hide();
                    }
                } else {
                    ron.showError(data);
                }

                if ($callback) {
                    $callback();
                } else {
                    $("#jidelna_prevod_objednavky").dialog("close");
                }
            }).fail(function (jqXHR) {
                $('#loadingSpinnerPrevodObjednavky').hide();
                ron.showError(ron.translate("Jidelna_chyba_pri_prevodu"));

                if ($callback) {
                    $callback();
                } else {
                    $("#jidelna_prevod_objednavky").dialog("close");
                }
            });

    }
    function onFinish() {
        let $actionInput = $("#objednavky_browseraction");

        $actionInput.val("");
        $actionInput.closest("form").submit();
    }
    function provedPrevodObjednavky() {
        let
            novaOsobaIDPP = $('#prevodObjednavkySelectOsoba').val();

        if (novaOsobaIDPP === undefined || novaOsobaIDPP === '') {
            ron.showError(ron.translate('Jidelna_nezvolen_prijemce_objednavky'));
            return false;
        }

        canceled = false;

        if ($element) {
            if ($element.data("ron-idpp") && $element.data("ron-idpp") === novaOsobaIDPP) {
                ron.showError(ron.translate('Jidelna_opravdu_na_stejnou_osobu'));
                return false;
            }

            prevedObjednavku($element.closest("tr"), $element);
        } else {
            let
                $checkboxy = $(".vybrat-radek:checked"),
                $progressDialog = $("#progress_dialog");


            function prevedDalsiObjednavku(i) {
                let
                    $checkbox = $($checkboxy.get(i)),
                    $tr = $checkbox.closest("tr");

                prevedObjednavku($tr, $checkbox, function() { $progressDialog.progressDialog("step")} );
            }
            $("#jidelna_prevod_objednavky").dialog("close");
            $progressDialog.progressDialog({
                min: 0,
                max: $checkboxy.length - 1,
                onStep: prevedDalsiObjednavku,
                onClose: onFinish
            });
            prevedDalsiObjednavku(0);
        }
    }
    function prevestObjednavkyHromadne() {
        $element = null;
        zobrazPrevodObjednavky();
    }

    $(function() {
        $("body")
            .on("click", ".objednavku-prevest", prevodObjednavky)
            .on("click", "#jidelnaprevestobjednavkupresdetail", prevodObjednavkyDetail)
            .on("click", "#btn_prevest_objednavku", provedPrevodObjednavky);

        $("#browserjidelnaobjednavky_buttons")
            .on("click", "#button_provest_prevedeni", prevestObjednavkyHromadne);
    })

})(jQuery);
(function($) {
    function nastavButton($deleteButton, $OK) {
        $deleteButton
            .removeClass("fa-spin glyph-spinner");

        if ($OK) {
            $deleteButton
                .removeClass("glyph-button")
                .addClass("glyph-slash")
                .attr("title", ron._("Jidelna_zruseni_objednavky"));
        } else {
            $deleteButton
                .addClass("glyph-delete zrusit-objednavku")
                .attr("title", $deleteButton.data("original-title"))
        }
    }
    function provedZruseniObjednavky($row, $deleteButton, $callback)
    {
        if ($deleteButton) {
            $deleteButton
                .data("original-title", $deleteButton.attr("title"))
                .attr("title", ron._("Jidelna_odstranuji_objednavku"))
                .removeClass("glyph-delete zrusit-objednavku")
                .addClass("fa-spin glyph-spinner");
        }

        let
            data = {
                idObjednavky: $row.data("id-objednavky"),
                csrfkey: $deleteButton.data("csrfkey")
            };

        $.ajax({
            url: "?menuid=jidelnaobjednavky&action=delete",
            method: "POST",
            data: data
        }).done(function(data) {
            let OK = true;

            if (data.result === "error") {
                ron.showError(data);
                OK = false;
            } else {
                $row.addClass("zrusena-objednavka");
            }

            if ($deleteButton) {
                nastavButton($deleteButton, OK);
            }

            if ($callback) {
                $callback(OK);
            }
        }).fail(function(jqXHR) {
            if ($deleteButton) {
                nastavButton($deleteButton, false);
            }

            ron.showAjaxError(jqXHR);
            if ($callback) {
                $callback(false);
            }
        });
    }
    function zrusitPolozkuJidelnickuClick()
    {
        let
            $this = $(this);
        function provedZruseni() {
            provedZruseniObjednavky($this.closest("tr"), $this, null);
        }

        ron.confirm(ron._("Jidelna_zrusit_objednavku_potvrzeni"), provedZruseni, this);
    }
    function onFinish() {
        let $actionInput = $("#objednavky_browseraction");

        $actionInput.val("");
        $actionInput.closest("form").submit();
    }
    function zrusitObjednavkyHromadne() {
        let
            $checkboxy = $(".vybrat-radek:checked"),
            $progressDialog = $("#progress_dialog");
        function zrusObjednavku(i) {
            let $tr = $($checkboxy.get(i)).closest("tr");

            provedZruseniObjednavky($tr,
                $tr.find(".zrusit-objednavku"),
                function() { $progressDialog.progressDialog("step"); }
            );
        }

        function zrusVybraneObjednavky() {
            $progressDialog.progressDialog({
                min: 0,
                max: $checkboxy.length - 1,
                onStep: zrusObjednavku,
                onClose: onFinish
            });

            zrusObjednavku(0);
        }

        if (!$checkboxy.length) {
            ron.showError(ron._("Neni_vybrana_zadna_objednavka"));
            return;
        }

        ron.confirm(ron._("Jidelna_zrusit_objednavky_hromadne_potvrzeni"), zrusVybraneObjednavky, this);
    }


    $(function() {
        $("#browserjidelnaobjednavky")
            .on("click", ".zrusit-objednavku", zrusitPolozkuJidelnickuClick);

        $("#browserjidelnaobjednavky_buttons")
            .on("click", "#button_provest_zruseni", zrusitObjednavkyHromadne)
    });
})(jQuery);
(function($) {
    function vlozObjednavkuDoBurzy($row, $actionButton, $callback)
    {

        let
            data = {
                idObjednavky: $row.data("id-objednavky"),
                csrfkey: $actionButton.data("csrfkey")
            };

        $.ajax({
            url: "?menuid=jidelnaobjednavky&action=doburzy",
            method: "POST",
            data: data
        }).done(function(data) {
            let OK = true;

            if (data.result === "error") {
                ron.showError(data);
                OK = false;
            } else {
                $row.find('.cas-vlozeni-na-burzu').text(data.datumCasVlozeniNaBurzu);
                $actionButton.hide();
            }

            if ($callback) {
                $callback(OK);
            }
        }).fail(function(jqXHR) {
            ron.showAjaxError(jqXHR);
            if ($callback) {
                $callback(false);
            }
        });
    }


    function objednavkaDoBurzyClick() {
        let
            $this = $(this);
        function vlozDoBurzy() {
            vlozObjednavkuDoBurzy($this.closest("tr"), $this, null);
        }

        ron.confirm(ron._("Jidelna_objednavka_do_burzy_potvrzeni"), vlozDoBurzy, this);
        return false;
    }
    function onFinish() {
        let $actionInput = $("#objednavky_browseraction");

        $actionInput.val("");
        $actionInput.closest("form").submit();
    }
    function objednavkyDoBurzyHromadne() {
        let
            $checkboxy = $(".vybrat-radek:checked"),
            $progressDialog = $("#progress_dialog");
        function prevedObjednavku(i) {

            let
                $checkbox = $($checkboxy.get(i)),
                $tr = $checkbox.closest("tr");

            vlozObjednavkuDoBurzy($tr, $checkbox,
                function() { $progressDialog.progressDialog("step"); }
            );
        }

        function prevedVybraneObjednavky() {
            $progressDialog.progressDialog({
                min: 0,
                max: $checkboxy.length - 1,
                onStep: prevedObjednavku,
                onClose: onFinish
            });

            prevedObjednavku(0);
        }

        if (!$checkboxy.length) {
            ron.showError(ron._("Neni_vybrana_zadna_objednavka"));
            return;
        }

        ron.confirm(ron._("Jidelna_objednavky_do_burzy_hromadne_potvrzeni"), prevedVybraneObjednavky, this);
    }

    $(function() {
        $("#browserjidelnaobjednavky")
            .on("click", ".objednavka-do-burzy", objednavkaDoBurzyClick);

        $("#browserjidelnaobjednavky_buttons")
            .on("click", "#button_provest_doburzy", objednavkyDoBurzyHromadne)
    });
})(jQuery);
