<?php

/**
 * UTF8
 * Funkce pro stare XML formulare. Nepouzivat!
 */

//require_once('adsapp/rozdeleni.php');

/* @var \RonPortal\XML\RonPortalXMLForm $xmlform   aktualni instance xml formulare*/
global $xmlform;


/**
 * @param $mode
 * @return bool
 * @deprecated
 */
function questform_mode($mode)
{
    global $xmlform;
    $xmlform ->mode = $mode;

    return !$mode;
}

/**
 * @param $neukladat
 * @param $verze
 * @return string
 * @deprecated
 */
function questform_initformular($neukladat, $verze)
{
    global $xmlform;
    $xmlform ->neukladat = $neukladat;
    $xmlform ->verze = (int)$verze;

    if ($xmlform ->neukladat == 2  && isset($_POST['xmlformpost'])  &&  (int)$_POST['xmlformpost']) {
        // u nevyplnovaciho formulare, ktery ma neukladat="2" pouzije post, pokud byl formular odeslan
        $xmlform ->usePostValues = true;
    }

    return '';
}

/**
 * @return string
 * @deprecated
 */
function questform_xmlformaction()
{
    global $xmlform;
    if ($xmlform ->neukladat == 2) {
        return '?menuid=vyplnitdotaznik&record=' . $xmlform ->idSablony;
    }

    return '?menuid=ulozxmlformular';
}


/**
 * Pridani chybove hlasky do formulare
 * @param $fieldname
 * @param $text
 * @return string
 * @deprecated
 */
function questform_error($fieldname, $text) // OK
{
    global $xmlform;

    $text = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($text), false);
    $fieldname = $xmlform->nahradPromenne($fieldname, false);

    $xmlform->addErrorMsg($text, $fieldname);

    return '';
}



/**
 * Zobrazeni chybove hlasky
 * @param $fieldname
 * @param $text
 * @param bool|true $convert
 * @return DOMDocument
 * @deprecated
 */
function questform_showerror($fieldname, $text, $convert = true)
{
    global $xmlform;

    if ($convert) $text = \Ron\StringUtils::fromUTF8($text);
    $text = $xmlform->nahradPromenne($text, false);

    $xmlform->addErrorMsg($text, $fieldname);
    return questform_xmlresult('<DIV class="errortext_xsl">' . $text . '</DIV>', false); // $createrootelement = false
}


/**
 * vraci true, pokud jeste v dokumentu nebyla zadna sekce, jinak false
 * zaroven zaznamena, ze uz v dokumentu byla sekce - takze pri dalsim volani uz bude vracet false
 * @return bool
 * @deprecated
 */
function questform_sekce()
{
    global $xmlform;
    $result = $xmlform -> prvniSekce;

    $xmlform -> viceSekci = !($xmlform -> prvniSekce);
    $xmlform -> prvniSekce = false;

    return $result;
}


/**
 * formatuje sql hodnotu na text, ale pro timestamp vraci cislo!
 * @param \Ron\DB\Database $database
 * @param $format
 * @param $value
 * @return null|string
 * @deprecated
 */
function xmlform_formatsqlvalue($database, $format, $value)
{
    switch ($format) {
        case 'timestamp' :
            return isset($value) ? $database ->stringToTimestamp($value) : '';

        default :
            return \Ron\DB\DBUtils::getFormatedValue($database, $format, $value);
    }
}


/**
 * @param $format
 * @param $value
 * @return null|string
 * @deprecated
 */
function questform_format($format, $value)
{
    global $xmlform;
    return xmlform_formatsqlvalue($xmlform ->database, $format, $value);
}



/**
 * Vraci zadany retezec jako XML dokument - doplni do nej potrebne nalezitosti (hlavicka, korenovy element)
 * pokud je createrootelement = true, tak vysledek "obali" do korenoveho elementu XMLRESULT
 * pokud je false, tak neobaluje, ale v tom pripade musi vysledek obsahovat prave jeden korenovy element!
 * @param $strresult
 * @param bool|true $createrootelement
 * @param bool|false $cdata
 * @return DOMDocument
 * @deprecated
 */
function questform_xmlresult($strresult, $createrootelement = true, $cdata = false)
{
    $result =
        '<?xml version="1.0" encoding="windows-1250"?>';   // <? --

    if ($createrootelement) $result .= '<XMLRESULT>';
    if ($cdata) $result .= '<![CDATA[';

    $result .= $strresult;

    if ($cdata) $result .= ']]>';
    if ($createrootelement) $result .= '</XMLRESULT>';

    $dom = new DOMDocument();
    $dom -> loadXML($result);
    return $dom;
    //return $dom -> documentElement -> childNodes -> item(0);
    //return $dom -> childNodes -> item(0) -> childNodes;
}


/**
 * @param $text
 * @return string
 * @deprecated
 */
function questform_convert($text)
{
    return \Ron\StringUtils::xmlTextConvert($text);
}


/**
 * Vlozi do formulare pole pro nasledne pouziti pri submitu
 * @return bool
 * @deprecated
 */
function questform_use_postvalues()
{
    global $xmlform;

    return $xmlform -> usePostValues;
}


/**
 * @param $value
 * @deprecated
 */
function questform_setusepostvalues($value)
{
    global $xmlform;
    $xmlform ->addDebugMessage("Nastavuji USEPOSTVALUES na $value");
    $xmlform -> usePostValues = $value;
}



/**
 * Vlozi do formulare pole pro nasledne pouziti pri submitu
 * @return DOMDocument
 * @deprecated
 */
function questform_formfields() // OK
{
    global $xmlform;

    if ( $xmlform -> readOnly ) return questform_xmlresult('', true);

    $neukladatvalue = $xmlform -> neukladat ? '1' : '0'; // Parametr neukladat urcuje, jestli se jedna o nevyplnovaci formular

    return questform_xmlresult(
        "<INPUT type='hidden' name='id' value='{$xmlform -> id}'/>".
        "<INPUT type='hidden' name='idsablony' value='{$xmlform -> idSablony}'/>".
        //"<INPUT type='hidden' name='typdotazniku' value='{$xmlform -> f_typ}'/>".
        "<INPUT type='hidden' name='xmlformpost' value='1'/>". // priznak, ze byl formular odeslan POSTem
        "<INPUT type='hidden' name='formaction' value=''/>".
        "<INPUT type='hidden' name='xmlaction' value=''/>".    // xml akce - naplni se pri stisku buttonu
        "<INPUT type='hidden' name='neukladat' value='$neukladatvalue'/>", // priznak, jestli se jedna o nevyplnovaci formular
        true
      );
}


/**
 * @param $text
 * @return string
 * @deprecated
 */
function questform_infomsg($text)
{
    global $xmlform;

    $text = $xmlform -> nahradPromenne( \Ron\StringUtils::fromUTF8($text), false );
    \Ron\MessageManager::addInfoMessage($text);

    return '';
}


///**
// * @param $text
// * @return string
// * @deprecated
// */
//function questform_debugmsg($text)
//{
////    if (\Ron\Http\App::getDebugMode()) {
////        global $xmlform;
////
////        $text = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($text), false);
////        $xmlform ->addDebugMessage($text);
////    }
//    return '';
//}


/**
 * Nastavi hodnotu promenne. Pokud jeste neexistuje, tak ji prida.
 * Jmeno promenne je slozene ze zadaneho jmena a sufixu
 * @param $name
 * @param $value
 * @param string $varname_suffix
 * @param null $index
 * @param int $preserveparams
 * @return string
 * @deprecated
 */
function questform_setvariable($name, $value, $varname_suffix = '', $index = null, $preserveparams = 0)
{
    global $xmlform;

    $value = \Ron\StringUtils::fromUTF8($value); // konverze z utf-8 (interne pouzivano v xml) do kodovani Portalu

    $name = $xmlform -> nahradPromenne($name, false); // sqlformatovani = false
    if (isset($index)  &&  $index !== '') $index = $xmlform ->nahradPromenne($index, false);

    if (!$preserveparams  ||  $preserveparams == 'no') $value = $xmlform -> nahradPromenne($value, false);

    if (isset($index)  &&  $index !== '') {
        // pole
        $pole = $xmlform ->getVariableValue($name.$varname_suffix);
        if (is_array($pole)) {
            $pole[$index] = $value;
        }
        else {
            $pole = [$index => $value];
        }

        $xmlform -> setVariable($name.$varname_suffix, $pole);
    } else {
        $xmlform -> setVariable($name.$varname_suffix, $value);
    }

    return '';
}



/**
 * Vraci hodnotu promenne se zadanym jmenem
 * @param $name
 * @param string $varname_suffix
 * @param string $index
 * @param string $format
 * @return string
 * @throws Exception
 * @deprecated
 */
function questform_variablevalue($name, $varname_suffix = '', $index = '', $format = '') // OK
{
    global $xmlform;

    $name = $xmlform->nahradPromenne($name, false); // sql=false
    if (isset($index) && $index !== '') {
        // pole
        $index = $xmlform->nahradPromenne($index, false);

        $pole = $xmlform->getVariableValue($name . $varname_suffix);
        if (!isset($pole)) {
            $val = null;
        } else if (is_array($pole)) {
            $val = $pole[$index];
        } else {
            throw new Exception("Chyba! Promenna {$name}{$varname_suffix} neni pole!");
        }
    } else {
        $val = $xmlform->getVariableValue($name . $varname_suffix);
    }

    if (!isset($val)) return '';

    if ($format) {
        $val = \Ron\DB\DBUtils::getFormatedValue($xmlform->database, $format, $val);
    }

    return \Ron\StringUtils::toUTF8('' . $val);
}


/**
 * Vraci zadany text po nahrazeni promennych - tag <text>
 * @param $text
 * @param $sqlformatovani
 * @return string
 * @deprecated
 */
function questform_replacevariables($text, $sqlformatovani)
{
    global $xmlform;

    $text = \Ron\StringUtils::fromUTF8($text);
    $text = $xmlform -> nahradPromenne($text, 'html');

    return \Ron\StringUtils::toUTF8($text);
}

/**
 * @param $name
 * @param $expression
 * @return string
 * @deprecated
 */
function questform_expression($name, $expression)
{
    global $xmlform;  // pozor, tato promenna se pouziva ve formularich v expression
    $expression = \Ron\StringUtils::fromUTF8($expression);
    $expression = $xmlform->nahradPromenne($expression, false); // sqlformatovani = false

    $name = $xmlform->nahradPromenne($name, false); // sqlformatovani = false

    $xmlform ->addDebugMessage("XMLDebug> Tag expression - vyhodnocuji vyraz ($name): $expression");

    if ($name) {
        $value = null;
        eval('$value = ' . $expression . ';');
        $xmlform->variables[$name] = $value;

        $xmlform ->addDebugMessage("XMLDebug> Tag expression - vysledek: $value");
    } else {
        eval($expression);
    }

    return '';
}


/**
 * @param \Ron\DB\Database $database
 * @param string $sql
 * @param string $errormsg
 * @return \Ron\DB\Cursor
 * @deprecated
 */
function questform_sqlresult_internal($database, $sql, $errormsg = null)
{
    // V SQL dotazu nahradi promenne skutecnymi hodnotami
    global $xmlform;
    $sql = $xmlform -> nahradPromenne($sql, 'sql');

    if ( !$sql ) return false;

    $result = $database ->getSqlResult($sql);

    $xmlform ->addDebugMessage('XMLDebug> '.$sql);

    return $result;
}


/**
 * Pokud je $log = 1, tak zaloguje provedeny sql dotaz a pokud je $log = 2 tak navic zaloguje i nactene hodnoty vsech sloupcu
 * @param $sql
 * @param $format
 * @param $variablename
 * @param int $log
 * @return null|string
 * @throws \Ron\DB\DBException
 * @deprecated
 */
function questform_executesql_internal($sql, $format, $variablename, $log = 0)
{
    global $xmlform;

    $sql = $xmlform->nahradPromenne($sql, 'sql');
    if (\Ron\Http\App::getDebugMode()) $xmlform->addDebugMessage($sql);

    if (!$sql) return null;

    $cursor = $xmlform->database->getSqlResult($sql);

    $result = '';

    $logdata = '';

    if ($row = $cursor->fetch()) {
        $result = xmlform_formatsqlvalue($xmlform ->database, $format, $row[0]);

        if ($log) $logdata .= $result . "\n\n";

        if ($variablename) {
            global $xmlform;

            if (sizeof($row) == 1) {
                // jen jeden prvek => vubec negeneruje pole
                $xmlform->variables[$variablename] = $result;
                if ($log == 2) $logdata .= $variablename . ' = ' . $result . "\n";
            } else {
                // vice prvku
                if ($xmlform->verze > 1) {
                    // verze 2 a vice => pokud ma vysledek vice sloupcu, pouzije pole
                    $pole = array();

                    foreach ($row as $i => $val) {
                        $pole[$i] = $i ? $val : $result; // nulta polozka pole je naformatovana
                        if ($log == 2) $logdata .= $variablename . "[$i] = " . $val . "\n";
                    }

                    $xmlform->variables[$variablename] = $pole;
                } else {
                    // starsi verze => pouzije primo promenne s indexem v nazvu
                    // nastavi hodnotu promennych
                    $xmlform->variables[$variablename] = $result;

                    if ($log == 2) $logdata .= $variablename . ' = ' . $result . "\n";

                    foreach ($row as $i => $val) {
                        $xmlform->variables[$variablename . "[$i]"] = $val;

                        if ($log == 2) $logdata .= $variablename . "[$i] = " . $val . "\n";
                    }
                }
            }
        }
    }

    if ($log) {
        \RonPortal\Log::addRecordToDBLog($xmlform ->database,
            \Ron\DB\SQLUtils::getTableNameFromSQL($sql), \Ron\DB\SQLUtils::getEventTypeFromSQL($sql),
            'XSL XML', $sql . "\n" . $logdata);
    }

    return $result;
}


/**
 * @param $sql
 * @param $format
 * @return string
 * @deprecated
 */
function questform_executesql($sql, $format) // OK
{
    return \Ron\StringUtils::toUTF8(questform_executesql_internal($sql, $format, null)  ); // null => nenastavuje promennou
}


/**
 * @param $name
 * @param $sql
 * @param $sqltextvariable
 * @param $format
 * @param $log
 * @return string
 * @deprecated
 */
function questform_sqlvariable($name, $sql, $sqltextvariable, $format, $log) // OK
{
    global $xmlform;

    $name = $xmlform -> nahradPromenne( $name, false );
    if ($sqltextvariable) $sql = $xmlform -> getVariableValue($sqltextvariable);

    questform_executesql_internal($sql, $format, $name, $log);

    return '';
}


/**
 * @param $tablename
 * @return string
 * @deprecated
 */
function questform_createdbrecord($tablename)
{
    global $xmlform;

    $xmlform -> f_dbzaznam = new \RonPortal\RonPortalDBRecord($xmlform ->database, $tablename, 'XML formular (XSL)');

    return '';
}


/**
 * @return DOMDocument|string
 * @throws Exception
 * @throws \Ron\DB\DBException
 * @deprecated
 */
function questform_editrecord()
{
    global $xmlform;

    if ($xmlform->f_dbzaznam->loadRecord()) {
        try {
            $xmlform->f_dbzaznam->updateRecord();
        } catch (Exception $e) {
            return questform_showerror('', 'Chyba pri editaci zaznamu!', false);
        }
    } else {
        return questform_showerror('', 'Chyba pri nacitani puvodniho zaznamu!', false);
    }

    return '';
}


/**
 * @param $varname
 * @return string
 * @throws Exception
 * @throws \Ron\DB\DBException
 * @deprecated
 */
function questform_loadrecord($varname)
{
    global $xmlform;

    if ($xmlform->f_dbzaznam->loadRecord()) {
        foreach ($xmlform->f_dbzaznam->fields as $field) {
            $xmlform->variables[$varname . '_' . ($field->fieldName)] = $field->originalValue;
        }
    }

    return '';
}


/**
 * @return DOMDocument|string
 * @deprecated
 */
function questform_insertrecord()
{
    global $xmlform;

    try {
        $xmlform->f_dbzaznam->insertRecord();
    } catch (Exception $e) {
        return questform_showerror('', 'Chyba pri vkladani noveho zaznamu!', false);
    }

    return '';
}


/**
 * @return DOMDocument|string
 * @deprecated
 */
function questform_updateorinsertrecord()
{
  global $xmlform;
  
  try {
      $xmlform->f_dbzaznam->updateOrInsert();
  } catch (Exception $e) {
      return questform_showerror('', 'Chyba pri vkladani nebo editaci zaznamu!', false);
  }
  
  return '';
}


/**
 * @return DOMDocument|string
 * @deprecated
 */
function questform_deleterecord()
{
    global $xmlform;

    try {
        $xmlform->f_dbzaznam->deleteRecord();
    } catch (Exception $e) {
        return questform_showerror('', 'Chyba pri ruseni zaznamu!', false);
    }

    return '';
}


/**
 * @param $name
 * @param $format
 * @param $readonly
 * @param $size
 * @param $updatelog
 * @param $value
 * @return string
 * @deprecated
 */
function questform_createrecordfield($name, $format, $readonly, $size, $updatelog, $value)
{
    global $xmlform;

    $value = \Ron\StringUtils::fromUTF8($value);
    $value = $xmlform->nahradPromenne($value, false); // sql formatovani = false

    $field = $xmlform->f_dbzaznam->addField($name, $format, $readonly, $size, $value);

    // priznaky pro logovaci pole (napr. Update_UserName)
    $field->updateLog = $updatelog;

    return '';
}


/**
 * @param $where
 * @return string
 * @deprecated
 */
function questform_recordwhere($where)
{
    global $xmlform;

    $where = \Ron\StringUtils::fromUTF8($where);
    $where = $xmlform->nahradPromenne($where, 'sql'); // sql formatovani = true

    $xmlform->f_dbzaznam->where = $where;

    return '';
}



/**
 * $log = 2 - logovat vzdy, $log = 1 - logovat chyby
 * $varname je (nepovinne) jmeno promenne, ktera se nastavi na hodnotu 0/1 v pripade ne/uspechu
 * @param $to
 * @param $subject
 * @param $text
 * @param $from
 * @param $copyTo
 * @param $log
 * @param $varname
 * @return string
 * @deprecated
 */
function questform_email($to, $subject, $text, $from, $copyTo, $log, $varname)
{
    global $xmlform;

    if ($log === '') $log = 1; // vychozi nastaveni = logovat v pripade chyby

    $to = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($to), false); // sqlformatovani = false
    $subject = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($subject), false);
    $text = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($text), false);
    $from = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($from), false);
    $copyTo = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($copyTo), false);

    $logtext =
        sprintf(\Ron\StringUtils::fromUTF8(
            "Příjemce: %s\n" .
            "Předmět: %s\n" .
            "Odesílatel: %s\n" .
            "Kopie: %s\n" .
            "Text:\n%s"),
            $to, $subject, $from, $copyTo, $text);

    $OK = false;

    if ($to) {
        require_once('ron/mailer.php');
        $eMail = new \Ron\EMail();
        $eMail ->to = $to;
        $eMail ->subject = $subject;
        $eMail ->text = $text;
        $eMail ->from = $from;
        $eMail ->copyTo = $copyTo;

        try {
            \Ron\MailManager::sendMail($eMail);
            $OK = true;
            $errorMsg = null;
        } catch (\Exception $e) {
            $errorMsg = $e ->getMessage();
            $xmlform ->addErrorMsg($errorMsg);
        }

        if ($log == 2 || ($log && !$OK)) {
            \RonPortal\Log::addRecordToLog($xmlform ->database,
                \Ron\StringUtils::fromUTF8( $OK ? 'Odeslání emailu proběhlo úspěšně' : 'Chyba při odesílání emailu' ),
                \Ron\StringUtils::fromUTF8( 'XSL XML formuláře' ),
                ($OK ? '' : "Chyba: $errorMsg\n\n") .
                $logtext
            );
        }
    } else if ($log) {
        \RonPortal\Log::addRecordToLog($xmlform ->database,
            \Ron\StringUtils::fromUTF8('Chyba při odesílání emailu'), \Ron\StringUtils::fromUTF8('XSL XML formuláře'),
            \Ron\StringUtils::fromUTF8("Není zadána adresa příjemce\n\n") . $logtext);
    }

    if ($varname) $xmlform->variables[$varname] = $OK ? 1 : 0;

    return '';
}



/**
 * vraci vysledek true/false - jestli prikaz probehl v poradku nebo ne
 * pouziva se pro UPDATE/INSERT
 * pokud je zadano sqltextvariable, tak se pouzije sql dotaz z hodnoty teto promenne,
 * jinak se pouzije primo zadany SQL dotaz
 * @param $sqltext
 * @param $sqltextvariable
 * @return bool
 * @throws Exception
 * @deprecated
 */
function questform_executesqlaction($sqltext, $sqltextvariable)
{
    global $xmlform;

    $sql = $sqltextvariable
        ? $xmlform->getVariableValue($sqltextvariable)
        : trim($sqltext);

    // V SQL dotazu nahradi promenne skutecnyma hodnotama
    $sql = $xmlform->nahradPromenne($sql, 'sql');

    $xmlform ->database ->sql($sql); // nevraci zadne radky
    \RonPortal\Log::logSQL($xmlform ->database, $sql, 'XSL XMLAkce (' . $xmlform->popis . ')');
    return true;

//    \Ron\RonPortal\Log::addRecordToDBLog($xmlform ->database, \Ron\DB\SQLUtils::getTableNameFromSQL($sql), 'ERROR', 'XSL XMLAkce (' . $xmlform->popis . ')', $sql);
//    $xmlform->addErrorMsg("Chyba v SQL dotazu! \n" . $sql . '<br/>' . $xmlform ->database ->lastErrorText(), '');
//
//    return false;
}


/**
 * @param $description
 * @param $category
 * @param $comment
 * @deprecated
 */
function questform_log($description, $category, $comment)
{
    // konverze znakove sady a doplneni promennych
    global $xmlform;
    $comment = $xmlform -> nahradPromenne( \Ron\StringUtils::fromUTF8($comment), false); // sqlformatovani = false
    $category = $xmlform -> nahradPromenne( \Ron\StringUtils::fromUTF8($category), false);
    $description = $xmlform -> nahradPromenne( \Ron\StringUtils::fromUTF8($description), false);

    \RonPortal\Log::addRecordToLog($xmlform ->database, $description, $category, $comment);
}


/**
 * @param $tablename
 * @param $eventtype
 * @param string $srcdescription
 * @param string $comment
 * @deprecated
 */
function questform_dblog($tablename, $eventtype, $srcdescription = '', $comment ='')
{
    // konverze znakove sady a doplneni promennych
    global $xmlform;
    $srcdescription = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($srcdescription), false); // sqlformatovani = false
    $comment = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($comment), false);

    if (!$srcdescription) {
        $srcdescription = 'XML (XSL)';
    }

    \RonPortal\Log::addRecordToDBLog($xmlform ->database, $tablename, $eventtype, 'XSL ' . $srcdescription, $comment);
}


/**
 * @param $autoSubmit
 * @return string
 * @deprecated
 */
function questform_createadsfilterform($autoSubmit)
{
    global $xmlform;

    $xmlform->ronPortalFilterForm = new \RonPortal\Controls\RonPortalFilterForm($xmlform ->database, 'vyplnitdotaznik&record=' . $xmlform ->idSablony);
    //$xmlform->f_adsfilterform->NastavAkci('?menuid=vyplnitdotaznik&record=' . $xmlform->f_idsablony);

    if ( !isset($autoSubmit)  ||  $autoSubmit === '' ) $xmlform->ronPortalFilterForm->autoSubmit = true; // defaultni hodnota
    else $xmlform->ronPortalFilterForm->autoSubmit = ($autoSubmit == 'no') ? 0 : $autoSubmit;

    \Ron\MessageManager::addWarning('XML formular je zastaraly a v nektere z dalsich verzi Portalu jiz nebude funkcni! Upravte formular a nastavte atribut mode!');
}


/**
 * @param $aplikace
 * @param $jenotevrene
 * @deprecated
 */
function questform_adsfilterform_obdobi($aplikace, $jenotevrene)
{
    global $xmlform;

    $xmlform->ronPortalFilterForm->addFilterObdobi($aplikace);
}


/**
 * vyber pracovniho pomeru podle prav nebo podle predavaciho procesu
 * @param $prava
 * @param $predavaciProces
 * @deprecated
 */
function questform_adsfilterform_osoby($prava, $predavaciProces)
{
    global $xmlform;

    if ($prava) {
        $prava = \RonPortal\Prava::vratPrava($prava);
//        $xmlform->ronPortalFilterForm->nastavOsoby(true, $prava, 0, 0);
        $xmlform->ronPortalFilterForm->addFilterPP(false, $prava);
    } else {
        throw new Exception('XML formular je zastaraly! tag adsfilterform nepodporuje nacitani osob podle procesu! Nastavte mode!');
//        if (!$predavaciProces) $predavaciProces = $xmlform->predavaciProces;
//        $xmlform->ronPortalFilterForm->nastavOsobyDleProcesu(true, $predavaciProces, $xmlform->typRozdeleniProcesu);
    }
}


/**
 * @param $typRozdeleni
 * @param $pouzeVlastni
 * @param $prava
 * @param $filtrRozdeleni
 * @deprecated
 */
function questform_adsfilterform_rozdeleni($typRozdeleni, $pouzeVlastni, $prava, $filtrRozdeleni)
{
    global $xmlform;

    $typRozdeleni = (int)$xmlform->nahradPromenne($typRozdeleni, false);
    //$filtrRozdeleni = $xmlform->nahradPromenne($filtrRozdeleni, 'sql');
    $filtrRozdeleni = null; // 10-2023

    $xmlform ->ronPortalFilterForm ->nastavRozdeleni(true, $typRozdeleni, $pouzeVlastni, $filtrRozdeleni);
    $xmlform->ronPortalFilterForm->showVcetnePodrizenychRozdeleni = false;
    if ($prava) $xmlform ->ronPortalFilterForm ->f_pravarozdeleni = \RonPortal\Prava::vratPrava($prava);
}

/**
 * @param $typRozdeleni
 * @param $pouzeVlastni
 * @param $prava
 * @param $filtrRozdeleni
 * @deprecated
 */
function questform_adsfilterform_rozdeleni2($typRozdeleni, $pouzeVlastni, $prava, $filtrRozdeleni)
{
    global $xmlform;

    $typRozdeleni = (int)$xmlform->nahradPromenne($typRozdeleni, false);
    //$filtrRozdeleni = $xmlform->nahradPromenne($filtrRozdeleni, 'sql');
    $filtrRozdeleni = null; // 10-2023

    if ($typRozdeleni) {
        $f = $xmlform->ronPortalFilterForm->addFilterRozdeleni('rozdeleni2', $typRozdeleni);
        if ($prava) {
            $f ->setPrava(\RonPortal\Prava::vratPrava($prava));
        }
    } else {
        $f = $xmlform ->ronPortalFilterForm ->addFilterRozdeleni2(null, $prava ? \RonPortal\Prava::vratPrava($prava) : null);
    }

    $f->setShowVcetnePodrizenych(false);


//    $xmlform ->ronPortalFilterForm ->nastavRozdeleni2(true, $typRozdeleni, $pouzeVlastni, $filtrRozdeleni);
//    $xmlform->ronPortalFilterForm->showVcetnePodrizenychRozdeleni2 = false;
//    if ($prava) $xmlform ->ronPortalFilterForm ->f_pravarozdeleni = \RonPortal\Prava::vratPrava($prava);
}


/**
 * @return string
 * @throws Exception
 * @deprecated
 */
function questform_adsfilterform()
{
    global $xmlform;

    // zobrazi formular
    $xmlform->ronPortalFilterForm->loadData();
    //$xmlform->ronPortalFilterForm->render();

    // nastavi promenne formulare
    if ($xmlform->ronPortalFilterForm->getFilterValue('obdobi')) {
        $xmlform->nastavObdobiAplikace('OBDOBI', 'ADS', $xmlform->ronPortalFilterForm->getFilterValue('obdobi'));
    }

    //if ($xmlform->ronPortalFilterForm->showRozdeleni) {
    if ($xmlform->ronPortalFilterForm->getFilterValue('rozdeleni')) {
        $xmlform->nastavRozdeleni('ROZDELENI',
            $xmlform->ronPortalFilterForm->getFilterValue('rozdeleni', \RonPortal\Controls\FilterFormFilterRozdeleni::SPEC_TYP_ROZDELENI),
            $xmlform->ronPortalFilterForm->getFilterValue('rozdeleni')
        );
    }

    if ($xmlform->ronPortalFilterForm->getFilterValue('rozdeleni2')) {
        $xmlform->nastavRozdeleni('ROZDELENI2',
            $xmlform->ronPortalFilterForm->getFilterValue('rozdeleni2', \RonPortal\Controls\FilterFormFilterRozdeleni::SPEC_TYP_ROZDELENI),
            $xmlform->ronPortalFilterForm->getFilterValue('rozdeleni2')
        );
    }

//    if ($xmlform->ronPortalFilterForm->showRozdeleni2) {
//        $xmlform ->nastavRozdeleni2('ROZDELENI2', $xmlform->ronPortalFilterForm->kodTypuRozdeleni2, \RonPortal\RonPortalSession::rozdeleni2($xmlform->ronPortalFilterForm->kodTypuRozdeleni2));
//    }

    if ($xmlform->ronPortalFilterForm->getFilterValue('osoba')) {
        $xmlform->nastavPracovniPomer('OSOBA', $xmlform->ronPortalFilterForm->getFilterValue('osoba'));
    }

    $xmlform ->setVariable('adsfilterformsubmit', isset($_POST['adsfilterform']) ? (int)$_POST['adsfilterform'] : 0);

    return '';
}


/**
 * @param $name
 * @return string
 * @deprecated
 */
function questform_createbrowser($name)
{
    global $xmlform;

    $xmlform->f_browser = new \RonPortal\XML\XMLBrowser($xmlform ->database, $xmlform);
    $xmlform->f_browser->name = $name;
    $xmlform->f_browser->cssClass = 'xsl-browser-deprecated background-pink color-silver';

    return '';
}

/**
 * @param $sql
 * @return string
 * @deprecated
 */
function questform_browsersql($sql)
{
    global $xmlform;

    $sql = $xmlform ->nahradPromenne($sql, 'sql');
    $xmlform -> f_browser -> sql = $sql;

    return '';
}

/**
 * @param $index
 * @param $format
 * @param $caption
 * @param $style
 * @param $link
 * @param $text
 * @param $htmlparams
 * @return string
 * @deprecated
 */
function questform_browserfield($index, $format, $caption, $style, $link, $text, $htmlparams)
{
  global $xmlform;

  $field = new \RonPortal\XML\XMLBrowserField($xmlform);
  $field -> type = \Ron\Controls\BrowserField::FIELD_TYPE_DEFAULT;
  $field -> format = $format;
  //$field -> style = $style;
  $field -> sqlFieldIndex = $index;

  $field -> header = $xmlform ->nahradPromenne( \Ron\StringUtils::fromUTF8($caption), false );
  //$field -> f_align = $align;
  
  // v linku a textu se promenne nahradi az pri pouziti!
  //$field -> link = $link; - zruseno 6.9.2023 - deprecated - linky generuji znak &, ktery neni v XSL validni
  $field -> xmlText = \Ron\StringUtils::fromUTF8($text);
  $field -> xmlHTML = $xmlform ->nahradPromenne( \Ron\StringUtils::fromUTF8($htmlparams), false );
  
  $xmlform ->f_browser ->addField($field);

  return '';
}


/**
 * @return DOMDocument
 * @deprecated
 */
function questform_browser()
{
  global $xmlform;

  return questform_xmlresult($xmlform -> f_browser -> getHTML(), false); // $createrootelement = false
}


/**
 * POZOR! Nepouzivat primo v XSL!
 * @param $inline
 * @return string
 * @deprecated
 */
function questform_getlogname($inline)
{
  if ($inline) $result = '<span ';
  else $result = '<div ';
  
  $result .= ' class="dotaznik_jmeno_xsl">'.date('j.n.Y G:i', time()).' - '.questform_convert(\RonPortal\User::getUserName()).': ';
  
  if ($inline) $result .= '</span>';
  else $result .= '</div>';
  
  return $result;
}

/**
 * Parametr format je nepovinny. Pokud je zadan, tak se zkontroluje zadana hodnota.
 * @param $name
 * @param string $format
 * @param int $required
 * @return string
 * @deprecated
 */
function questform_postvalue($name, $format = '', $required = 0)
{
    global $xmlform;

    $name = $xmlform->nahradPromenne($name, false); // sqlformatovani = false
    // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql

    $value = $_POST[$name];

    if ($value == '') {
        if ($required) {
            $xmlform->addErrorMsg(\Ron\ronText('Chybi_povinna_hodnota'), $name);
        }
    } else {
        try {
            switch ($format) {
                case 'date' :
                case 'datetime' :
                    \Ron\DateUtils::datetimeStringToTimestamp($value);
                    break;

                case 'time' :
                    \Ron\DateUtils::timeStringToTimestamp($value);
                    break;

                case 'integer' :
                case 'int' :
                    if (!\Ron\StringUtils::isInteger($value)) {
                        throw new Exception(\Ron\ronText('Bad_number_format'));
                    }
                    break;

                case 'positive' :
                    if (!\Ron\StringUtils::isInteger($value)) {
                        throw new Exception(\Ron\ronText('Bad_number_format'));
                    }
                    if ($value <= 0) {
                        throw new Exception(\Ron\ronText('Cislo_neni_vetsi_nez_0'));
                    }
                    break;

                case 'float' :
                    if (!\Ron\StringUtils::isFloat($value)) {
                        throw new Exception(\Ron\ronText('Bad_number_format'));
                    }
                    break;

                default :
                    //$value = $_POST[$name];
                    break;
            }
        } catch (Exception $e) {
            $xmlform->addErrorMsg($e->getMessage(), $name);
        }
    }

    // nastavi hodnotu promenne
    $xmlform->variables[$name] = $value;

    return \Ron\StringUtils::toUTF8($value);
}


/**
 * nastavi hodnotu promenne a v pripade zadaneho formatu take pripadne dalsi hodnoty
 * @param $name
 * @param $format
 * @param $value
 * @deprecated
 */
function questform_nastavpromennou($name, $format, $value)
{
    global $xmlform;

    $name = $xmlform->nahradPromenne($name, false); // sqlformatovani = false
    // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql

    // nastavi hodnotu promenne
    $xmlform->variables[$name] = $value;

    if (strcmp($value, '')) {
        try {
            switch ($format) {
                case 'date' :
                case 'datetime' :
                    if ($value === '') $xmlform->variables[$name . '_TIMESTAMP'] = null;
                    else {
                        $pomts = \Ron\DateUtils::datetimeStringToTimestamp($value);
                        $xmlform->variables[$name . '_TIMESTAMP'] = $pomts;
                    }
                    break;

                case 'time' :
                    $pomts = \Ron\DateUtils::timeStringToTimestamp($value);
                    $xmlform->variables[$name . '_TIMESTAMP'] = $pomts; // pridat jeste _FLOAT ?
                    break;

                case 'integer' :
                case 'int' :
                    if (!\Ron\StringUtils::isInteger($value)) {
                        throw new Exception(\Ron\ronText('Bad_number_format'));
                    }
                    break;

                case 'positive' :
                    if (!\Ron\StringUtils::isInteger($value)) {
                        throw new Exception(\Ron\ronText('Bad_number_format'));
                    }
                    if ($value <= 0) {
                        throw new Exception(\Ron\ronText('Cislo_neni_vetsi_nez_0'));
                    }
                    break;

                case 'float' :
                    if (!\Ron\StringUtils::isFloat($value)) {
                        throw new Exception('Bad_number_format');
                    }
                    $xmlform->variables[$name . '_FLOAT'] = \Ron\StringUtils::stringToFloat($value);
                    break;

                default :
                    //$value = $_POST[$name];
                    break;
            }
        } catch (Exception $e) {
            $xmlform->addErrorMsg($e->getMessage(), $name);
        }
    }
}


/**
 * @param $name
 * @param $format
 * @param string $htmlname
 * @return null
 * @deprecated
 */
function questform_postvariable($name, $format, $htmlname = '')
{
  global $xmlform;

  $name = $xmlform -> nahradPromenne($name, false); // sqlformatovani = false
     // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql
     
  if ($htmlname) $htmlname = $xmlform -> nahradPromenne($htmlname, false);
  else $htmlname = $name;  

  $value = $_POST[$htmlname];

  questform_nastavpromennou($name, $format, $value);
  
  return null;
}



/**
 * volano z show - zobrazi edit
 * @param $name
 * @param $format
 * @param $required
 * @param $defaultvalue
 * @param $size
 * @param $htmlparams
 * @return DOMDocument
 * @deprecated
 */
function questform_edit($name, $format, $required, $defaultvalue, $size, $htmlparams) // OK
{
    global $xmlform;

    $name = $xmlform->nahradPromenne($name, false); // sqlformatovani = false
    // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql

    $htmlparams = $xmlform->nahradPromenne($htmlparams, false); // sqlformatovani = false

    if ($xmlform->usePostValues && isset($_POST[$name])) {
        if ($format == 'datetime') $value = $_POST[$name] . ' ' . $_POST[$name . '_time'];
        else $value = $_POST[$name];
    } else {
        $value = \Ron\StringUtils::fromUTF8($defaultvalue);
        // nahradi promenne - aby bylo mozno napr. prednastavit aktualni cas
        global $xmlform;
        $value = $xmlform->nahradPromenne($value, false); // sqlformatovani = false
    }

    questform_nastavpromennou($name, $format, $value);


    $className = $xmlform->isError($name) ? 'dotaznik_errinput' : 'app_input';

    $size = $xmlform->nahradPromenne($size, false);

    $sizestr = '';
    if ($size) if ((int)$size > 0) $sizestr = 'size="' . (int)$size . '"';

    if ($xmlform->readOnly && strpos($htmlparams, 'readonly') === false) $readonlystr = ' readonly="readonly" ';
    else $readonlystr = '';

    switch ($format) {
        case 'float' :
            $className .= ' inputFloat';
            break;

        case 'int' :
        case 'integer' :
        case 'positive' :
            $className .= ' inputInt';
            break;

        case 'time' :
            if (!$sizestr) $sizestr = 'size="5"';
            $className .= ' inputTime';
            break;

        case 'date' :
            return
                questform_xmlresult(
                    '<SPAN>' .
                    '<input type="text" name="' . $name . '" class="' . $className . ' inputDate" maxlength="10" size="10" value="' . $value . '" ' . $htmlparams . '/>' .
                    '<img src="images/16_calendar.png" class="showcalendar" data-roncalendar-inputname="' . $name . '" />' .
                    '</SPAN>', false);

        case 'datetime' :
            $poma = explode(' ', $value);
            return
                questform_xmlresult(
                    '<span>' .
                    '<input type="text" name="' . $name . '" class="' . $className . ' inputDate" maxlength="10" size="10" value="' . $poma[0] . '" ' . $htmlparams . '/>' .
                    '<img src="images/16_calendar.png" class="showcalendar" data-roncalendar-inputname="' . $name . '" />' .
                    '<input type="text" name="' . $name . '_time" class="' . $className . ' inputTime" ' . $readonlystr . ' size="5" value="' . $poma[1] . '" ' . $htmlparams . '/>' .
                    '</span>', false);
    }

    return questform_xmlresult(
        '<INPUT type="text" name="' . $name . '" class="' . $className . '" ' . $readonlystr . ' ' . $sizestr . ' value="' . questform_convert($value) . '" ' . $htmlparams . '/>',
        false); // createrootelement = false

}


/**
 * volano pri fill - zpracuje edit (zkontroluje zadanou hodnotu atd.)
 * @param $name
 * @param $format
 * @param $required
 * @param $editing
 * @param $size
 * @param $defaultvalue
 * @param $htmlparams
 * @return DOMDocument
 * @deprecated
 */
function questform_postedit($name, $format, $required, $editing, $size, $defaultvalue, $htmlparams)
{
  // editing: append - vzdy nabidne puvodni hodnotu, yes - edituje se posledni zadana hodnota, no - bez editace
  global $xmlform;

  $name = $xmlform -> nahradPromenne($name, false); // sqlformatovani = false
     // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql

//  $htmlparams = $xmlform -> NahradPromenne($htmlparams, false); // sqlformatovani = false
     // nahracit promenne nebo ne ?
     
  $defaultvalue = \Ron\StringUtils::fromUTF8($defaultvalue);
  
  if ($format == 'datetime')
  {
    $value = '';

    if (  $_POST[$name] != ''  &&  $_POST[$name.'_time'] == '') $value = $_POST[$name].' 00:00'; // neni zadan cas - doplni 0
    else if ( $_POST[$name] == ''  &&  $_POST[$name.'_time'] != '') $xmlform -> addErrorMsg( \Ron\ronText('Bad_date_format'), $name ); // neni zadan datum
    else if ( $_POST[$name] != '' ) $value = $_POST[$name].' '.$_POST[$name.'_time'];
  }
  else
  {
    $value = $_POST[$name];
  }  

  if ( $value == '')
  {
    if ($required  &&  $required != 'no') 
    {
    	$xmlform -> addErrorMsg( \Ron\ronText('Chybi_povinna_hodnota'), $name );
    }
  }
  

  $newdefaultvalue = $defaultvalue;
  $showedit = true; 
  $logvalue = true;
  
  // nastavi hodnotu promenne
  //$xmlform -> f_promenne[$name] = $value;
  questform_nastavpromennou($name, $format, $value);

  $value = questform_convert($value); // odstrani < > & a podobne

  if ( $editing == 'append' )
  {
    // pridava se dalsi text, vychozi hodnota je porad stejna jako v sablone
    if ($value == '') $logvalue = false;
    else if ( !strcmp($value, $defaultvalue) ) $logvalue = false;
      // neni co logovat (byla zadana prazdna nebo vychozi hodnota)
      
    $newdefaultvalue = $defaultvalue;
  }
  else if ( $editing == 'yes' )
  {
    $logvalue = ( strcmp($value, $defaultvalue) ); // loguje v pripade zmeny
    $newdefaultvalue = $value;
  }
  else if ( $editing == 'nolog' )
  {
    // editace je povolena a zadana hodnota se neloguje
    $logvalue = false;
    $newdefaultvalue = $value;
  }
  else
  {
    $showedit = false;
    $logvalue = false;
      // needitovatelne pole netreba logovat
  }

  // nastavi hodnotu promenne
  $xmlform -> variables[$name] = $value;

  $value = questform_convert($value); // nahradi znaky <, > a podobne

  $result = '';
  
  if ($logvalue)
      $result .=
        '<posledniodpoved>'.
        questform_getlogname(true). // inline = true
        $value.
        '</posledniodpoved>';
        
  if ($showedit)
  {
      $result .= 
        "<edit name='$name' editing='$editing' format='$format' required='$required' size='$size' htmlparams='".questform_convert($htmlparams)."'>".
        $newdefaultvalue.
        '</edit>';
  }
  else
  {
    if ( $format == 'date'  ||  $format == 'datetime'  ||  $format == 'time' )
      $result .=
        "<variable name='{$name}_TIMESTAMP' value='".$xmlform -> variables[$name.'_TIMESTAMP']."'/>";
    
    $result .=
       "<variable name='$name' value='$value'/>".
       '<div class="dotaznik_odpoved">'.$value.'</div>';
  }

  return questform_xmlresult($result, true ); // createrootelement = true
}


/**
 * @param $name
 * @return DOMDocument
 * @deprecated
 */
//function questform_calendarbutton($name)
//{
//    // ... bude odstraneno
//  global $xmlform;
//  $name = $xmlform -> nahradPromenne($name, false); // sqlformatovani = false
//     // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql
//
//  return questform_xmlresult(
//    calendarbutton($name, false),
//    false );
//}



/**
 * volano z show - zobrazi hidden pole
 * @param $name
 * @param $value
 * @param $format
 * @return DOMDocument
 * @deprecated
 */
function questform_hidden($name, $value, $format) // OK
{
    global $xmlform;

    $name = $xmlform -> nahradPromenne($name, false); // sqlformatovani = false
    // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql

    if ($xmlform -> usePostValues) {
        $value = $_POST[$name];
    } else {
        $value = \Ron\StringUtils::fromUTF8($value);
        // nahradi promenne - aby bylo mozno napr. prednastavit aktualni cas
        global $xmlform;
        $value = $xmlform -> nahradPromenne($value, false); // sqlformatovani = false
    }

    questform_nastavpromennou($name, $format, $value);

    return questform_xmlresult(
        '<INPUT type="hidden" name="'.$name.'" value="'.questform_convert($value).'" />',
        false ); // createrootelement = false
}


/**
 * @param $name
 * @param $checked
 * @param $htmlparams
 * @return DOMDocument
 * @deprecated
 */
function questform_checkbox($name, $checked, $htmlparams) // OK
{
    global $xmlform;

    $name = $xmlform->nahradPromenne($name, false); // sqlformatovani = false
    // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql

    $checked = $xmlform->nahradPromenne($checked, false); // sqlformatovani = false
    $htmlparams = $xmlform->nahradPromenne($htmlparams, false); // sqlformatovani = false

    $checkedstr = '';
    if ($xmlform ->usePostValues) {
        if ($_POST[$name]) $checked = $_POST[$name];
        else $checked = 0;
    }

    if ($checked) {
        $xmlform->variables[$name] = 1;
        $checkedstr = 'checked="checked"';
    } else {
        $xmlform->variables[$name] = 0;
        $checkedstr = '';
    }

    return questform_xmlresult(
        '<INPUT type="checkbox" name="' . $name . '" ' . $checkedstr . ' ' . $htmlparams . '/>',
        false);
}


/**
 * @param $name
 * @return string
 * @deprecated
 */
function questform_checkpostvalue($name)
{
  global $xmlform;

  $name = $xmlform -> nahradPromenne($name, false); // sqlformatovani = false
     // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql

  if ( $_POST[$name] )
  {
    $xmlform -> variables[$name] = 1;
    return 'checked';
  }
  else
  {
    $xmlform -> variables[$name] = 0;
    return '';
  }
}


/**
 * @param $name
 * @param $value
 * @param $checked
 * @param $htmlparams
 * @return DOMDocument
 * @deprecated
 */
function questform_radio($name, $value, $checked, $htmlparams) // OK
{
    // checked urcuje vychozi hodnotu

    global $xmlform;


    $name = $xmlform->nahradPromenne($name, false); // sqlformatovani = false
    // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql

    $value = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($value), false); // sqlformatovani = false
    $checked = $xmlform->nahradPromenne($checked, false); // sqlformatovani = false
    $htmlparams = $xmlform->nahradPromenne($htmlparams, false); // sqlformatovani = false

    $checkedstr = '';
    if ($xmlform->usePostValues) {
        if ($_POST[$name] == $value) $checked = 1;
        else $checked = 0;
    }

    if ($checked) {
        $xmlform->variables[$name] = $value;
        $checkedstr = 'checked="checked"';
    } else {
        //$xmlform -> f_promenne[$name] = 0; -- nemeni hodnotu promenne (muze byt zmenena u jineho radiobuttonku)
        $checkedstr = '';
    }

    return questform_xmlresult(
        '<INPUT type="radio" name="' . $name . '" value="' . questform_convert($value) . '" ' . $checkedstr . ' ' . $htmlparams . '/>',
        false);
}


/**
 * @param $name
 * @return string
 * @deprecated
 */
function questform_radiopostvalue($name)
{
  global $xmlform;
  
  $name = $xmlform -> nahradPromenne($name, false); // sqlformatovani = false
     // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql
     
  $value = $_POST[$name];
  $xmlform -> variables[$name] = $value;

  return \Ron\StringUtils::toUTF8($value);
}





/**
 * zobrazeni editu
 * @param $name
 * @param $rows
 * @param $cols
 * @param $value
 * @return DOMDocument
 * @deprecated
 */
function questform_memo($name, $rows, $cols, $value) // OK
{
  global $xmlform;

  $name = $xmlform -> nahradPromenne($name, false); // sqlformatovani = false
     // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql

  if ($xmlform -> usePostValues) {
      $value = $_POST[$name];
  } else {
    $value = \Ron\StringUtils::fromUTF8($value);
    // nahradi promenne - aby bylo mozno napr doplnit cas, jmeno uzivatele a podobne
    $value = $xmlform -> nahradPromenne($value, false); // sqlformatovani = false
  }

  $xmlform -> variables[$name] = $value;

  if ( !$cols ) $cols = 20; // zmena - pro upozorneni na stary XSL formular
  if ( !$rows ) $rows = 5;

  return questform_xmlresult(
    //'<TEXTAREA cols="'.$cols.'" rows="'.$rows.'" name="'.$name.'" wrap="virtual">'.
    '<TEXTAREA name="'.$name.'" wrap="virtual">'.
    questform_convert($value). // nahradi & < > a podobne
    '</TEXTAREA>', false ); // createrootelement = false
}



/**
 * zpracovani tagu memo - nastavi promennou, vraci novy tag (vyplneny/nahrazeny)
 * @param $name
 * @param $editing
 * @param $rows
 * @param $cols
 * @param $defaultvalue
 * @return DOMDocument
 * @deprecated
 */
function questform_postmemo($name, $editing, $rows, $cols, $defaultvalue)
{
  // editing: append - vzdy nabidne puvodni hodnotu, yes - edituje se posledni zadana hodnota, no - bez editace
  global $xmlform;

  $name = $xmlform -> nahradPromenne($name, false); // sqlformatovani = false
     // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql

  $value = $_POST[$name];
  $value = str_replace ("\r\n", "\n", $value ); 
      // z formulare prijde jiny konec radku nez z xml v $defaultvalue!
      // musi se to sjednotit, aby potom fungovalo porovnavani
  $defaultvalue = \Ron\StringUtils::fromUTF8($defaultvalue);

  $newdefaultvalue = $defaultvalue;
  $showedit = true; 
  $logvalue = true;
  
  if ( $editing == 'append' )
  {
    // pridava se dalsi text, vychozi hodnota je porad stejna jako v sablone
    if ($value == '') $logvalue = false;
    else if ( !strcmp($value, $defaultvalue) ) $logvalue = false;
      // neni co logovat (byla zadana prazdna nebo vychozi hodnota)
      
    $newdefaultvalue = $defaultvalue; // zustava puvodni vychozi hodnota
  }
  else if ( $editing == 'yes' )
  {
    $logvalue = ( strcmp($value, $defaultvalue) ); // loguje pouze v pripade zmeny
    $newdefaultvalue = $value; // nova vychozi hodnota
  }
  else if ( $editing == "nolog" )
  {
    // editace je povolena a zadana hodnota se neloguje
    $logvalue = false;
    $newdefaultvalue = $value;
  }
  else
  {
    $showedit = false;
    $logvalue = false;
      // needitovatelne pole netreba logovat
  }  

  // nastavi hodnotu promenne
  $xmlform -> variables[$name] = $value;

  $value = questform_convert($value); // nahradi znaky <, > a podobne

  $result = '';
  
  if ($logvalue)
      $result .=
        questform_getlogname(false). // inline = false
        "<posledniodpoved>".
        str_replace ("\n", "<BR/>", $value ).
        "</posledniodpoved>\n";
        
  if ($showedit)
  {
      $result .= 
        "<memo name='$name' editing='$editing' cols='$cols' rows='$rows'>".
        questform_convert($newdefaultvalue).
        '</memo>';
  }
  else
  {
    $result .=
       "<longvariable name='$name'>".
       $value.
       '</longvariable>'.
       '<div class="dotaznik_odpoved">'.str_replace ("\n", "<BR/>", $value ).'</div>';
  }
  
  return questform_xmlresult($result, true); // createrootelement = true
}


/**
 * nahradi konce radku znackou <BR/>
 * @param $name
 * @return DOMDocument
 * @deprecated
 */
function questform_postmemovalue($name)
{
  // nastavi hodnotu promenne
  global $xmlform;

  $name = $xmlform -> nahradPromenne($name, false); // sqlformatovani = false
     // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql

  $value = $_POST[$name];
  $xmlform -> variables[$name] = $value;

  $result = $value;
//  $result = str_replace ('<', '&lt;', $result);
//  $result = str_replace ('>', '&gt;', $result);

  $result = str_replace ("\n", "<BR/>", $result );

  // vysledek musi vracet jako XML result, protoze jinak vklada do textu konce radku jako text "<br/>"
  // nedela konverzi znakove sady, protoze vysledek se vraci jako XML
  return questform_xmlresult( $result, true, true ); // createrootelement = true, cdata = true
}


/**
 * Zobrazi combobox ze zadaneho sql dotazu. $value je prednastavena hodnota - OK
 * @param $name
 * @param $sql
 * @param $sqltextvariable
 * @param $format
 * @param $value
 * @param $required
 * @param bool|false $showcode
 * @param string $htmlparams
 * @return DOMDocument
 * @throws \Ron\DB\DBException
 * @deprecated
 */
function questform_sqlselect($name, $sql, $sqltextvariable, $format, $value, $required, $showcode = false, $htmlparams = '')
{
    $result = '';

    // doplni do dotazu promenne (parametry)
    global $xmlform;

    $name = $xmlform ->nahradPromenne($name, false); // sqlformatovani = false
    // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql
    $htmlparams = $xmlform ->nahradPromenne($htmlparams, false); // sqlformatovani = false

    if ($sqltextvariable) $sql = $xmlform ->getVariableValue($sqltextvariable);
    $sql = $xmlform ->nahradPromenne($sql, 'sql');

    if ($xmlform ->usePostValues) {
        $value = $_POST[$name];
    } else {
        $value = \Ron\StringUtils::fromUTF8($value);
        $value = $xmlform ->nahradPromenne($value, false); // sql formatovani = false
    }

    $xmlform ->addDebugMessage("tag sqlselect, name: $name, sql: $sql", true);

    $cursor = $xmlform ->database ->getSqlResult($sql);

    //if ( in_array($name, $xmlform -> f_errorfields) ) $classstr = 'class="dotaznik_errinput"';
    $classstr = $xmlform ->isError($name) ? 'class="dotaznik_errinput"' : '';

    $result .= '<SELECT name="' . $name . '" ' . $classstr . ' ' . $htmlparams . '>';

    if (!$value || !$required) // pokud jeste nebyla zadana hodnota nebo pole neni povinne, prida prazdnou hodnotu
    {
        $selectedstr = !$value ? 'selected="selected"' : '';
        $result .= "<OPTION value='' $selectedstr></OPTION> ";
    }

    while ($row = $cursor ->fetch()) {
        $rowval = xmlform_formatsqlvalue($xmlform ->database, $format, $row[0]);
        // formatovatni (format timestamp na cislo, ostatni standardne na retezec

        if ($rowval == $value) {
            $selectedstr = 'selected="selected"';
            $xmlform ->variables[$name] = $rowval;
            $xmlform ->variables[$name . '_text'] = $row[1];
        } else {
            $selectedstr = '';
        }

        $text = questform_convert($row[1]);
        $code = questform_convert($rowval);
        if ($showcode) $text .= ' (' . $code . ')';
        $result .= "<OPTION value='$code' $selectedstr>$text</OPTION> ";
    }

    $result .= '</SELECT>';

    return questform_xmlresult($result, false); // createrootelement=false
}


/**
 * @param $name
 * @param $sqltext
 * @param $sqltextvariable
 * @param $format
 * @param $editing
 * @param $required
 * @param $showcode
 * @param $htmlparams
 * @return DOMDocument
 * @throws \Ron\DB\DBException
 * @deprecated
 */
function questform_sqlselectpost($name, $sqltext, $sqltextvariable, $format, $editing, $required, $showcode, $htmlparams)
{
    global $xmlform;

    $name = $xmlform->nahradPromenne($name, false); // sqlformatovani = false
    // nahradi promenne i ve jmene, aby slo napriklad pouzit ve forsql

    $htmlparams = $xmlform->nahradPromenne($htmlparams, false); // sqlformatovani = false

    if ($required && $_POST[$name] == '') {
        $xmlform->addErrorMsg(\Ron\ronText('Chybi_povinna_hodnota'), $name);
    }

    $sql = $sqltextvariable
        ? $xmlform->getVariableValue($sqltextvariable)
        : $sqltext;

    // doplni do dotazu promenne (parametry)
    $sql = $xmlform->nahradPromenne($sql, 'sql');

    $xmlform ->addDebugMessage('XMLDebug> sqlselect: ' . $sql, true);

    $cursor = $xmlform ->database ->getSqlResult($sql);

    $found = false;

    $kod = '';
    $popis = '';

    while (!$found && $row = $cursor ->fetch()) {
        $rowval = xmlform_formatsqlvalue($xmlform->database, $format, $row[0]);

        if ($rowval == $_POST[$name]) {
            $kod = $rowval;
            $popis = $row[1];
            $xmlform->variables[$name] = $kod;
            $xmlform->variables[$name . '_text'] = $popis;

            $kod = questform_convert($kod);
            $popis = questform_convert($popis);

            $found = true;
        }
    }

    if (!$found) {
        $xmlform->variables[$name] = null;
        $xmlform->variables[$name . '_text'] = null;
    }

    if ($editing && $editing != 'no') {
        $sqlparam = $sqltextvariable ? "sqltextvariable='$sqltextvariable'" : '';

        $result =
            "  <sqlselect name='$name'  editing='$editing'  value='$kod' $sqlparam format='$format'  required='$required'  showcode='$showcode'  htmlparams='" . questform_convert($htmlparams) . "'>\n";

        if (!$sqltextvariable) $result .= '<![CDATA[' . $sqltext . ']]>';

        $result .= "  </sqlselect>\n";

        return questform_xmlresult($result, false); // createrootelement = false
    } else {
        $result =
            "  <variable name='$name' value='$kod' />\n" .
            "  <variable name='{$name}_text' value='$popis' />\n" .
            "  <div class='dotaznik_odpoved'>\n" .
            "    $popis\n" .
            "  </div>\n";

        return questform_xmlresult($result, true); // createrootelement = true
    }
}


/**
 * @param $sql
 * @param $captions
 * @return DOMDocument
 * @throws \Ron\DB\DBException
 * @deprecated
 */
function questform_sqlbrowser($sql, $captions)
{
    global $xmlform;

    $sql = $xmlform->nahradPromenne($sql, 'sql');

    if (!$sql) return questform_xmlresult('<DIV class="browser" title="Prazdny SQL dotaz!"></DIV>', false); // createrootelement = false

    $cursor = $xmlform ->database ->getSqlResult($sql);

    $result = '<TABLE class="old_xml_browser">';

    $captionarray = null;
    $stylesarray = null;

    if ($captions) {
        $captions = \Ron\StringUtils::fromUTF8($captions); // konverze z utf-8 (interne pouzivano v xml) do windows-1250

        $result .= '<TR>';
        $captionarray = explode(';', $captions);
        $stylesarray = array();
        $i = 0;
        foreach ($captionarray as $caption) {
            $poma = explode(':', $caption, 2);
            $result .= "<TH {$poma[1]}>{$poma[0]}</TH>";
            $stylesarray[$i] = $poma[1];
            $i++;
        }
        $result .= '</TR>';
    }

    while ($row = $cursor ->fetch()) {
        $result .= '<TR>';

        $i = 0;
        foreach ($row as $field) {
            $stylestr = '';
            if ($stylesarray) if (isset($stylesarray[$i])) $stylestr = $stylesarray[$i];

            $result .= "<TD $stylestr>$field</TD>";
            $i++;
        }

        $result .= "</TR>\n";
    }
    $result .= "</TABLE>\n";

    return questform_xmlresult($result, false); // createrootelement = false
}



/**
 * vraci HTML text pro vyber osoby - $value je prednastavena hodnota
 * @param $name
 * @param $value
 * @return DOMDocument
 * @throws \Ron\DB\DBException
 * @deprecated
 */
function questform_vyberosoby($name, $value)
{
    global $xmlform;

    $sql = \RonPortal\PredavaciProcesyUtils::sqlVyberOsobyProPredavaciProces($xmlform ->database, $xmlform->predavaciProces, $xmlform->typRozdeleniProcesu);

    $cursor = $xmlform ->database ->getSqlResult($sql);

    $result = '<SELECT name="' . $name . '">'; // tohle je korenovy element

    while ($row = $cursor ->fetch()) {
        if ($row[0] == $value) $selectedstr = 'selected="selected"';
        else $selectedstr = '';

        $result .=
            "<OPTION value='" . \Ron\StringUtils::htmlTextConvert($row[0]) . "' $selectedstr>" .
            \Ron\StringUtils::htmlTextConvert($row[1]) . ' ' . \Ron\StringUtils::htmlTextConvert($row[2]) . ($row[3] ? ', ' . \Ron\StringUtils::htmlTextConvert($row[3]) : '') .
            "</OPTION>\n";
    }

    $result .= "</SELECT>\n";

    return questform_xmlresult($result, false); // createrootelement = false
}


/**
 * @param $name
 * @return mixed
 * @deprecated
 */
function questform_vybranaosoba($name)
{
  global $xmlform;

  // Nastavi promenne podle zvolene osoby
  $xmlform -> nastavOsobu($name, $_POST[$name]);

  // Vraci RC zvolene osoby
  return $_POST[$name];
}


/**
 * vraci xml dokument s promennyma pro vybranou osobu
 * @param $name
 * @return DOMDocument
 * @deprecated
 */
function questform_osoba_promenne($name)
{
  global $xmlform;

  return questform_xmlresult(
      "<variable name='{$name}' value='".$xmlform -> variables["{$name}"]."' />\n".
      "<variable name='{$name}_RC' value='".$xmlform -> variables["{$name}_RC"]."' />\n".
      "<variable name='{$name}_jmeno' value='".$xmlform -> variables["{$name}_jmeno"]."' />\n".
      "<variable name='{$name}_prijmeni' value='".$xmlform -> variables["{$name}_prijmeni"]."' />\n".
      "<variable name='{$name}_titul' value='".$xmlform -> variables["{$name}_titul"]."' />\n".
      "<variable name='{$name}_jmenoprijmeni' value='".$xmlform -> variables["{$name}_jmenoprijmeni"]."' />\n"
    );
}



/**
 * vraci HTML text pro vyber pracovniho pomeru - $value je prednastavena hodnota
 * $value je ID vybraneho (predplneneho) pracovniho pomeru
 * $pouzeVlastni 0 = vlastni i podrizena rozdeleni, 1 = pouze vlastni rozdeleni, 2 = pouze podrizena rozdeleni
 * @param $name
 * @param $value
 * @param $pouzeVlastni
 * @return DOMDocument
 * @throws \Ron\DB\DBException
 * @deprecated
 */
function questform_vyberpracovnihopomeru($name, $value, $pouzeVlastni)
{
    global $xmlform;

    $sql = \RonPortal\PredavaciProcesyUtils::sqlVyberPPProPredavaciProces($xmlform ->database, $xmlform->predavaciProces, $xmlform->typRozdeleniProcesu, (int)$pouzeVlastni);

    $cursor = $xmlform ->database ->getSqlResult($sql);

    $result = '<SELECT name="' . $name . '">'; // tohle je korenovy element

    while ($row = $cursor ->fetch()) {
        if ($row[7] == (int)$value) $selectedstr = 'selected="selected"';
        else $selectedstr = '';

        $pp_str =
            \Ron\ronText('Osobni_cislo') . ' ' . $row[5] . ", " .
            \Ron\ronText('Datum_nastupu') . ' ' . \Ron\DB\DBUtils::getFormatedValue($xmlform ->database, 'date', $row[6]);

        $result .= "<OPTION value='{$row[7]}' $selectedstr>{$row[1]} {$row[2]}" . ($row[3] ? ", {$row[3]}" : '') . " - $pp_str</OPTION>\n";
    }

    $result .= "</SELECT>\n";

    return questform_xmlresult($result, false); // createrootelement = false
}



/**
 * Nastavi promenne podle zadaneho pracovniho pomeru
 * @param $varname
 * @param $idpp
 * @return string
 * @throws Exception
 * @deprecated
 */
function questform_nastavpracovnipomer($varname, $idpp)
{
  global $xmlform;

  // Nastavi promenne podle zvolene osoby
  $idpp = $xmlform -> nahradPromenne($idpp, false); // sqlformatovani = false
  $xmlform -> nastavPracovniPomer($varname, $idpp);
  return '';
}



/**
 * Nastavi promenne podle vybraneho pracovniho pomeru a vraci ID vybraneho PP
 * @param $name
 * @return mixed
 * @deprecated
 */
function questform_vybranypracovnipomer($name)
{
  // Nastavi promenne podle zvolene osoby (v combo boxu)
  questform_nastavpracovnipomer($name, $_POST[$name]);

  // Vraci ID zvoleneho p. pomeru
  return $_POST[$name];
}



/**
 * vraci xml dokument s promennyma pro vybrany PP
 * @param $name
 * @return DOMDocument
 * @deprecated
 */
function questform_pracovnipomer_promenne($name)
{
  global $xmlform;

  return questform_xmlresult(
      "<variable name='{$name}' value='".$xmlform -> variables["{$name}"]."' />\n".
      "<variable name='{$name}_id' value='".$xmlform -> variables["{$name}_id"]."' />\n".
      "<variable name='{$name}_RC' value='".$xmlform -> variables["{$name}_RC"]."' />\n".
      "<variable name='{$name}_jmeno' value='".$xmlform -> variables["{$name}_jmeno"]."' />\n".
      "<variable name='{$name}_prijmeni' value='".$xmlform -> variables["{$name}_prijmeni"]."' />\n".
      "<variable name='{$name}_titul' value='".$xmlform -> variables["{$name}_titul"]."' />\n".
      "<variable name='{$name}_jmenoprijmeni' value='".$xmlform -> variables["{$name}_jmenoprijmeni"]."' />\n".
      "<variable name='{$name}_osobnicislo' value='".$xmlform -> variables["{$name}_osobnicislo"]."' />\n".
      "<variable name='{$name}_datumnastupu' value='".$xmlform -> variables["{$name}_datumnastupu"]."' />\n".
      "<variable name='{$name}_popis' value='".$xmlform -> variables["{$name}_popis"]."' />\n"
    );
}


/**
 * @param $varname
 * @param $rc
 * @return string
 * @deprecated
 */
function questform_nastavosobuformulare($varname, $rc)
{
  global $xmlform;

  $rc = \Ron\StringUtils::fromUTF8($rc); // konverze z utf-8 do windows-1250
  
  $rc = $xmlform -> nahradPromenne($rc, false); // sqlformatovani = false
  $xmlform -> nastavOsobu($varname, $rc);
  
  return '';
}



/**
 * vraci HTML text pro vyber obdobi - $value je prednastavena hodnota
 * @param $name
 * @param $value
 * @param $aplikace
 * @param $jenNeuzavrene
 * @param $jenUkoncene
 * @param $filtrObdobi
 * @param $variabilni
 * @return DOMDocument
 * @throws \Ron\DB\DBException
 * @deprecated
 */
function questform_vyberobdobi($name, $value, $aplikace, $jenNeuzavrene, $jenUkoncene, $filtrObdobi, $variabilni)
{
    global $xmlform;

    $params = $xmlform ->database ->createParameters();

    $filtrObdobi = $xmlform->nahradPromenne($filtrObdobi, 'sql');

    if ($variabilni) {
        $sql =
            'SELECT PocatekObdobi, PopisObdobi, KonecObdobi FROM VariantniObdobi ' .
            ' WHERE 1 = 1 ';

        if ((int)$jenUkoncene) $sql .= ' AND KonecObdobi < ' . $params ->addParameter($xmlform ->database ->dateToParam(time()));

        if ($filtrObdobi) $sql .= " AND  ($filtrObdobi) ";

        $sql .= ' ORDER BY PocatekObdobi DESC ';
    } else {
        $sql =
            'SELECT PocatekObdobi, Popis, KonecObdobi, Uzavreno FROM Obdobi ' .
            ' WHERE Aplikace = ' . $params ->addParameter($aplikace);

        if ((int)$jenNeuzavrene) {
            $sql .= ' AND Uzavreno = 0 ';
        }

        if ((int)$jenUkoncene) {
            $sql .= ' AND KonecObdobi < ' . $params ->addParameter($xmlform ->database ->dateToParam(time()));
        }

        if ($filtrObdobi) $sql .= " AND  ($filtrObdobi) ";

        $sql .= ' ORDER BY PocatekObdobi DESC ';
    }


    $result = '';

    // hodnota predvyplnena nebo z POST
    $value = $xmlform ->usePostValues ? $_POST[$name] : \Ron\StringUtils::fromUTF8($value);

    $xmlform ->addDebugMessage('tag vyberobdobi, sql: ' . $sql, true);

    $cursor = $xmlform ->database ->getSqlResult($sql, $params);

    $classstr = $xmlform ->isError($name) ? 'class="dotaznik_errinput"' : '';

    $result .= '<SELECT name="' . $name . '" ' . $classstr . '>';

    if (!$value) { // pokud jeste nebyla zadana hodnota, prida prazdnou hodnotu  -  pridat prazdny radek, kdyz pole neni povinne? ? ?
        $selectedstr = 'selected="selected"';
        $result .= "<OPTION value='' $selectedstr></OPTION> ";

        $xmlform ->nastavObdobi($name, null, null, null, null);
    }

    while ($row = $cursor ->fetch()) {
        $hlpval = $cursor ->stringToTimestamp($row[0]);

        if ($hlpval == $value) {
            $selectedstr = 'selected="selected"';
            // nastavi prislusne promenne
            if ($variabilni) {
                $xmlform ->nastavObdobi($name, $hlpval, $xmlform ->database ->stringToTimestamp($row[2]), $row[1]);
            } else {
                $xmlform ->nastavObdobi($name, $hlpval, $cursor ->stringToTimestamp($row[2]), $row[1], (int)$row[3]);
            }
        } else {
            $selectedstr = '';
        }

        $result .= "<OPTION value='{$hlpval}' $selectedstr>" . \Ron\StringUtils::xmlTextConvert($row[1]) . "</OPTION>";
    }

    $cursor ->close();

    $result .= '</SELECT>';

    return questform_xmlresult($result); // aby z retezce neodstranoval znaky < a >
}



/**
 * Nastavi promenne podle vybraneho obdobi a vraci pocatek obdobi
 * @param $name
 * @param $aplikace
 * @param $variabilni
 * @return mixed
 * @deprecated
 */
function questform_vybraneobdobi($name, $aplikace, $variabilni)
{
  global $xmlform;

  if ( ! $_POST[$name] )
  {
  	$xmlform -> addErrorMsg( \Ron\ronText('Chybi_povinna_hodnota'), $name );
  }

  // Nastavi promenne podle zvoleneho obdobi
  $xmlform -> nastavObdobiAplikace($name, $aplikace, $_POST[$name], $variabilni);

  // Vraci pocatek zvoleneho obdobi
  return $_POST[$name];
}



/**
 * vraci xml dokument s promennyma pro vybrane obdobi
 * @param $name
 * @param $aplikace
 * @return DOMDocument
 * @deprecated
 */
function questform_obdobi_promenne($name, $aplikace)
{
  global $xmlform;

  return questform_xmlresult(
      "<variable name='{$name}' value='".$xmlform -> variables["{$name}"]."' />\n".
      "<variable name='{$name}_pocatek' value='".$xmlform -> variables["{$name}_pocatek"]."' />\n".
      "<variable name='{$name}_konec' value='".$xmlform -> variables["{$name}_konec"]."' />\n".
      "<variable name='{$name}_pocatekstr' value='".$xmlform -> variables["{$name}_pocatekstr"]."' />\n".
      "<variable name='{$name}_konecstr' value='".$xmlform -> variables["{$name}_konecstr"]."' />\n".
      "<variable name='{$name}_popis' value='".$xmlform -> variables["{$name}_popis"]."' />\n"
    );
}



/**
 * vraci HTML text pro vyber rozdeleni - $value je prednastavena hodnota
 * $pouzevlastni = 0 => vsechny, 1 = pouze vlastni, 2 = pouze vlastni a podrizena
 * @param $name
 * @param $value
 * @param $typ
 * @param $filter
 * @param $obdobi
 * @param $pouzevlastni
 * @return DOMDocument|string
 * @deprecated
 */
function questform_vyberrozdeleni($name, $value, $typ, $filter, $obdobi, $pouzevlastni)
{
    global $xmlform;

    // pokud neni typ zadan, pouzije se stejny typ jako se pouziva pro predavaci proces
    if (!$typ) $typ = \RonPortal\RonPortalSettings::getIntValue(\RonPortal\RonPortalSettings::PREDAVANI_TYP_ROZDELENI);
    $typ = (int)$typ;

    if (!$typ) return "Chyba v tagu $name: neni zadan typ rozdeleni";

    $sql =
        'SELECT Kod, Popis FROM Rozdeleni ' .
        " WHERE KodTypuRozdeleni = $typ ";


    $obdobiod = time();
    $obdobido = \Ron\DateUtils::endOfTheDay(time());

    if ($obdobi == 1) ; // aktualne platna obdobi
    else if ($obdobi == 2) {
        // rozdeleni nejsou filtrovana podle obdobi
        $obdobiod = 0;
        $obdobido = 0;
    }
    if (!$obdobi) {
        // Zobrazi jen platna rozdeleni
        if ($xmlform->pocatekObdobi) {
            $obdobiod = $xmlform->pocatekObdobi;
            $obdobido = \Ron\DateUtils::endOfTheDay($xmlform->konecObdobi);
        }
        // jinak zustane vychozi nastaveni - aktualni cas
    }

    if ($obdobiod) $sql .= ' AND (DatumZruseni >= ' . $xmlform ->database ->dateToString($obdobiod) . ' OR DatumZruseni IS NULL) ';
    if ($obdobido) $sql .= ' AND DatumVytvoreni <= ' . $xmlform ->database ->dateToString($obdobido);

    // pokud je typ rozdeleni stejny jako typ pro predavaci proces, tak prida filtr podle prav
//  if ( $typ == S_GetTypRozdeleniProHodnoceni() )
    if ($pouzevlastni == 1) {
        $sql .=
            ' AND EXISTS ' .
            '( SELECT * ' .   // jen moje rozdeleni (bez podrizenych)
            '  FROM RozdeleniOsob R_JA ' .
            "  WHERE R_Ja.RC = '" . $xmlform ->database ->addSlashes(\RonPortal\User::getRC()) . "'" .
            '    AND R_Ja.KodTypuRozdeleni = Rozdeleni.KodTypuRozdeleni ' .
            '    AND R_Ja.Rozdeleni = Rozdeleni.Kod ' .
            "    AND R_Ja.KodTypuRozdeleni = $typ" .
            '    AND R_Ja.PlatnostOd <= ' . $xmlform ->database ->dateToString(time()) .
            '    AND (R_Ja.PlatnostDo >= ' . $xmlform ->database ->dateToString(time()) . '  OR  R_Ja.PlatnostDo IS NULL)' .
            ')';
    } else if ($pouzevlastni == 2) {
        $sql .=
            ' AND EXISTS ' .
            '( SELECT * ' .   // jen moje a podrizene rozdeleni
            '  FROM RozdeleniOsob R_JA, HierarchieRozdeleni H ' .
            "  WHERE R_Ja.RC = '" . $xmlform ->database ->addSlashes(\RonPortal\User::getRC()) . "'" .
            '    AND H.TypNadrazene = R_Ja.KodTypuRozdeleni ' .
            '    AND H.KodNadrazene = R_Ja.Rozdeleni ' .
            '    AND H.TypPodrizene = Rozdeleni.KodTypuRozdeleni ' .
            '    AND H.KodPodrizene = Rozdeleni.Kod ' .
            "    AND R_Ja.KodTypuRozdeleni = $typ" .
            '    AND R_Ja.PlatnostOd <= ' . $xmlform ->database ->dateToString(time()) .
            '    AND (R_Ja.PlatnostDo >= ' . $xmlform ->database ->dateToString(time()) . '  OR  R_Ja.PlatnostDo IS NULL)' .
            ')';
    } else if ($pouzevlastni == 3) {
        $sql .=
            ' AND EXISTS ' .
            '( SELECT * ' .  // jen podrizene
            '  FROM RozdeleniOsob R_JA, HierarchieRozdeleni H ' .
            "  WHERE R_Ja.RC = '" . $xmlform ->database ->addSlashes(\RonPortal\User::getRC()) . "'" .
            '    AND H.TypNadrazene = R_Ja.KodTypuRozdeleni ' .
            '    AND H.KodNadrazene = R_Ja.Rozdeleni ' .
            '    AND H.TypPodrizene = Rozdeleni.KodTypuRozdeleni ' .
            '    AND H.KodPodrizene = Rozdeleni.Kod ' .
            "    AND R_Ja.KodTypuRozdeleni = $typ" .
            '    AND R_Ja.PlatnostOd <= ' . $xmlform ->database ->dateToString(time()) .
            '    AND (R_Ja.PlatnostDo >= ' . $xmlform ->database ->dateToString(time()) . '  OR  R_Ja.PlatnostDo IS NULL)' .
            '    AND H.KodNadrazene <> H.KodPodrizene' .
            ')';
    } else if ($pouzevlastni == 4) {
        $sql .=
            ' AND EXISTS ' .
            '( SELECT * ' .  // jen primo podrizene
            '  FROM RozdeleniOsob R_JA ' .
            "  WHERE R_Ja.RC = '" . $xmlform ->database ->addSlashes(\RonPortal\User::getRC()) . "'" .
            '    AND Rozdeleni.RozdeleniRodice = R_Ja.KodTypuRozdeleni ' .
            '    AND Rozdeleni.Rodic = R_Ja.Rozdeleni ' .
            "    AND R_Ja.KodTypuRozdeleni = $typ" .
            '    AND R_Ja.PlatnostOd <= ' . $xmlform ->database ->dateToString(time()) .
            '    AND (R_Ja.PlatnostDo >= ' . $xmlform ->database ->dateToString(time()) . '  OR  R_Ja.PlatnostDo IS NULL)' .
            ')';
    }

    if ($filter) $sql .= ' AND ( ' . $filter . ')';

    $sql .= ' ORDER BY Popis ';

    // hodnota predvyplnena nebo z POST
    $value = $xmlform->usePostValues ? $_POST[$name] : \Ron\StringUtils::fromUTF8($value);

    return questform_sqlselect($name, $sql, null, '', $value, true, true); // required=true, showcode=true
}


/**
 * Nastavi promenne podle vybraneho rozdeleni a vraci kod rozdeleni
 * @param $name
 * @param $typ
 * @param $required
 * @return mixed
 * @deprecated
 */
function questform_vybranerozdeleni($name, $typ, $required)
{
    global $xmlform;

    if ($required && !$_POST[$name]) {
        $xmlform->addErrorMsg(\Ron\ronText('Chybi_povinna_hodnota'), $name);
    }

    // pokud neni typ zadan, pouzije se stejny typ jako se pouziva pro predavaci proces
    if (!$typ) $typ = \RonPortal\RonPortalSettings::getIntValue(\RonPortal\RonPortalSettings::PREDAVANI_TYP_ROZDELENI);
    $typ = (int)$typ;

    // Nastavi promenne podle zvoleneho rozdeleni
    $xmlform->nastavRozdeleni($name, $typ, $_POST[$name]);

    // Vraci kod zvoleneho rozdeleni
    return $_POST[$name];
}


/**
 * @param $name
 * @param $typprava
 * @param $tabulka
 * @param $obdobiod
 * @param $obdobido
 * @return string
 * @deprecated
 */
function questform_filtrpodleprav($name, $typprava, $tabulka, $obdobiod, $obdobido) {
    /* @var \RonPortal\XML\RonPortalXMLForm $xmlform */
    global $xmlform;

    if (!$tabulka) $tabulka = 'PracovniPomer';
    $typprava = $xmlform -> nahradPromenne($typprava, false);

    if ($obdobiod) $obdobiod = (int)$xmlform -> nahradPromenne($obdobiod, false);

    if (!$obdobiod) {
        if ($xmlform -> pocatekObdobi) $obdobiod = $xmlform -> pocatekObdobi;
        else $obdobiod = time();
    }

    if ($obdobido) $obdobido = (int)$xmlform -> nahradPromenne($obdobido, false);

    if (!$obdobido) {
        if ($xmlform -> konecObdobi) $obdobiod = $xmlform -> konecObdobi;
        else $obdobido = time();
    }

    $prava = \RonPortal\Prava::vratPrava($typprava);
    $filtr = $prava ->sqlFiltr($tabulka, $obdobiod, $obdobido);
    $xmlform -> variables[$name] = $filtr;

    return '';
}


/**
 * Nastavi vybrane rozdeleni formulare v $typ i $kod lze pouzit parametry
 * pokud je zadano $name tak nastavi i prislusne promenne stejne jako v metode vyberrozdeleni
 * @param $name
 * @param $typ
 * @param $kod
 * @return string
 * @deprecated
 */
function questform_nastavrozdeleniformulare($name, $typ, $kod)
{
  global $xmlform;

  $typ = $xmlform -> nahradPromenne($typ, false); // sqlformatovani = false
  $kod = $xmlform -> nahradPromenne($kod, false);

  $xmlform ->nastavRozdeleni($name, $typ, $kod);

  return '';
}


/**
 * Nastavi vybrane obdobi formulare
 * pokud je zadano $name tak nastavi i prislusne promenne
 * a pokud je zadano i $aplikace nebo $variabilni, tak nacte z databaze i dalsi promenne tykajici se obdobi
 * @param $name
 * @param $aplikace
 * @param $obdobi
 * @param $variabilni
 * @return string
 * @deprecated
 */
function questform_nastavobdobiformulare($name, $aplikace, $obdobi, $variabilni)
{
  global $xmlform;

  $obdobi = $xmlform -> nahradPromenne($obdobi, false); // sqlformatovani = false

  $xmlform -> nastavObdobiAplikace($name, $aplikace, $obdobi, $variabilni);

  return '';
}


/**
 * Nastavi vybrane rozdeleni formulare v $typ i $kod lze pouzit parametry
 * pokud je zadano $name tak nastavi i prislusne promenne stejne jako v metode vyberrozdeleni
 * @param $fieldname
 * @param $value
 * @return string
 * @deprecated
 */
function questform_nastavpodrobnostiformulare($fieldname, $value) // OK
{
  global $xmlform;

  $value = \Ron\StringUtils::fromUTF8($value); // konverze z utf-8 do windows-1250

  $value = $xmlform -> nahradPromenne($value, false); // sqlformatovani = false

  switch ( strtolower($fieldname) )
  {
    case 'rozliseni1' : $xmlform -> rozliseni1 = substr( trim($value), 0, 40); break;
    case 'rozliseni2' : $xmlform -> rozliseni2 = substr( trim($value), 0, 40); break;
    case 'rozliseni3' : $xmlform -> rozliseni3 = substr( trim($value), 0, 40); break;
    case 'rozliseni4' : $xmlform -> rozliseni4 = substr( trim($value), 0, 40); break;

    case 'dodatecnypopis' : $xmlform -> dodatecnyPopis = substr( trim($value), 0, 120); break;
    case 'poznamka' : $xmlform -> poznamka = $value; break;
  }

  return '';
}


/**
 * Nastavi vybrane rozdeleni formulare v $typ i $kod lze pouzit parametry
 * pokud je zadano $name tak nastavi i prislusne promenne stejne jako v metode vyberrozdeleni
 * @param $idsablony
 * @return string
 * @deprecated
 */
function questform_nastavXMLafter($idsablony)
{
  global $xmlform;
  $idsablony = $xmlform -> nahradPromenne($idsablony, false); // sqlformatovani = false
  
  $xmlform -> f_xmlsablona_after = $idsablony;

  return '';
}


/**
 * vraci xml dokument s promennyma pro vybrane rozdeleni
 * @param $name
 * @param $aplikace
 * @return DOMDocument
 * @deprecated
 */
function questform_rozdeleni_promenne($name, $aplikace)
{
  global $xmlform;

  return questform_xmlresult(
      "<variable name='{$name}' value='".$xmlform -> variables["{$name}"]."' />\n".
      "<variable name='{$name}_typ' value='".$xmlform -> variables["{$name}_typ"]."' />\n".
      "<variable name='{$name}_kod' value='".$xmlform -> variables["{$name}_kod"]."' />\n".
      "<variable name='{$name}_popis' value='".$xmlform -> variables["{$name}_popis"]."' />\n"
    );
}


/**
 * @param $param
 * @param $contenttext
 * @return string
 * @deprecated
 */
function questform_createeditacemesicnich($param, $contenttext)
{
    global $xmlform;

    $xmlform->f_editacemesicnich = new \RonPortal\Editace\EditaceMesicnichHromadna($xmlform ->database,
        $xmlform->kodTypuRozdeleni, $xmlform->rozdeleni);

    $xmlform->f_editacemesicnich->f_readonly = $xmlform->readOnly;

    if ($contenttext) {
        $contenttext = $xmlform->nahradPromenne($contenttext, false); // sql = false
        $xmlform->f_editacemesicnich->loadXML($contenttext);
    } else if ($param) {
        $xmlform->f_editacemesicnich->LoadDOMElement($param[0]);
    }

    // nahradi promenne v SQL filtru pro vyber osob
    $xmlform->f_editacemesicnich->filtrOsoby = $xmlform->nahradPromenne($xmlform->f_editacemesicnich->filtrOsoby, 'sql');

    return '';
}


/**
 * @return DOMDocument
 * @deprecated
 */
function questform_editacemesicnich_vratlimit()
{
    global $xmlform;

    if (!$xmlform->f_editacemesicnich) {
        $xmlform ->addErrorMsg('Chyba ve formulari - funkce questform_editacemesicnich_vratlimit volana mimo &lt;editacemesicnich&gt;!');
    }

    if ($xmlform->f_editacemesicnich->souhlasPrekrocitLimit) {
        return questform_xmlresult('<editacemesicnichlimit povolit="1" />', false);
    } else {
        return questform_xmlresult('<editacemesicnichlimit povolit="0" />', false);
    }
}


/**
 * Editace mesicnich vysledku - kontrola zadanych hodnot a zapis do databaze
 * @return string
 * @throws Exception
 * @deprecated
 */
function questform_zapismesicni()
{
    global $xmlform;

    if ($xmlform->deleted) return ''; // formular uz byl smazan

    $xmlform->f_editacemesicnich->nactiSeznamOsobPodlePost($xmlform->pocatekObdobi, !$xmlform->f_editacemesicnich ->kontrolovatPrava);

    $xmlform->f_editacemesicnich->nactiLimityRozdeleni();

    if (!$xmlform->f_editacemesicnich->jeChyba) {
        if ($xmlform->f_editacemesicnich->kontrolaObdobi()) {
            if ($xmlform->f_editacemesicnich->zkontrolujLimity()) {
                $xmlform->f_editacemesicnich->zapisData();
                if ($xmlform->f_editacemesicnich->jeChyba) $xmlform->addErrorMsg('&nbsp;');
            } else {
                global $STR_PrekrocenLimitMP; // kompat.
                $xmlform->addErrorMsg($STR_PrekrocenLimitMP ?: \Ron\ronText('Prekrocen_limit_MP'));
            }
        } else {
            $xmlform->addErrorMsg( \Ron\ronText('Obdobi_uzavreno') );
        }
    } else {
        $xmlform->addErrorMsg( \Ron\ronText('Spatna_hodnota') );
    }

    return '';
}


/**
 * @return DOMDocument
 * @throws Exception
 * @deprecated
 */
function questform_editacemesicnich()
{
    global $xmlform;

    if ($xmlform->neukladat == 2  &&  $xmlform ->usePostValues) {
        // neukladaci formular
        questform_zapismesicni();
    } else if ($xmlform->usePostValues) {
        // fill
        $xmlform->f_editacemesicnich->nactiSeznamOsobPodlePost($xmlform->pocatekObdobi, true); // povolitvse = true - lze editovat vsechny osoby

        $xmlform->f_editacemesicnich->zkontrolujLimity(); // aby se oznacily prekrocene hodnoty

        $xmlform->f_editacemesicnich->nactiLimityRozdeleni();
    } else {
        //$xmlform -> f_editacemesicnich -> f_vcetnepodrizenych = $vcetnepodrizenych;
        $xmlform->f_editacemesicnich->nactiSeznamOsobXML($xmlform->kodTypuRozdeleni, $xmlform->rozdeleni, $xmlform->pocatekObdobi);

        $xmlform->f_editacemesicnich->zkontrolujLimity(); // aby se oznacily prekrocene hodnoty
    }

    $result =
        '<div><div class="errormsg">XML formular je zastaraly!</div>' .
        $xmlform->f_editacemesicnich->vratObsahFormulareH(false) . // tlacitkoulozit = false
        '</div>';

    return questform_xmlresult($result, false);
}


/**
 * Pole pro vlozeni dokumentu name = jmeno promenne. Popis a typ dokumentu mohou obsahovat promenne.
 * @param $name
 * @param $popis
 * @param $typ
 * @param $style
 * @return DOMDocument
 * @deprecated
 */
function questform_dokument($name, $popis, $typ, $style)
{
    global $xmlform;

    //if ( in_array($name, $xmlform -> f_errorfields) ) $classstr = 'class="fileinput dotaznik_errinput"';
    if ( $xmlform ->isError($name)) $classstr = 'class="fileinput dotaznik_errinput"';
    else $classstr = 'class="fileinput"';

    if ($style) $style = "style='$style'";

    return questform_xmlresult(
        "<INPUT type='file' name='$name' $classstr $style />",
        false); // createrootelement = false

}


/**
 * @param $name
 * @param $id
 * @return DOMDocument|string
 * @throws \Ron\DB\DBException
 * @deprecated
 */
function questform_pripojenydokument($name, $id)
{
    // zobrazi odkaz na stahnuti pripojeneho dokumentu
    global $xmlform;

    $id = (int)$id;
    $params = $xmlform ->database ->createParameters();
    $sql = 'SELECT Popis, JmenoSouboru FROM Dokument WHERE Id = ' . $params ->addParameter($id);

    $cursor = $xmlform ->database ->getSqlResult($sql, $params);
    if (!$row = $cursor ->fetch()) return '';

    if ($name) $xmlform->variables[$name] = $id;

    return questform_xmlresult("<div class='pripojenydokument'><a target='_blank' href='?menuid=xmlform&amp;action=download&amp;idxml={$xmlform -> id}&amp;record=$id'>{$row[1]}</a></div>", false);
}


/**
 * <xsl:copy-of select="php:function('questform_vlozdokument', string(./@name), string(./@popis), string(./@typ), (./@editing), string(./@style) )" />
 * @param $name
 * @param $popis
 * @param $typ
 * @param $editing
 * @param $style
 * @return DOMDocument
 * @deprecated
 */
function questform_vlozdokument($name, $popis, $typ, $editing, $style)
{
    global $xmlform;

    $result = '';

    $popis = \Ron\StringUtils::fromUTF8($popis);

    $kopirovatpuvodni = false;

    if (is_uploaded_file($_FILES[$name]['tmp_name'])) {
        // uzivatel pripojil soubor
        $popissouboru = $xmlform->nahradPromenne($popis);

        try {
            $id = \RonPortal\Dokumenty\DokumentyUtils::vlozDokument($xmlform ->database, $name, $typ, $popissouboru, 'XML formular');

            $xmlform->variables[$name] = $id;
            $xmlform->noveDokumenty[] = $id;

            $result .= questform_getlogname(true) . "<pripojenydokument  name='$name'  id='$id' />";

            $kopirovatpuvodni = $editing == 'yes' || $editing == 'append';
        } catch (\Exception $e) {
            $xmlform->addErrorMsg('Pri vkladani souboru doslo k chybe!', $name);
        }
    } else {
        $kopirovatpuvodni = true;
    }


    if ($kopirovatpuvodni) {
        // soubor nebyl vlozen, nebo se muze nahrat dalsi (editing = yes/append)
        $result .= "<dokument name='$name' popis='$popis' typ='$typ' editing='$editing' style='$style' />";
    }

    return questform_xmlresult($result, true); // createrootelement = true;
}

      
/**
 * Provede test
 * @param $testtype
 * @param $text
 * @param $param1
 * @param $param2
 * @return bool
 * @throws Exception
 * @deprecated
 */
function questform_test($testtype, $text, $param1, $param2)
{
    global $xmlform;

    if (\Ron\Http\App::getDebugMode()) $xmlform ->addDebugMessage("Test ($testtype)");

    switch ($testtype) {
        case 'emptysql' :
        case 'notemptysql' :
            $cursor = questform_sqlresult_internal($xmlform ->database, $text, 'Tag test: Chyba v SQL dotazu!');
            if ($row = $cursor ->fetch()) {
                // vysledek sql vyrazu neni prazdny
                return ($testtype == 'notemptysql');
            }

            return ($testtype == 'emptysql');

        case 'error' :
            return $xmlform->isError();

        case '=' :
        case '==' :
        case 'eq' :
            return ($xmlform->nahradPromenne($param1, false) == $xmlform->nahradPromenne($param2, false));

        case '>' :
        case 'gt' :
            return ($xmlform->nahradPromenne($param1, false) > $xmlform->nahradPromenne($param2, false));

        case '>=' :
        case 'gteq' :
            return ($xmlform->nahradPromenne($param1, false) >= $xmlform->nahradPromenne($param2, false));

        case '<' :
        case 'lt' :
            return ($xmlform->nahradPromenne($param1, false) < $xmlform->nahradPromenne($param2, false));

        case '<=' :
        case 'lteq' :
            return ($xmlform->nahradPromenne($param1, false) <= $xmlform->nahradPromenne($param2, false));

        case '<>' :
        case '!=' :
        case 'neq' :
            return ($xmlform->nahradPromenne($param1, false) != $xmlform->nahradPromenne($param2, false));

        default :
            throw new Exception("Chyba - tento typ testu neni implementovan! ($testtype)");
    }
}


/**
 * Vraci true/false podle vysledku zadane podminky
 * @param $condition
 * @return bool
 * @deprecated
 */
function questform_if($condition)
{
    global $xmlform;

    $condition = $xmlform->nahradPromenne($condition, false);

    $xmlform ->addDebugMessage('XMLDebug> if - vyhodnocuji vyraz: ' . $condition );

    $result = null;
    eval('$result = ' . $condition . ';');

    return !!$result;
}


/**
 * @param $name
 * @param $sqltext
 * @param $sqltextvariable
 * @return DOMDocument
 * @throws \Ron\DB\DBException
 * @deprecated
 */
function questform_forsql($name, $sqltext, $sqltextvariable)
{
    global $xmlform;

    $sql = $sqltextvariable ? $xmlform->getVariableValue($sqltextvariable) : $sqltext;

    // V SQL dotazu nahradi promenne skutecnymi hodnotami
    $sql = $xmlform->nahradPromenne($sql, 'sql');

    $strresult = '';

    if (\Ron\Http\App::getDebugMode()) $xmlform ->addDebugMessage('forsql: ' . $sql);

    $cursor = $xmlform ->database ->getSqlResult($sql);
    while ($row = $cursor ->fetch()) {
        $strresult .= '<ROW>';
        foreach ($row as $fieldindex => $dbvalue) {
            if ($xmlform ->verze > 1) {
                // pouzije pole
                $strresult .= "<variable name='{$name}' index='{$fieldindex}' value='" . \Ron\StringUtils::xmlTextConvert($dbvalue) . "' />";
            } else {
                // puvodni verze, ktera nepodporovala pole - pouzije pouze promenne se slozenym jmenem
                $strresult .= "<variable name='{$name}[$fieldindex]' value='" . \Ron\StringUtils::xmlTextConvert($dbvalue) . "' />";
            }
        }
        $strresult .= "</ROW>\n";
    }

    return questform_xmlresult($strresult, true); // $createrootelement = true
}


/**
 * @param $name
 * @param $arrayvariable
 * @return DOMDocument
 * @deprecated
 */
function questform_foreach($name, $arrayvariable)
{
    global $xmlform;

    $strresult = '';

    $arr = $xmlform ->variables[$arrayvariable];
    foreach ($arr as $key => $value) {
        $strresult .= '<ROW>';
        $strresult .= "<variable name='{$name}' value='" . \Ron\StringUtils::xmlTextConvert($value) . "' />";
        $strresult .= "<variable name='{$name}_key' value='" . \Ron\StringUtils::xmlTextConvert($key) . "' />";
        $strresult .= "</ROW>\n";
    }

    return questform_xmlresult($strresult, true); // $createrootelement = true
}



///**
// * nastavi promennou $name na hodnotu nastaveni uzivatele $key
// * @param $name
// * @param $key
// * @param $defaultvalue
// * @return string
// * @deprecated
// */
//function questform_loadusersettings($name, $key, $defaultvalue)
//{
//    global $xmlform;
//
//    $name = $xmlform ->nahradPromenne($name, false);
//
//    $key = $xmlform ->nahradPromenne(\Ron\StringUtils::fromUTF8($key), false);
//    $defaultvalue = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($defaultvalue), false);
//
//    $value = \RonPortal\NastaveniUzivatele::getUserSettingsItem($xmlform ->database, strtolower($key), $defaultvalue);
//
//    $xmlform -> setVariable($name, $value);
//
//    return '';
//}

///**
// * @param $key
// * @param $value
// * @param $defaultvalue
// * @param $save
// * @return string
// * @deprecated
// */
//function questform_storeusersettings($key, $value, $defaultvalue, $save)
//{
//    global $xmlform;
//
//    $key = $xmlform ->nahradPromenne(\Ron\StringUtils::fromUTF8($key), false);
//    $defaultvalue = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($defaultvalue), false);
//    $value = $xmlform->nahradPromenne(\Ron\StringUtils::fromUTF8($value), false);
//
//    if ($save == ''  ||  $save == null) $save = true; // neni zadano => default = true
//    else if ($save == 'no'  ||  !$save) $save = false;
//    else $save = true;
//
//    \RonPortal\NastaveniUzivatele::setUserSettingsItem($xmlform ->database, strtolower($key), $value, $defaultvalue, $save);
//
//    return '';
//}


///**
// * @return string
// * @throws Exception
// * @deprecated
// */
//function questform_hlavickahodnoceni()
//{
//    global $xmlform;
//
//    if (!$xmlform ->dotaznik) {
//        throw new Exception('Chyba v tagu hlavickahodnoceni! Neni nacten dotaznik!');
//    }
//
//    $xmlform ->dotaznik ->zobrazHlavicku();
//    return '';
//}


///**
// * @param $id
// * @param $druhhodnoceni
// * @param $temacislo
// * @return DOMDocument
// * @throws \Ron\DB\DBException
// * @deprecated
// */
//function questform_otazkyhodnoceni($id, $druhhodnoceni, $temacislo)
//{
//    global $xmlform;
//
//    $id = $xmlform->nahradPromenne($id, false);
//    $druhhodnoceni = $xmlform->nahradPromenne($druhhodnoceni, false);
//    $temacislo = $xmlform->nahradPromenne($temacislo, false);
//
//    if ($id) {
//        $sql =
//            'SELECT HodnoticiKriterium.KodKriteria ' .
//            '  FROM PripraveneTemaHodnoceni, HodnoticiKriterium ' .
//            ' WHERE PripraveneTemaHodnoceni.Id = ' . (int)$id .
//            '   AND HodnoticiKriterium.DruhHodnoceni = PripraveneTemaHodnoceni.DruhHodnoceni ' .
//            '   AND HodnoticiKriterium.TemaCislo = PripraveneTemaHodnoceni.TemaCislo ' .
//            '   AND HodnoticiKriterium.KodKriteriaHlavni IS NULL' . // 15.4.2015 RON-PR nacitaji se jen otazky, ktere nejsou dalsim typem odpovedi
//            ' ORDER BY HodnoticiKriterium.Poradi ';
//    } else {
//        $sql =
//            'SELECT HodnoticiKriterium.KodKriteria ' .
//            '  FROM HodnoticiKriterium ' .
//            ' WHERE HodnoticiKriterium.DruhHodnoceni = ' . (int)$druhhodnoceni .
//            '   AND HodnoticiKriterium.TemaCislo = ' . (int)$temacislo .
//            '   AND HodnoticiKriterium.KodKriteriaHlavni IS NULL' . // 15.4.2015 RON-PR nacitaji se jen otazky, ktere nejsou dalsim typem odpovedi
//            ' ORDER BY HodnoticiKriterium.Poradi ';
//    }
//
//    $strresult = '';
//
//    \Ron\MessageManager::addDebugLog('XMLDebug> otazkyhodnoceni: ' . $sql);
//
//    $cursor = $xmlform ->database ->getSqlResult($sql);
//
//    while ($row = $cursor ->fetch()) {
//        $strresult .=
//            '<ROW>' .
//            "<variable name='HODNOCENI_KodKriteria' value='" . \Ron\StringUtils::xmlTextConvert($row[0]) . "' />" .
//            "</ROW>\n";
//    }
//
//    $cursor ->close();
//
//    return questform_xmlresult($strresult, true); // $createrootelement = true
//}


///**
// * @param $id
// * @param $druhHodnoceni
// * @param $temaCislo
// * @param $kodKriteria
// * @param $zpusobZobrazeni
// * @return DOMDocument
// * @throws Exception
// * @deprecated
// */
//function questform_otazkahodnoceni($id, $druhHodnoceni, $temaCislo, $kodKriteria, $zpusobZobrazeni)
//{
//    //require_once('adsapp/hodnoceni.php');
//    global $xmlform;
//
//    $id = $xmlform -> nahradPromenne($id, false);
//    $druhHodnoceni = $xmlform -> nahradPromenne($druhHodnoceni, false);
//    $temaCislo = $xmlform -> nahradPromenne($temaCislo, false);
//    $kodKriteria = $xmlform -> nahradPromenne($kodKriteria, false);
//
//    $otazka = null;
//
//    if ($druhHodnoceni == $xmlform ->dotaznik ->druhHodnoceni  &&  $temaCislo == $xmlform ->dotaznik ->temaCislo) {
//        $otazka = $xmlform ->dotaznik ->vratOtazku($kodKriteria);
//    }
//
//    if (!$otazka) {
//        $otazka = new \RonPortal\Testy\OtazkaDotazniku($id, $druhHodnoceni, $temaCislo);
//        $otazka->nactiOtazku($xmlform ->database, $kodKriteria);
//    }
//
//    if ( $zpusobZobrazeni !== '' ) {
//        $otazka -> zpusobZobrazeni = $zpusobZobrazeni;
//    }
//
//    $strresult =
//        '<DIV>'.
//        $otazka -> vratHTML_Otazka().
//        $otazka -> vratHTML_Odpoved(!$xmlform -> readOnly).
//        '</DIV>';
//
//    if ( !$otazka -> odpovedVyplnena  &&  $otazka -> povinnaOdpoved ) $xmlform -> dotaznik -> fVyplnenoVse = false;
//
//    return questform_xmlresult($strresult, false); // $createrootelement = false
//}


///**
// * @return DOMDocument|string
// * @deprecated
// */
//function questform_poznamkahodnoceni()
//{
//    global $xmlform;
//
//    if (!$xmlform -> dotaznik) {
//        return 'Chyba v poznamkahodnoceni - neni dotaznik!';
//    }
//
//    $strresult = $xmlform -> dotaznik -> vratHTMLPoznamka(!$xmlform -> readOnly);
//    return questform_xmlresult($strresult, false);
//}


///**
// * @param $ulozit
// * @param $odeslat
// * @param $vratit
// * @param $uzavrit
// * @return DOMDocument|string
// * @deprecated
// */
//function questform_tlacitkahodnoceni($ulozit, $odeslat, $vratit, $uzavrit)
//{
//    //require_once('adsapp/hodnoceni.php');
//
//    global $xmlform;
//
//    if (!$xmlform -> dotaznik) return 'Chyba v tlacitkahodnoceni - neni dotaznik!';
//
//    $ulozit = \Ron\StringUtils::fromUTF8($ulozit);
//    $odeslat = \Ron\StringUtils::fromUTF8($odeslat);
//    $vratit = \Ron\StringUtils::fromUTF8($vratit);
//    $uzavrit = \Ron\StringUtils::fromUTF8($uzavrit);
//
//    $strresult = $xmlform -> dotaznik -> vratHTMLTlacitka(!$xmlform -> readOnly, $ulozit, $odeslat, $vratit, $uzavrit);
//    if (!$strresult) return '';
//
//    return questform_xmlresult($strresult, false);
//}


///**
// * @return string
// * @throws \Ron\DB\DBException
// * @deprecated
// */
//function questform_ulozodpovedihodnoceni()
//{
//    global $xmlform;
//    if (!$xmlform -> dotaznik) {
//        return 'Chyba v ulozodpovedihodnoceni - neni dotaznik!';
//    }
//
//    $xmlform -> dotaznik -> fUlozenoVXML = $xmlform -> dotaznik -> ulozVyplnenyDotaznik();
//    $xmlform -> variables['HODNOCENI_Ulozeno'] = $xmlform -> dotaznik -> fUlozenoVXML;
//
//    return '';
//}


///**
// * priznak $neulozene urcuje, jestli se ma provest prepocet i kdyz nedoslo ke spravnemu ulozeni
// * a vyplneni vsech povinnych otazek
// * @param $neulozene
// * @return string
// * @throws Exception
// * @deprecated
// */
//function questform_prepocitejhodnoceni($neulozene)
//{
//    global $xmlform;
//    if (!$xmlform -> dotaznik) {
//        return 'Chyba v ulozodpovedihodnoceni - neni dotaznik!';
//    }
//
//    if ( $neulozene  ||
//         ($xmlform -> dotaznik -> fUlozenoVXML  &&  $xmlform -> dotaznik -> fVyplnenoVse) )
//    {
//      $xmlform -> dotaznik -> fPrepoctenoVXML = $xmlform -> dotaznik -> prepocitejDotaznik();
//      $xmlform -> variables['HODNOCENI_Prepocteno'] = $xmlform -> dotaznik -> fPrepoctenoVXML;
//    }
//
//    return '';
//}


/**
 * zobrazi link odkazujici na stejny formular se zadanymi parametry
 * @param $action
 * @param $params
 * @param $text
 * @param $question
 * @return DOMDocument
 * @deprecated
 */
function questform_link($action, $params, $text, $question)
{
  global $xmlform;

  $text = \Ron\StringUtils::fromUTF8($text);

  if ($action) $params = 'xmlaction='.$action.'&'.$params;

  $params = str_replace ('&', '&amp;', $params);

  $params = \Ron\StringUtils::fromUTF8($params);
  $params = $xmlform -> nahradPromenne($params, false);
  
  $text = $xmlform -> nahradPromenne($text, false);
  
  if ($question)
  {
    // ma se zobrazit dotaz - pouzije javascript
    $question = \Ron\StringUtils::fromUTF8($question);
    
    $onclickstr = 'ChangeLocationQuest(event, "' .$question.'", "?menuid=vyplnitdotaznik&#38;record='.$xmlform -> idSablony.'&#38;'.$params.'")';
     
    return questform_xmlresult(
          "<SPAN class='js' onclick='$onclickstr'>".
          $text.
          '</SPAN>',
        false
      );  
  }
  else
  {
    // bez dotazu - pouzije primy link
    return questform_xmlresult(
        '<A href="?menuid=vyplnitdotaznik&#38;record='.$xmlform -> idSablony.'&#38;'.$params.'">'.$text.'</A>',
        false
      );
  }  
}


/**
 * @param $text
 * @param $question
 * @param $submitaction
 * @return DOMDocument|string
 * @deprecated
 */
function questform_button($text, $question, $submitaction)
{
  global $xmlform;
  if ( $xmlform -> readOnly ) return '';

  $onclickstr = "XMLAction(this, '$question', '$submitaction')";

  return questform_xmlresult(
      '<INPUT type="button" class="XSL_button" OnClick="'.$onclickstr.'" value="'.$text.'" />',
      false
    );
}


/**
 * @param $text
 * @param $question
 * @return DOMDocument|string
 * @deprecated
 */
function questform_submitbutton($text, $question)
{
  $text = $text ? \Ron\StringUtils::fromUTF8($text) : \Ron\ronText('form.Store');

  $question = \Ron\StringUtils::fromUTF8($question);

  //return questform_button($text, $question, '?menuid=ulozxmlformular');
  return questform_button($text, $question, 'submit');
}


/**
 * @param $text
 * @param $question
 * @return DOMDocument|string
 * @deprecated
 */
function questform_submitnextbutton($text, $question)
{
  global $xmlform;
  if ($xmlform -> viceSekci) return ''; // dokument jeste neni vyplnen, akce se nezobrazi

  // Pokud neni kam predat (je na posledni urovni), tak tlacitko nezobrazi
  if ( $xmlform -> pocatecniUroven )    // pokud jeste neni prirazena uroven, je tlacitko zobrazeno
  {
    if ( !\RonPortal\UrovenPredavani::existujeVyssiUrovenPredavani($xmlform ->database,
            $xmlform -> predavaciProces, $xmlform -> pocatecniUroven,
            $xmlform -> poradiPredavani ) ) return '';
  }          

  global $STR_OdeslatXML; // kompat.

  if ( $text ) $text = \Ron\StringUtils::fromUTF8($text);
  else $text = $STR_OdeslatXML ?: \Ron\ronText('Odeslat_xml');

  $question = \Ron\StringUtils::fromUTF8($question);

  return questform_button($text, $question, 'submitnext');
}


/**
 * @param $text
 * @param $question
 * @return DOMDocument|string
 * @deprecated
 */
function questform_submitprevbutton($text, $question)
{
  global $xmlform;

  if ($xmlform -> viceSekci) return ''; // dokument jeste neni vyplnen, akce se nezobrazi

  // Pokud neni kam predat (je na posledni urovni), tak tlacitko nezobrazi
  if ( !\RonPortal\UrovenPredavani::existujeNizsiUrovenPredavani($xmlform ->database,
          $xmlform -> predavaciProces, $xmlform -> pocatecniUroven,
          $xmlform -> poradiPredavani ) ) return '';

  global $STR_VratitXML; // kompat

  if ( $text ) $text = \Ron\StringUtils::fromUTF8($text);
  else $text = $STR_VratitXML ?: \Ron\ronText('Vratit_xml');

  $question = \Ron\StringUtils::fromUTF8($question);

  return questform_button($text, $question, 'submitprev');
}


/**
 * pokud se ma formular predat dale tak nastavi formular na novou uroven a vraci true jinak vraci false
 * @return bool
 * @deprecated
 */
function questform_predatdale()
{
    global $xmlform;

    if ($xmlform->xmlAction == 'submitnext') {
        $xmlform ->addDebugMessage('XMLDebug> Zvolena akce "predat dale"');

        if (!$xmlform->isError()) $xmlform->predej(1);

        return true;
    }

    return false;
}


/**
 * pokud se ma formular vratitzpet, tak nastavi formular na novou uroven a vraci true, jinak vraci false
 * @param $zacatek
 * @return bool
 * @deprecated
 */
function questform_vratitzpet($zacatek)
{
    global $xmlform;

    if ($xmlform->xmlAction == 'submitprev') {
        $xmlform ->addDebugMessage('XMLDebug> Zvolena akce "vratit zpet" ' . $xmlform->xmlAction );

        if (!$xmlform->isError()) $xmlform->predej($zacatek ? -999 : -1);

        return true;
    }

    return false;
}


/**
 * Programove predani na jinou uroven. Vzdy by mel byt zadan jen jeden parametr
 * @param int $smer             + nebo - pocet urovni od aktualni urovne
 * @return bool
 * @deprecated
 */
function questform_predat($smer)
{
    global $xmlform;
    if ((int)$smer)  {
        return $xmlform ->predej((int)$smer);
    }

    return false;
}


/**
 * pokud ma uzivatel pravo provest akci, vraci xml dokument - input pro provedeni akce
 * jinak vraci prazdny retezec
 * pravo na zobrazeni akce ma uzivatel ze zadanych predavacich urovni ($urovne - kody oddelene strednikem)
 *  a pokud nejsou urovne zadany, tak jen uzivatel na posledni urovni predavani
 * @param $name
 * @param $text
 * @param $confirmquestion
 * @param $urovne
 * @return DOMDocument|string
 * @deprecated
 */
function questform_actionbutton($name, $text, $confirmquestion, $urovne)
{
  global $xmlform;

  if ( $xmlform -> readOnly ) return '';

  // konverze z utf-8 (interne pouzivano v xml) do windows-1250
  $confirmquestion = \Ron\StringUtils::fromUTF8($confirmquestion);
  $text = \Ron\StringUtils::fromUTF8($text);
  
  $name = $xmlform -> nahradPromenne($name, false);
  $text = $xmlform -> nahradPromenne($text, false);

  if ($urovne)
  {
    // jsou zadane urovne predavani, na kterych je akce zobrazena - zkontroluje, jestli je v nich aktualni uroven
    if ( $urovne != '#all' )  // #all = akce je povolena vzdy
      if ( strripos(';'.$urovne.';', ';'.$xmlform -> kodUrovne.';') === false ) return '';
        // pozor! strripos muze vracet 0 - proto musi byt pouzzit operator ===
  }
  else
  {
    // urovne nejsou zadane - pokud neni na posledni urovni predavani, akce neni povolena
    if ($xmlform -> viceSekci) return ''; // dokument jeste neni vyplnen, akce se nezobrazi

    if ( \RonPortal\UrovenPredavani::existujeVyssiUrovenPredavani($xmlform ->database,
            $xmlform -> predavaciProces, $xmlform -> pocatecniUroven,
            $xmlform -> poradiPredavani ) ) return '';
  }

  $onclickstr = "XMLAction(this, '$confirmquestion', '$name')";

  return questform_xmlresult(
      '<INPUT type="button" class="XSL-button" OnClick="'.$onclickstr.'" value="'.$text.'" />',
      false
    );

  //return questform_button($text, $confirmquestion, "?menuid=xmlaction&amp;name=$name");
}



/**
 * vraci true pokud se ma provest zadana akce
 * @param $name
 * @return bool
 * @deprecated
 */
function questform_action($name)
{
  global $xmlform;
  
  if ( $xmlform -> isError() ) return false;
  /*
  if ( !isset($_POST['xmlaction']) ) return false;
  
  return $_POST['xmlaction'] == $name;
  */
   return $xmlform -> xmlAction == $name;
}

/**
 * volano pri show - vraci true, pokud formular pouziva post (nastava u nevyplnovacich formularu)
 * @param $name
 * @return bool
 * @deprecated
 */
function questform_action_show($name)
{
    global $xmlform;

    if ( $xmlform -> isError() ) return false;
    if (!$xmlform ->usePostValues) return false;
    /*
    if ( !isset($_POST['xmlaction']) ) return false;

    return $_POST['xmlaction'] == $name;
    */
    return $xmlform -> xmlAction == $name;
}


/**
 * vraci true, pokud je aktualni menuid = $name (napr. test jestli je to "ulozxmlformular")
 * @return mixed
 * @deprecated
 */
function questform_menuid()
{
   return ( $_GET['menuid'] );
}


/**
 * nastavi "pokracovani" formulare - pokud je $value = 1, tak se formular po ulozeni
 * nezavre, ale znovu se zobrazi
 * @param $value
 * @return string
 * @deprecated
 */
function questform_pokracovat($value)
{
  global $xmlform;
  $xmlform -> pokracovat = (int)$value;

  return '';
}


/**
 * nastavi stav aktualniho formulare
 * @param $novystav
 * @return string
 * @deprecated
 */
function questform_nastavstav($novystav)
{
  global $xmlform;
  $xmlform -> stav = (int)$novystav;

  return '';
}


/**
 * smazani formulare z databaze
 * v pripade uspechu zobrazi zadanou zpravu
 * @param $okinfomsg
 * @return string
 * @deprecated
 */
function questform_delete($okinfomsg)
{
  global $xmlform;

  $okinfomsg = \Ron\StringUtils::fromUTF8($okinfomsg);
  $xmlform ->delete($okinfomsg);

  return '';
}


/**
 * spusteni skriptu - vraci true/false
 * pokud je zadano jmeno promenne ($variableName), tak nastavi podle vysledku
 * tuto promennou na hodnotu 0 (doslo k chybe) nebo 1 (probehlo v poradku)
 * @param $scriptcategory
 * @param $scriptname
 * @param $parameter
 * @param $variablename
 * @return string
 * @deprecated
 */
function questform_script($scriptcategory, $scriptname, $parameter, $variablename)
{
    global $xmlform;

    $scriptcategory = \Ron\StringUtils::fromUTF8($scriptcategory);
    $scriptname = \Ron\StringUtils::fromUTF8($scriptname);

    $parameter = \Ron\StringUtils::fromUTF8($parameter);
    $parameter = $xmlform->nahradPromenne($parameter, false); // sqlFormatovani = false

    try {
        \RonPortal\System\AgentManager::executeScript($scriptcategory, $scriptname, $parameter);
        $hodnota = 1;
    } catch (Exception $e) {
        $hodnota = 0;
        $xmlform ->addErrorMsg($e ->getMessage());
    }

    if ($variablename) $xmlform->variables[$variablename] = $hodnota;

    return '';
}


/**
 * @param $pokracovat
 * @param $menuid
 * @return string
 * @deprecated
 */
function questform_mapovanimenu($pokracovat, $menuid)
{
    global $xmlform;

    $xmlform ->f_mapovanimenu_pokracovat = $pokracovat;
    $xmlform ->f_mapovanimenu_newmenuid = $menuid;

    return '';
}


///**
// * @param string $reportName  Jmeno reportu
// * @param string $text        Zobrazeny text
// * @param string $format      Format sestavy (pdf, xls, ods pripadne vice oddelenych strednikem)
// * @return DOMDocument|string
// * @deprecated
// */
//function questform_report($reportName, $text, $format)
//{
//    global $xmlform;
//
//    //$text = \Ron\StringUtils::fromUTF8($text);
//    $text = "-t-";
//
//    try {
//        $server = \RonPortal\System\ReportServer::createInstance();
//        $xmlform ->f_reportServer = $server;
//
//        $reportKey = trim($server ->sendRequest('PREPAREREPORT ' . \RonPortal\System\ReportServer::getReportSessionId() . "\n", true)); // jednoradkova odpoved = true
//        if ( !$reportKey ) {
//            throw new Exception('Chyba pri komunikaci s report serverem! Report server nevratil klic sestavy.');
//        }
//
//        $server ->sendMessage("REPORTNAME $reportName");
//        $server ->sendMessage('VAR LoginName=' . \RonPortal\User::getLoginName());
//
//        $format_array = $format ? explode(';', $format) : null;
//        if ($format_array  &&  sizeof($format_array) > 1) {
//            // jsou zadane formaty, napr. "pdf;xls"  nebo ";xls" (prvni se pouzije defaultni)
//            $result_str = '';
//            $text_zobrazen = false;
//            foreach ($format_array as $format_item) {
//                if ($format_item) {
//                    $result_str .= " <a class='text_link report' href='?menuid=xmlform&amp;action=report&amp;format={$format_item}&amp;reportkey={$reportKey}' target='_blank'>$format_item</a> ";
//                } else {
//                    // defaultni format
//                    $result_str .= " <a class='text_link report' href='?menuid=xmlform&amp;action=report&amp;reportkey={$reportKey}' target='_blank'>$text</a> ";
//                    $text_zobrazen = true; // text uz se dale nebude zobrazovat
//                }
//            }
//
//            return questform_xmlresult(
//                '<span class=old_xml_reportlinks">' .
//                ( $text_zobrazen ? '' : $text) .
//                $result_str .
//                "</span>\n"
//            );
//        } else {
//            // format neni zadan, nebo je zadan jenom jeden
//            $formatstr = $format ? '&amp;format=' . $format : '';
//            return questform_xmlresult("<a class='text_link report' href='?menuid=xmlform&amp;action=report{$formatstr}&amp;reportkey={$reportKey}' target='_blank'>$text</a>", false);
//        }
//
//    } catch (Exception $e) {
//        $xmlform ->addErrorMsg($e ->getMessage());
//        return '';
//    }
//}
//
//
///**
// * @return string
// * @deprecated
// */
//function questform_reportend()
//{
//    global $xmlform;
//
//    try {
//        if (!$xmlform ->f_reportServer) {
//            throw new Exception('Chyba ve funkci questform_reportvariable - neni vytvoreno spojeni na report server!');
//        }
//
//        $xmlform ->f_reportServer ->sendMessage("EXIT\n");
//
//        $xmlform ->f_reportServer ->close();
//        $xmlform ->f_reportServer = null;
//    } catch (Exception $e) {
//        $xmlform ->addErrorMsg($e ->getMessage());
//    }
//
//    return '';
//}
//
//
///**
// * @param $name
// * @param $format
// * @param $value
// * @return string
// * @deprecated
// */
//function questform_reportvariable($name, $format, $value)
//{
//    global $xmlform;
//
//    try {
//        if (!$xmlform ->f_reportServer) {
//            throw new Exception('Chyba ve funkci questform_reportvariable - neni vytvoreno spojeni na report server!');
//        }
//
//        $value = $xmlform ->nahradPromenne(\Ron\StringUtils::fromUTF8($value), false);
//
//        if ($format == 'timestamp') $pomstr = 'DATEVAR ' . $name . '=' . date('j.n.Y H:i:s', $value);
//        else $pomstr = 'VAR ' . $name . '=' . $value;
//
//        $xmlform ->f_reportServer ->sendMessage($pomstr);
//    } catch (Exception $e) {
//        $xmlform ->addErrorMsg($e ->getMessage());
//    }
//
//    return '';
//}

