<?php
/**
 * Created by PhpStorm.
 * User: pavel.rudol
 * Date: 2.1.2017
 * Time: 13:01
 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;

return [
    'caption' => 'nastaveni_agent_ads',
    'category' => 'nastaveni_sekce_terminaly',
    'name'  => 'agent_ads',
    'index' => 920,
    'storage' => 'nastaveni',
    'strings' => 'preferences_agent.ini',
    'items' =>
        [
            // agent host
            [
                'name'  => 'ads_agenthost', 'type'  => Preference::TEXT,    'title' => 'Agent_host',
                'defaultValue' => '',
                'infoText' => 'Agent_host_info'
            ],
            // agent port
            [
                'name'  => 'ads_agentport', 'type'  => Preference::TEXT,    'title' => 'Agent_port',
                'defaultValue' => ''
            ],
            // agent cesta
            [
                'name'  => 'cestakdochazce', 'type'  => Preference::TEXT,    'title' => 'Agent_cesta',
                'defaultValue' => ''
            ],

            // spolecne pro vsechny agenty
            [
                'type'  => Preference::CATEGORY,    'title' => 'Agent_spolecne_nastaveni'
            ],
            // parametry agentu
            [
                'name'  => 'agent_params', 'type'  => Preference::TEXT,    'title' => 'Agent_default_params',
                'defaultValue' => '-lang:%LANG% -alwaysLog'
            ],

        ]
];
