<?php

/* 
 * Pavel Rudol, RON Software
 *  12.11.2015
 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;

return [
    'caption' => 'nastaveni_terminalu',
    'category' => 'nastaveni_sekce_terminaly',
    'name'  => 'terminaly',
    'index' => 900,
    'storage' => 'nastaveni',
    'strings' => 'terminaly.ini',

    'items' =>
        [
            // maximalni doba po kterou se bude kontrolovat stav terminalu po spusteni agenta
            [
                'name'  => 'terminal_max_interval', 'type'  => Preference::TEXT,    'title' => 'terminal_max_interval',
                'infoText' => 'terminal_max_interval_info', 'defaultValue' => '15'
            ],
            
            // interval v kterem se bude kontrolovat stav terminalu po spusteni agenta
            [
                'name'  => 'terminal_delka_intervalu', 'type'  => Preference::TEXT,    'title' => 'terminal_delka_intervalu',
                'infoText' => 'terminal_delka_intervalu_info', 'defaultValue' => '5'
            ],
        ]
];