<?php
/** Roman.Szablatura RON Software 2.2.2018 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;

return [
    'caption' => 'nastaveni_zaznamusnimacu',
    'category' => 'nastaveni_sekce_terminaly',
    'name'  => 'zaznamysnimacu',
    'index' => 901,
    'storage' => 'nastaveni',
    'strings' => 'preferences_zaznamysnimacu.ini',
    'items' =>
        [
            [
                'type' => Preference::INFO_TEXT,  'title' => 'Nastaveni lze provest v XML formulari "config_browserzaznamysnimacu".'
            ],
//            [
//                'type'  => Preference::CATEGORY,    'title' => 'zobrazeni_sloupcu'
//            ],

            [  // zruseno - lze vypnout v XML
                'name'  => 'zaznamysnimacu_zobrazitdatumnastupu',    'type'  => Preference::DELETE,
                'title' => 'zobrazit_datum_nastupu',  'defaultValue' => 0, 'infoText' => '&nbsp'
            ],

            [  // zruseno - lze vypnout v XML
                'name'  => 'zaznamysnimacu_zobrazitzpusobvlozeni',    'type'  => Preference::DELETE,
                'title' => 'zobrazit_zpusob_vlozeni',    'defaultValue' => 0, 'infoText' => '&nbsp'
            ],

//            [
//                'type'  => Preference::CATEGORY,    'title' => 'doba_aktualizace_stranky'
//            ],
            [
                'name'  => 'zaznamysnimacu_dobaaktualizacestranky',    'type'  => Preference::DELETE,
                'title' => 'doba_aktualizace', 'infoText' => 'doba_aktualizace_stranky_info', 'defaultValue' => '60'
            ],

//            [
//                'type'  => Preference::CATEGORY,    'title' => 'filtr_na_umisteni'
//            ],

            [   // zruseno - lze vypnout v XML
                'name'  => 'zaznamysnimacu_zobrazitumisteni',    'type'  => Preference::DELETE,
                'title' => 'zobrazit_umisteni', 'defaultValue' => 0, 'infoText' => '&nbsp'
            ],
        ]
];