<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\DB;

/**
 * Parametry se vkladaji primo do SQL dotazu (pro drivery, ktere neumi parametry, pripadne pro testovaci ucely)
 */
class AdHocParameters extends Parameters
{
    public function addParameter($value)
    {
        //$this ->data[] = $value;
        if (!isset($value)) {
            return 'null';
        }

        if ($value instanceof AdHocParameter) {
            return $value ->sqlValue;
        }

        if (is_string($value)) {
            return "'" . $this ->database ->addSlashes($value) . "'";
        }

        return $value;
    }

    public function getSqlParameters()
    {
        //return $this ->data;
        return null;
    }


    public function appendParameters($params)
    {
        // nedela nic - parametry byly vlozeny primo do SQL dotazu
        return $this;
    }


    public function newInstance()
    {
        return new self($this ->database);
    }


    public function getLogText()
    {
        return '';
    }
}
