<?php

namespace RonPortal\Controls;

use Ron\DB\Database;
use Ron\DB\SqlStatement;

/**
 * Rozhrani definuje tridu, ktera sestavuje SQL dotaz pro nacteni podrobnosti
 */
interface PodrobnostiDnuSqlBuilder
{
    /***
     * Sestavi SQL dotaz pro nacteni podrobnosti ke dnum
     * @param Database $database
     * @return SqlStatement|string|null
     */
    public function getSqlPodrobnostiDnu(Database $database);
}
