<?php

namespace RonPortal\Controls;

use Ron\Controls\FormField;
use RonPortal\User;

/**
 * Pole pro vlozeni RC aktualniho uzivatele
 * Class UserRCField
 * @package Ron\RonPortal
 */
class UserRCFormField extends FormField
{
    function __construct($fieldName)
    {
        parent::__construct(FormField::FIELD_TYPE_CONSTANT);

        $this->sqlFieldName = $fieldName;   // jmeno pole v databazi
        $this->maxLength = 15;

        $this->defaultValue = User::getRC();
    }
}
