<?php

namespace RonPortal\Hodnoceni;

use Ron\Http\Csrf;
use RonPortal\Testy\Dotaznik;
use RonPortal\Testy\DotaznikViewObject;

class HodnoceniViewObject extends DotaznikViewObject
{
    public function __construct(Dotaznik $dotaznik, $editace, $postValues)
    {
        parent::__construct($dotaznik, $editace, $postValues);
        $this ->setFormAction("?menuid=hodnoceni&record={$dotaznik->fId}");
    }


    public function renderHiddenFields()
    {
        if ($this ->editace) {
            $action = 'ulozdotaznik';
        } else if ($this->dotaznik ->jeEditovatelnyStav()) {
            $action = 'uzavridotaznik';
        } else {
            $action = '';
        }

        echo Csrf::csrfHiddenInput('hodnoceni_' . $this ->dotaznik ->fId);

        echo "<INPUT type='hidden' name='hodnoceniaction' value='$action'>\n";
    }


    protected function zobrazTlacitka()
    {
        echo "<div class='buttons'>";
        if ($this ->dotaznik instanceof Hodnoceni) {
            echo $this ->dotaznik ->vratHTMLTlacitka($this ->editace);
        }
        echo "</div>";
    }


//    public function render()
//    {
//        //$formAction = $this->dotaznik ->vratAkciDotazniku();
//
//        echo "<FORM name='dotaznik' class='inputform' method='post' action='{$this ->formAction}'>\n";
//
//        $this ->renderHiddenFields();
//
//        if ($this->dotaznik ->fXMLSablona) {
//            $this->dotaznik ->zobrazDotaznikXML($this ->editace, $this ->postValues);
//        } else {
//            $this->dotaznik ->zobrazHlavicku();
//
//            $this->dotaznik ->zobrazObsahDotazniku($this ->editace, $this ->oznacitSpravneOdpovedi);
//        }
//
//        echo "</FORM>\n";
//    }
}
