<?php

/**
 * Dialog pro zadani parametru delene smeny pri jejim planovani
 */

namespace RonPortal\Kapacity;

use Ron\Controls\Dialog;
use Ron\Controls\DialogButton;
use Ron\MVC\Renderer;
use Ron\MVC\TextViewObject;
use Ron\TextManager;

$renderer = new Renderer(null);
$renderer ->start();

?>
    <input type='hidden' id='planovani_delena_kodsmeny' name='planovani_delena_kodsmeny' value='' />

    <div class="container-fluid" id='kapacity_delenadata'>
        <div class="row mb-3">
            <div class="col-4 align-right col-form-label"><label for="planovani_delena_smena_pocatek"><?= TextManager::_('Delena_smena_od') ?></label></div>
            <div class="col-2 p-0"><input id='planovani_delena_smena_pocatek' class="form-control inputTime dialog-default-focus" type="text" name="delenasmena_pocatek" maxlength="5" size="5" value="" /></div>

            <div class="col-4 align-right col-form-label"><label for="planovani_delena_smena_konec"><?= TextManager::_('Delena_smena_do') ?></label></div>
            <div class="col-2 p-0"><input id='planovani_delena_smena_konec' class="form-control inputTime" type="text" name="delenasmena_konec" maxlength="5" size="5" value="" /></div>
        </div>

        <div class="row">
            <div class="col-4 align-right caption col-form-label"><label for="planovani_delena_smena_preruseni_od"><?= TextManager::_('Delena_preruseni_od') ?></label></div>
            <div class="col-2 p-0"><input id='planovani_delena_smena_preruseni_od' class="form-control inputTime" type="text" name="delenasmena_preruseniod" maxlength="5" size="5" value="" /></div>

            <div class="col-4 align-right caption col-form-label"><label for="planovani_delena_smena_preruseni_do"><?= TextManager::_('Delena_preruseni_do') ?></label></div>
            <div class="col-2 p-0"><input id='planovani_delena_smena_preruseni_do' class="form-control inputTime" type="text" name="delenasmena_prerusenido" maxlength="5" size="5" value="" /></div>
        </div>
    </div>
<?php
    $dialogContent =  $renderer ->stop();

    (new Dialog())
        ->setView(new TextViewObject($dialogContent, null, null))
        ->setId('kapacity_delena')
        ->setTitle('Delena_smena')
        //->addDialogClass('modal-lg')
        ->addButton(
            (new DialogButton())
                ->setValue('OK')
                ->setId('planovani_delena_ok')
        )
        ->addButton(DialogButton::cancelButton('planovani_delena_storno'))
        ->render();
