<?php
/**
 * stanislav.elbl, 24.05.2021 13:46
 */

namespace RonPortal\XML\Classes;

use RonPortal\System\TaskManager;
use RonPortal\XML\XMLFormElementCommand;

class XMLElementAgentStatus extends XMLFormElementCommand
{
    public function doCommand()
    {
        $result = null;
        $task = TaskManager::getInststance()->findTask($this->nahradPromenne($this->getAttributeValue('id')));
        TaskManager::getInststance()->updateTask($task);

//        if ($task  &&  $task ->isRunning) {
//            $manager = new AgentManager();
//            $result = $manager->getTaskStatus($task);
//        }

        $variableName = $this->nahradPromenne($this->getAttributeValue('variablename'));

        if ($variableName) {
            if ($task) {
                $this->setVariableValue($variableName, $task->progressMessage, 'progressMessage');
                $this->setVariableValue($variableName, $task->isRunning ? '1' : '0', 'isRunning');
                $this->setVariableValue($variableName, $task->errorMessage, 'errorMessage');
                $this->setVariableValue($variableName, $task->id, 'taskId');

//                if ($result) {
//                    $this->setVariableValue($variablename, $result->resultCode, 'resultCode');
//                    $this->setVariableValue($variablename, $result->finalMessage, 'finalMessage');
//                    $this->setVariableValue($variablename, $result->logText, 'logText');
//                }
            } else {
                $this->setVariableValue($variableName, '0', 'isRunning');
            }
        }
    }
}
