

var dane = {};

var davkynz = {};

(function () {


     var kontrolaVyplneniUdajuJinehoPoplatnika = function () {

        $("form").submit(function (e) {
            var vyzivujeJinyPoplatnik = $('#vyzivujeJinyPoplatnik');
            var jinyPoplatnikZamestnani = $('#jinyPoplatnikZamestnani');

            if($(vyzivujeJinyPoplatnik).find(":selected").val() == 1) {
                var cssAdresaPoplatnika = $('.adresa-poplatnika');
                var adresaNastavena = true;

                cssAdresaPoplatnika.each(function () {
                    $(this).removeClass("app_input_error");

                    if ($(this).val() == "") {
                        adresaNastavena = false;
                        $(this).addClass("app_input_error");
                    }
                });

                if(adresaNastavena){
                    cssAdresaPoplatnika.each(function () {
                        $(this).removeClass("app_input_error");
                    });
                }

                if (!adresaNastavena) {
                    ron.showError(ron.translate('Mzdy_prohlaseni_vyplnte_adresu_poplatnika'));
                    e.preventDefault();
                }
            }

            if($(jinyPoplatnikZamestnani).find(":selected").val() == 1 && $(vyzivujeJinyPoplatnik).find(":selected").val() == 1) {
                var zamestnavatelUdaje = $('.zamestnavatel-udaje');
                var zamestnavatelUdajeNastaveny = true;

                zamestnavatelUdaje.each(function () {
                    $(this).removeClass("app_input_error");

                    if ($(this).val() == "") {
                        zamestnavatelUdajeNastaveny = false;
                        $(this).addClass("app_input_error");
                    }
                });

                if(zamestnavatelUdajeNastaveny){
                    zamestnavatelUdaje.each(function () {
                        $(this).removeClass("app_input_error");
                    });
                }

                if (!zamestnavatelUdajeNastaveny) {
                    ron.showError(ron.translate('Mzdy_prohlaseni_vyplnte_adresu_poplatnika'));
                    e.preventDefault();
                }
            }
        });
    };

     var prevenceOdeslaniFormularePomociEnter = function(){
        $("form").keydown(function(event){
            if(event.keyCode == 13) {
              event.preventDefault();
              return false;
            }
        });
     };


      var prevenceOdeslaniFormularePokudJeNastavenaChyba = function(){
        $("form[name='formularzadosti'], form[name='formularProhlaseni']").submit(function (e) {
            var prvekSChybou = $(".app_input_error:first");

            if($(prvekSChybou).length  > 0)
            {
                if($(prvekSChybou).val() != "")
                {
                    var body = $("html, body");
                    body.stop().animate({scrollTop: $(prvekSChybou).offset().top - 50}, 900);
                    setTimeout(function () {
                        alert(ron.translate('zadost_na_formulari_jsou_chyby'));
                    }, 1000);

                    e.preventDefault();
                }
            }
        });
     };


     var kontrolaPoliDatumuOdDo = function()
     {
        var chyba = false;
        $(".filter-zadosti-od-do").blur(function ()
        {
            if($(this).val() != "") {
                var mesic = $(this).val().split("-");
                var mesicOd = parseInt(mesic[0]);
                var mesicDo = parseInt(mesic[1]);
                var overeniDatumu = new RegExp("^(0?[1-9]|1[012])$");
                var jeCislo = $.isNumeric(mesicDo);

                if ( (mesicDo >= mesicOd) && jeCislo && ((overeniDatumu.test((mesicOd).toString())) && (overeniDatumu.test((mesicDo).toString()))) ) {
                    $(this).removeClass("app_input_error");
                    $(this).val(mesicOd + "-" + mesicDo);
                    chyba = false;
                } else {
                    $(this).addClass("app_input_error");
                    chyba = true;
                }
            } else {
                $(this).removeClass("app_input_error");
                    chyba = false;
            }
        });

        if(chyba){
            ron.showError(ron.translate(''));
        }

        return chyba;
     };



     var kontrolaSlevyNaPartnera = function ()
     {
        var slevanapartneraproztp = $('#slevanapartneraproztp');
        var slevanapartnera = $('#slevanapartnera');

        $(slevanapartneraproztp).keypress(function(e) {
            if($(slevanapartnera).val() === ""){
                e.preventDefault();
            }
        });
        $(slevanapartnera).blur(function () {
            if($(slevanapartnera).val() === ""){
                $(slevanapartneraproztp).val("");
            }

            kontrolaSlevyNaPartneraZtp();
        });

        $(slevanapartneraproztp).blur(function () {
            kontrolaSlevyNaPartneraZtp();
        });
     };



     var kontrolaSlevyNaPartneraZtp = function(){
        var slevanapartneraproztp = $('#slevanapartneraproztp');
        var slevanapartnera = $('#slevanapartnera');

        var testOk = true;
        var mesicZTP = $(slevanapartneraproztp).val().split("-");
        var mesicZTPOd = parseInt(mesicZTP[0]);
        var mesicZTPDo = parseInt(mesicZTP[1]);

        var mesicNaroku = $(slevanapartnera).val().split("-");
        var mesicNarokuOd = parseInt(mesicNaroku[0]);
        var mesicNarokuDo = parseInt(mesicNaroku[1]);


        if($(slevanapartnera).val() !== ""){
            if($(slevanapartneraproztp).val() !== "") {
                if (!((mesicNarokuOd <= mesicZTPOd) && (mesicZTPDo <= mesicNarokuDo))) {
                    testOk = false;
                    ron.showError(ron.translate('zadost_rozsah_mesicu_naroku'));
                }
            }
        }


        if(testOk){
            $(slevanapartneraproztp).removeClass("app_input_error");
        } else {
            $(slevanapartneraproztp).addClass("app_input_error");
        }
     };
    dane.showDoplnujiciInfo = function () {
        ron.showMessage(
            {
                title: ron._("Info"),
                content: $($(this).data('selector')).html()
            });
    };
    dane.doplnujiciInfo = function () {
        var text;
        $('.dane_info').each(function () {
            text = $($(this).data('selector')).text().toString();
            text = text.replace(/\n\s+/g, '\n');
            text.trim();
            $(this).prop('title', text);
        });
    };
    dane.dokumentDialog = function () {
        var $dialog = $("#novydokument");

        var $linkButton = $(this);
        var inputName = $linkButton.data('input-name');
        var strArray = inputName.split("-");
        var origName = strArray[0];
        var newName = origName;
        var index = 1;
        var $inputParent = $('#input-file');
        var $originalParent = $("#" + origName);
        var $input = $("[name='" + inputName + "']");

        if ($input.val()) {

            if (strArray[1] !== undefined) {
                index = parseInt(strArray[1]);
            }
            index++;
            newName = origName + '-' + index;
            $input = $('<input type="file" name="' + newName + '">');
        }

        $inputParent.html($input);

        $('#vlozitDokumentBtn').on('click', function () {
            if (index > 1) {
                if (index == 2) {
                    $originalParent.append($('<input type="hidden" name="' + origName + '_pocet" value="' + index + '">'));
                } else {
                    $('[name="' + origName + '_pocet"]').val(index);
                }
            }
            $linkButton.data('input-name', newName);
            $originalParent.append($input);
            $dialog.dialog('close');
        });

        $dialog
            .dialog({
                modal: true,
                resizable: false,
                width: "auto",
                height: "auto"
            });

        return false;
    };
    dane.pridatDokument = function () {
        var $linkButton = $(this);
        var inputName = $linkButton.data('input-name');
        var $pocet = $("[name='" + inputName + "_pocet']");
        var index = ron.utils.stringToFloat($pocet.val());

        var $originalParent = $("#" + inputName);
        var suffix = '';
        if (index > 1) {
            suffix = "-" + index;
        }
        var $input = $("[name='" + inputName + suffix +"']");

        if ($input.val()) {
            index++;
            var newName = inputName + '-' + index;
            $input = $('<br/><input type="file" name="' + newName + '">');
            $originalParent.append($input);
            $pocet.val(index);
        }

        return false;
    };
    dane.slevaNaDite = function () {
        let uplatnujeSlevu = false,
            $vyzivujeDalsiPoplatnik = $('[name="vyzivujeJinyPoplatnik"]'),
            $cbUpravaPoradi = $('#pozaduji_upravu_poradi_ditete');

        if ($(this).hasClass('daneToggleDisabled') && $cbUpravaPoradi.prop('checked')) { //neprovadet, u toggle disabled se nejdrive nastavi selecty s poradim deti a nasledne se tato funkce vola znovu
            return;
        }

        $('.danovezvyhodneniporadiditete').each(function (key) {
            if ($cbUpravaPoradi.prop('checked')) {
               if ($(this).find(':selected').val() != 0) {
                    uplatnujeSlevu = true;
                }
            } else {
                if ($('[name="poradi_ditete_aktualne_'+ key + '"]').val() != 0) {
                    uplatnujeSlevu = true;
                }
            }
        });

        if ($cbUpravaPoradi.length > 0) {
            if (!uplatnujeSlevu) {
                $vyzivujeDalsiPoplatnik.val(0).prop('disbabled', true);
                $('.jiny-poplatnik').prop('disabled', true);
            } else if ($vyzivujeDalsiPoplatnik.val() == 1) {
                $('.jiny-poplatnik').prop('disabled', false);
            }

            $vyzivujeDalsiPoplatnik.prop('disabled', !uplatnujeSlevu);
        }
    }
    dane.bytovePotreby = function () {
        var uplatnujeOdecet = ron.utils.stringToFloat($('[name="zadosturokyvyse"]').val()) > 0;

        $('.bytove_potreby').prop('disabled', !uplatnujeOdecet);
    }
    dane.kontrolaOdeslaniProhlaseni = function (event) {
        let zakladniSlevaDB = $('[name="zakladni_odpocet_zobrazeni"]').find(':selected').val() == 1,
            zakladniSlevaZmena = ($('[name="sleva_zakladni_nova"]').find(':selected').val() == 1);

        if (!dane.kontrolaPoradiDitete()) {
            event.preventDefault();
        }

        if (($('[name="prohlasenikdanicinim"]').val() == 1) && (($('#pozaduji_upravu_slev').prop('checked') && !zakladniSlevaZmena) || (!$('#pozaduji_upravu_slev').prop('checked') && !zakladniSlevaDB))) {
            if (!ron.confirm(ron.translate('prohlaseni_chybi_zakladni_sleva'))) {
                event.preventDefault();
            }
        }
    }
    dane.kontrolaOdeslaniZadosti = function (event) {
        let uplatnujeOdecet = $('[name="zadosturokyzadam"]').find(':selected').val() == 1,
            jinaOsoba = $('[name="bytovepotrebyuplatnuje"]').find(':selected').val() == 1;

        if (uplatnujeOdecet) {
            if (($('#zadostbytovepotrebyuveruadresa').val() == '') || (($('[name="zadostbytovepotrebypred2021"]').find(':selected').val() == 0) && ($('[name="zadostbytovepotrebypo2021"]').find(':selected').val() == 0))) {
                if (($('#zadostbytovepotrebyuveruadresa').val() == '')) {
                    ron.showError(ron.translate('zadost_chybi_adresa'));
                }
                if ((($('[name="zadostbytovepotrebypred2021"]').find(':selected').val() == 0) && ($('[name="zadostbytovepotrebypo2021"]').find(':selected').val() == 0))) {
                    ron.showError(ron.translate('zadost_chybi_rok_uveru'));
                }

                event.preventDefault();
            }
            if (jinaOsoba && (($('[name="jinaosobauplatnujeodpocetjmeno_0"]').val() == '') && ($('[name="jinaosobauplatnujeodpocetprijmeni_0"]').val() == '') && ($('[name="jinaosobauplatnujeodpocetrc_0"]').val() == '') && ($('[name="jinaosobauplatnujeodpocetadresa_0"]').val() == '') )) {
                ron.showError(ron.translate('zadost_chybi_jina_osoba'));
                event.preventDefault();
            }
        }
    }

    dane.jinyPoplatnikVyzivuje = function () {
        let vyzivujeDalsiPoplatnik = $('[name="vyzivujeJinyPoplatnik"]').val() == 1,
            $jinyPoplatnik = $('.jiny-poplatnik');

        if (vyzivujeDalsiPoplatnik) {
            $jinyPoplatnik.filter('input').each(function () {
                let $this = $(this);
                if ($this.val() === '' && ($this.data('poplatnik-hidden') !== undefined)) {
                    $this.val($this.data('poplatnik-hidden'));
                }
            });
        }
    }

    dane.toggleDisabled = function () {
        let $this = $(this),
            $elem = $($this.data('selector'));
        if (this.tagName.toLowerCase() == 'input') {
            $elem.prop('disabled', ($this.is(':checked') === false));
        } else if (this.tagName.toLowerCase() == 'select') {
            $elem.prop('disabled', $this.val() != 1);
        }
        $elem.each(function () {
            let $this = $(this);
            if ($this.data('old-value-selector') !== undefined) {
                $this.val($("[name='" + $this.data('old-value-selector') + "']").val());
            }
        })
        if (this.id == 'pozaduji_upravu_poradi_ditete') {
            dane.slevaNaDite();
        }
    }

    dane.selectAll = function () {
        let $this = $(this),
            $cb = $this.parents('.col').find('input.mesic');

        $cb.prop('checked', $this.prop('checked'));
    }
    
    dane.kontrolaPoradiDitete = function () {
        let poradi = [],
            chyba = false;
        poradi[1] = 0;
        poradi[2] = 0;
        $('.danovezvyhodneniporadiditete').removeClass('.error').each(function () {
            let $this = $(this);
            poradi[$this.val()] = poradi[$this.val()]+1;
        });
        for (let i = 1; i <= 2; i++) {
            if (poradi[i] > 1) {
                $('.danovezvyhodneniporadiditete').each(function () {
                    let $this = $(this);
                    if ($this.val() == i) {
                        $this.addClass('error');
                        chyba = true;
                    }
                });
            }
        }

        return !chyba;
    }

    dane.odecitatelnePolozky = function () {
        let $this = $(this);

        if (ron.utils.stringToFloat($this.val()) > 0) {
            $($this.data('selector')).val(1).not('.inactive').prop('disabled',false);
        } else {
            $($this.data('selector')).val(0);
        }
    }

    dane.pouzitAktualniAdresu = function(){
        $(this).html($("#adresabytovepotrebyuveru").val());
    }

    dane.kontrolaSouctuOdectu = function () {
        let $this = $(this),
            limit = $('.kontrola-souctu[data-soucet-max]').data('soucet-max'),
            soucet = new Number();

        $('.kontrola-souctu').each(function () {
            let $this = $(this);
            soucet += ron.utils.stringToFloat($this.val());
        });

        $this.removeClass('error');
        if (soucet > limit) {
            $this.addClass('error');
            ron.showError(ron.translate('zadost_prekrocen_limit_odectu'));
        }
    }

    davkynz.selectDruhDavky = function () {
        $('#davkynz-druhdavky')
            .prop('disabled', !($('#davkynz-cislodokladu').val() == '' || $('#davkynz-zahranicni').prop('checked') /* ePodani neni editovatelne na portalu || $('#davkynz-epodani').prop('checked') == false*/))
            .find('option[value="1"], option[value="3"]').toggle($('#davkynz-zahranicni').prop('checked') == true); //pokud je zvoleno zahranicni, jsou viditelne vsechnz druhy davek, jinak jen kody 5 a 6
    }
    davkynz.zadaniSkoly = function () {
        let $duvod = $('#davkynz-duvodosetrovani'),
            povinnaSkola = ($duvod.val() == 3 || $duvod.data('duvodpece') == 3);
        $('#davkynz-row-nazevzarizeni, #davkynz-row-iczarizeni').toggleClass('d-none', !povinnaSkola); //zobrazit jen pokud je uzavrena skola
    }
    davkynz.pecovalTerminy = function () {
        $('#davkynz-row-pecovaloddo').toggle($('#davkynz-pecovalceloudobu').prop('checked') == false); //zobrazit jen pokud neni zatrzeno pecoval celou dobu
    }

    davkynz.nactiOsobyDoFormulare = function() {
        let vynulujSelect = function(select) {
            $(select).find('option').remove();
        };
        let zobrazData = function(data) {
            let selectOsoby = $('#davkynz-osetrovanaosoba');

            if (!data  || data.members === undefined || data.members.length === 0) {
                vynulujSelect(selectOsoby);
                return;
            }

            vynulujSelect(selectOsoby);

            $.each(data.members, function(key, value) {
                $(selectOsoby)
                    .append($('<option>', {value : value.kod})
                        .text(value.popis));
            });
        };

        let $this = $(this),
            url = '?menuid=davkynz&action=clenoverodiny&osoba=' + $this.val();

        if (url) {
            $.ajax(url)
                .done(function (data) {
                    ron.debugLog("Nacteny data osob. ", data);

                    if (data.result === "error") {
                        vynulujSelect($('#davkynz-osetrovanaosoba'));
                        ron.showError(data);
                    } else {
                        zobrazData(data);
                    }

                }).fail(function (jqXHR) {
                    vynulujSelect($('#davkynz-osetrovanaosoba'));
                    ron.showAjaxError(jqXHR, "Pri nacitani clenu rodiny doslo k chybe!");
            });
        }
    }

    davkynz.vlozNovouOsobu = function() {
        $('.novyprislusnik').toggleClass('d-none', $('#davkynz-osetrovanaosoba').val() !== 'NEW');
    };

    $(function () {
        kontrolaVyplneniUdajuJinehoPoplatnika();
        prevenceOdeslaniFormularePomociEnter();
        kontrolaPoliDatumuOdDo();
        kontrolaSlevyNaPartnera();
        prevenceOdeslaniFormularePokudJeNastavenaChyba();

        $(document.body)
            .on('click', '.dane_info', dane.showDoplnujiciInfo)
            .on('click', '.show-dokument-input-dialog', dane.dokumentDialog)
            .on('click', '.add-dokument-input', dane.pridatDokument)
            .on('change', '.danovezvyhodneniporadiditete, #pozaduji_upravu_poradi_ditete', dane.slevaNaDite)
            .on('change', '[name="zadosturokyvyse"]', dane.bytovePotreby)
            .on('change', '[name="vyzivujeJinyPoplatnik"]', dane.jinyPoplatnikVyzivuje)
            .on('change', '.daneToggleDisabled', dane.toggleDisabled)
            .on('change', '.odecitatelne-polozky', dane.odecitatelnePolozky)
            .on('dblclick', '#zadostbytovepotrebyuveruadresa', dane.pouzitAktualniAdresu)
            .on('change', '.dane_vsechny_mesice', dane.selectAll)
            .on('change', '.kontrola-souctu', dane.kontrolaSouctuOdectu)

            .on('change', '.davkynz-vyberdavky, #davkynz-epodani, #davkynz-zahranicni', davkynz.selectDruhDavky)
            .on('change', '#davkynz-duvodosetrovani', davkynz.zadaniSkoly)
            .on('change', '#davkynz-osobadavky', davkynz.nactiOsobyDoFormulare)
            .on('change', '#davkynz-pecovalceloudobu', davkynz.pecovalTerminy)
            .on('change', '#davkynz-osetrovanaosoba', davkynz.vlozNovouOsobu);
        dane.doplnujiciInfo();
        dane.slevaNaDite();
        dane.jinyPoplatnikVyzivuje();
        davkynz.zadaniSkoly();
        davkynz.selectDruhDavky();
        davkynz.pecovalTerminy();
        davkynz.vlozNovouOsobu();

        $('form[name="formularProhlaseni"]')
            .submit(dane.kontrolaOdeslaniProhlaseni);
        $('form[name="formularzadosti"]')
            .submit(dane.kontrolaOdeslaniZadosti);
    })
})();